VehicleInspector = {};

VehicleInspector.modDir = g_currentModDirectory;
VehicleInspector.settingsDir = getUserProfileAppPath().. "modSettings/VehicleInspector/";

VehicleInspector.metadata = {
	interface = " FS22 ...",
	title = "VehicleInspector",
	notes = " Zeigt/Ändert Vehicle Informationen/Bestände und vieles mehr in einem Hud an",
	author = " (by HappyLooser)",
	version = " v1.96 Beta",
	datum = " 05.11.2016",
	update = " 25.02.2023",
	web = " http://modhoster.de",
	info = " Link Freigabe,Änderungen,Kopien oder Code Benutzung ist ohne meine Zustimmung nicht erlaubt",
	"##Orginal Link Freigabe: http://modhoster.de"
};

function VehicleInspector:loadMap(name)
	g_currentMission.vehicleInspector = VehicleInspector;	
	print("---loading ".. tostring(VehicleInspector.metadata.title).. tostring(VehicleInspector.metadata.version).. tostring(VehicleInspector.metadata.author).. "---")
	if VehicleInspector:getServer() then return;end;
	g_currentMission.vehicleInspector = self;
	VehicleInspector.hlDebugMode = false;
	loadScripts(1);	
	VehicleInspector.overlays = {};
	VehicleInspector.storeOverlays = {};
	VehicleInspector.categoryOverlays = {};
	VehicleInspector.fillTypeOverlays = {};
	VehicleInspector.clickAreas = {master={}, slave={}};
	loadScripts(2);
	VehicleInspector.previewVehicleData = {};
	VehicleInspector.previewVehicleFillTypes = {};
	VehicleInspector.helpMenu = nil;
	VehicleInspector.inGameMapMenu = nil;
	VehicleInspector.isVisible = false;
	VehicleInspector.output = {};
	viSetGetOverlays:loadOverlays();
	VehicleInspector:loadSettings();
	viSetGet:generateVehicleCategories();
	Mission00.onStartMission = Utils.appendedFunction(Mission00.onStartMission, VehicleInspector.onStartMission);
end;

function VehicleInspector:onStartMission()	
	if not VehicleInspector:getServer() then 
		VehicleInspector:searchOtherMods();
		viHlGui:generate(false);
		viSetGet:getInGameDisplay();
		viSetGet:speedMeterDisplay();
		viSetGet:vehicleShowInfo();
		if VehicleInspector.global.foundMoh then 
			viSetGetForMoh:loadPdaIcons();viSetGetForMoh:loadCmds();viSetGetForMoh:generateVehicleInspectorSlot();
		else
			VehicleInspector.seeTxt.cpRemaining.mohVisible = true;VehicleInspector.seeTxt.adRemaining.mohVisible = true;
		end;
		VehicleInspector:registerActionEventsPlayer();
		FSBaseMission.registerActionEvents = Utils.appendedFunction(FSBaseMission.registerActionEvents, VehicleInspector.registerActionEventsPlayer);
		viSetGetOverlays:loadIconFillTypes();
		viSetGet:deleteGhostVehicleCategorySettingLine();
		
	end;
end;	

function VehicleInspector:registerActionEventsPlayer()    
   	local isOkay, eventName = InputBinding.registerActionEvent(g_inputBinding, 'VIOnOffMouseCursor', self, VehicleInspector.actionKeyMouse ,false ,true ,false ,true);
    if isOkay then if g_currentMission.hl.controlMod == "VehicleInspector" then	g_inputBinding.events[eventName].displayIsVisible = false;else g_inputBinding:removeActionEvent(eventName);end;end;	
	isOkay, eventName = InputBinding.registerActionEvent(g_inputBinding, 'VIViewContractorVehicle', self, VehicleInspector.actionKeyMouse ,false ,true ,false ,true);
	if isOkay then g_inputBinding.events[eventName].displayIsVisible = false;end;
	isOkay, eventName = InputBinding.registerActionEvent(g_inputBinding, 'VIViewForce', self, VehicleInspector.actionKeyMouse ,false ,true ,false ,true);
	if isOkay then g_inputBinding.events[eventName].displayIsVisible = false;end;
end;

function VehicleInspector:actionKeyMouse(actionName, keyStatus, arg4, arg5, arg6)	
	if not g_currentMission.hl.dragDrop.on then
		if not VehicleInspector.global.isOn and actionName == "VIOnOffMouseCursor" then 
			viMouseKeyEvents:setKey(unicode, sym, modifier, isDownKey, true, true); 
		elseif actionName == "VIOnOffMouseCursor" then
			viMouseKeyEvents:setKey(unicode, sym, modifier, isDownKey, false, true);	
		elseif VehicleInspector.global.isOn and actionName == "VIViewContractorVehicle" then
			viMouseKeyEvents:setKey(unicode, sym, modifier, isDownKey, false, false, "VIViewContractorVehicle");
		elseif VehicleInspector.global.isOn and actionName == "VIViewForce" then
			viMouseKeyEvents:setKey(unicode, sym, modifier, isDownKey, false, false, "VIViewForce");
		end;
	end;
end;

function VehicleInspector:deleteMap()
	if VehicleInspector:getServer() then return;end;
	VehicleInspector:saveSettings();VehicleInspector:get_hl("deleteOverlays", {VehicleInspector.overlays}, "deleteOverlays");VehicleInspector:get_hl("deleteOverlays", {VehicleInspector.storeOverlays}, "deleteOverlays");VehicleInspector:get_hl("deleteOverlays", {VehicleInspector.categoryOverlays}, "deleteOverlays");VehicleInspector:get_hl("deleteOverlays", {VehicleInspector.fillTypeOverlays}, "deleteOverlays");
end;

function VehicleInspector:mouseEvent(posX, posY, isDown, isUp, button)
	if VehicleInspector:getServer() or VehicleInspector:get_hl("getIngameMap", {}, "getIngameMap") or VehicleInspector:get_hl("getFullSize", {true, true}, "getFullSize") then return;end;
	if VehicleInspector.global.isOn then viMouseKeyEvents:setKeyMouse(nil, nil, nil, nil, posX, posY, isDown, isUp, button);end;
end;

function VehicleInspector:keyEvent(unicode, sym, modifier, isDown)
	if VehicleInspector:getServer() or VehicleInspector:get_hl("getIngameMap", {}, "getIngameMap") or VehicleInspector:get_hl("getFullSize", {true, true}, "getFullSize") then return;end;
	if VehicleInspector.global.isOn then viMouseKeyEvents:setKeyMouse(unicode, sym, modifier, isDown, nil, nil, nil, nil, nil);end;
end;

function VehicleInspector:update(dt)
	if VehicleInspector:getServer() or VehicleInspector:get_hl("getIngameMap", {}, "getIngameMap") or VehicleInspector:get_hl("getFullSize", {true, true}, "getFullSize") then return;end;
	if VehicleInspector.global.previewVehicleData.canLoadedFillTypes and (g_currentMission.player.hudUpdater == nil or not g_currentMission.player.hudUpdater.isVehicle) then VehicleInspector.previewVehicleFillTypes = {};end;
	g_currentMission.hl.update_timers(dt, "VehicleInspector");
	g_currentMission.hl.updateRunMsg(dt, "VehicleInspector");
	if g_currentMission.hl.isMouseCursor then g_currentMission.hl.mouseOnOff(true,true, "VehicleInspector");else VehicleInspector.previewVehicleData = {};end;
end;

function VehicleInspector:draw(dt)
	if VehicleInspector:getServer() or VehicleInspector:get_hl("getIngameMap", {}, "getIngameMap") or VehicleInspector:get_hl("getFullSize", {true, true}, "getFullSize") then return;end;
	VehicleInspector:get_hl("drawRunMsg", {"VehicleInspector"}, "VehicleInspector:draw");
	
	--respect settings for other mods (not every mod) that's why
	setTextAlignment(0);
	setTextLineBounds(0, 0);
	setTextWrapWidth(0);
	setTextColor(1, 1, 1, 1);
	setTextBold(false);
	--respect settings for other mods
	
	if VehicleInspector.global.isOn then
		if VehicleInspector.global.iconDisplay.isOn then
			viDrawIcons:setOpen();
		else
			viDraw:setOpen();
		end;
		if g_currentMission.hl.isMouseCursor and VehicleInspector.global.previewVehicleData.isOn and #VehicleInspector.previewVehicleData > 0 then viDrawPreviewVehicleData:setOpen(VehicleInspector.previewVehicleData[1]);end;
	end;
	if VehicleInspector.global.viewWorkingWidth.isOn then viDraw:setOpenWidth();end;
	if VehicleInspector.global.viewUnloadSide.isOn then viDraw:setOpenTipSide();end;
	if VehicleInspector.global.viewAttachedDamage.isOn then viDraw:setAttachedDamage();end;
	if VehicleInspector.global.previewVehicleData.canLoadedFillTypes and #VehicleInspector.previewVehicleFillTypes > 0 then viDrawPreviewVehicleData:setFillTypesShowInfo();end;
	
	if #VehicleInspector.global.testNumber > 0 then		 
		setTextBold(true);
		for a=1, #VehicleInspector.gobal.testNumber do		
			local posY = 50+a+1/100;
			renderText(0.1, posY, 0.010, "-N ".. tostring(a).. "- ".. tostring(VehicleInspector.global.testNumber[a]));
		end;
	end;	
	if #VehicleInspector.global.testString > 0 then
		setTextBold(true);		
		for a=1, #VehicleInspector.global.testString do
			local posY = 0.55-(a/100);
			renderText(0.5, posY, 0.010, "-S ".. tostring(a).. "- ".. tostring(VehicleInspector.global.testString[a]));
		end;
	end;
	
	--respect settings for other mods
	setTextAlignment(0);
	setTextLineBounds(0, 0);
	setTextWrapWidth(0);
	setTextColor(1, 1, 1, 1);
	setTextBold(false);
	--respect settings for other mods
end;	
	
function VehicleInspector:getServer()
	return g_server ~= nil and g_client ~= nil and g_dedicatedServer ~= nil;
end;

function VehicleInspector:saveSettings()
	viSetGetSettingsXml:saveConfig();	
end;

function VehicleInspector:loadSettings()
	viSetGetSettingsXml:loadConfig();	
end;

function VehicleInspector:searchOtherMods()	
	local env = getfenv(0);		
	if env["MultiOverlayV4"] ~= nil and env["MultiOverlayV4"]["MultiOverlayV4"] ~= nil then
		VehicleInspector.moh = env["MultiOverlayV4"];		
	end;
	VehicleInspector.otherMods = {};
	if env["FS22_guidanceSteering"] ~= nil and env["FS22_guidanceSteering"]["GuidanceSteering"] ~= nil then
		VehicleInspector.otherMods.gps = true;			
	end;
	if env["FS22_park_vehicle"] ~= nil and env["FS22_park_vehicle"]["ParkVehicle"] ~= nil then
		VehicleInspector.otherMods.parkVehicle = true;			
	end;
	if env["FS22_AutoDrive"] ~= nil and env["FS22_AutoDrive"]["AutoDrive"] ~= nil then
		VehicleInspector.otherMods.autoDrive = env["FS22_AutoDrive"];
	end;
	if env["FS22_Courseplay"] ~= nil and env["FS22_Courseplay"]["Courseplay"] ~= nil then
		VehicleInspector.otherMods.courseplay = env["FS22_Courseplay"]; 
	end;
	if g_currentMission.multiOverlayV4 ~= nil then VehicleInspector.global.foundMoh = true;end;
end;

function VehicleInspector:getPosition()
	local posY = VehicleInspector.global.posY[VehicleInspector.global.viewModus];
	local posX = VehicleInspector.global.posX[VehicleInspector.global.viewModus];
	local width = VehicleInspector.global.width[VehicleInspector.global.viewModus];
	local height = VehicleInspector.global.height[VehicleInspector.global.viewModus];
	return {height=height,width=width,x=posX,y=posY,toLarge=VehicleInspector:getVisible() and VehicleInspector.global.toLarge};
end;

function VehicleInspector:getVisible()
	return VehicleInspector.isVisible and VehicleInspector.global.isOn;
end;	

function loadScripts(int)
	if int == 1 then
		source(VehicleInspector.modDir.."_hl.lua");
		source(VehicleInspector.modDir.."defaultSettings/viLoadTables.lua");
		source(VehicleInspector.modDir.."defaultSettings/viSetGetSettingsXml.lua");		
	end;
	if int == 2 then
		source(VehicleInspector.modDir.."scripte/overlays/viSetGetOverlays.lua");
		source(VehicleInspector.modDir.."scripte/mouseKeyEvents/viMouseKeyEvents.lua");
		source(VehicleInspector.modDir.."scripte/hlGui/viHlGui.lua");
		source(VehicleInspector.modDir.."scripte/viSetGet.lua");
		source(VehicleInspector.modDir.."scripte/draw/viDraw.lua");		
		source(VehicleInspector.modDir.."scripte/mohFeatures/viVehicleMohOutput.lua");
		source(VehicleInspector.modDir.."scripte/mohFeatures/viSetGetForMoh.lua");
		source(VehicleInspector.modDir.."scripte/viOutput.lua");
	end;
end;

--_hl Freeware ls17,19,22--
function VehicleInspector:get_hl(args, argsTable, errorTxtCall) --args hl table, argsTable a table with all args Values, errorTxt a Value for debug print
	local isOkay, result, argsError, errorTxt = nil,nil,nil,errorTxtCall;
	if VehicleInspector.hlDebugMode and (errorTxtCall == nil or type(errorTxtCall) ~= "string" or string.len(errorTxtCall) == 0) then errorTxt = "Unknown";end;
	local foundArgsError = false;
	if type(argsTable) == "table" and g_currentMission.hl[args] ~= nil then	
		isOkay, result = pcall(g_currentMission.hl[args], unpack(argsTable));
	else
		foundArgsError = true;
	end;
	if VehicleInspector.hlDebugMode and foundArgsError then isOkay=false;argsError="Unknown args or argsTable or argsTable = 0";end;		
	if VehicleInspector.hlDebugMode and (not isOkay or foundArgsError) then g_currentMission.hl.setDebug("VehicleInspectorMod", args or "Unknown", errorTxt, argsError or "No args error", result or "NO result error");end;
	return result, isOkay;	
end;
--_hl Freeware ls17,19,22--
addModEventListener(VehicleInspector);