viSetGetSettingsXml = {};

function viSetGetSettingsXml:reloadConfig() --Gui Menue Callback
	createFolder(getUserProfileAppPath().. "modSettings/");
	createFolder(VehicleInspector.settingsDir);
	local file = VehicleInspector.settingsDir.. "vehicleInspectorSettings.xml";	
	if fileExists(file) then
		local Xml = loadXMLFile("VehicleInspector_XML", file, "vehicleInspectorSettings");
		viSetGetSettingsXml:loadSearchInvertConfig(Xml);
		--txt--
		viSetGetSettingsXml:loadTxtConfig(Xml);
		--txt--
		--showColor--
		viSetGetSettingsXml:loadShowColorConfig(Xml);
		--showColor--
	end;
end;

function viSetGetSettingsXml:loadConfig()
	createFolder(getUserProfileAppPath().. "modSettings/");
	createFolder(VehicleInspector.settingsDir);
	local file = VehicleInspector.settingsDir.. "vehicleInspectorSettings.xml";
	local oldXml = false;
	viSetGetSettingsXml:cloneDefaultColor();
	if not fileExists(file) then
		viSetGetSettingsXml:saveConfig();
	else
		local Xml = loadXMLFile("VehicleInspector_XML", file, "vehicleInspectorSettings");
		local groupNameTag = ("vehicleInspectorSettings.simple.version(%d)"):format(0);
		--if getXMLString(Xml, groupNameTag.. "#xmlVersion") then viSetGetSettingsXml:saveConfig();viSetGetSettingsXml:cloneDefaultColor();return;end;
		groupNameTag = ("vehicleInspectorSettings.global(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#isOn") ~= nil then VehicleInspector.global.isOn = getXMLBool(Xml, groupNameTag.. "#isOn");end;
		--if getXMLBool(Xml, groupNameTag.. "#hlDebugMode") ~= nil then VehicleInspector.hlDebugMode = getXMLBool(Xml, groupNameTag.. "#hlDebugMode");end;
		viSetGetSettingsXml:loadSearchInvertConfig(Xml);
		groupNameTag = ("vehicleInspectorSettings.global.otherValues.joinVehicles(%d)"):format(0);
		if getXMLInt(Xml, groupNameTag.. "#int") ~= nil then VehicleInspector.global.joinVehicles = getXMLInt(Xml, groupNameTag.. "#int");end;		
		groupNameTag = ("vehicleInspectorSettings.global.otherValues.attachedLimit(%d)"):format(0);
		if getXMLInt(Xml, groupNameTag.. "#int") ~= nil then VehicleInspector.global.attachedLimit = getXMLInt(Xml, groupNameTag.. "#int");end;		
		groupNameTag = ("vehicleInspectorSettings.global.otherValues.autoMouseOffJoinVehicle(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.global.autoMouseOffJoinVehicle = getXMLBool(Xml, groupNameTag.. "#boolean");end;		
		groupNameTag = ("vehicleInspectorSettings.global.otherValues.viewBackground(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.global.seeBackground = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.global.otherValues.backgroundTransparents(%d)"):format(0);
		if getXMLFloat(Xml, groupNameTag.. "#float") then VehicleInspector.global.backgroundT = getXMLFloat(Xml, groupNameTag.. "#float");end;		
		groupNameTag = ("vehicleInspectorSettings.global.otherValues.viewPlayerOnTop(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.global.seePlayerOnTop = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.global.otherValues.viewHelperOnTop(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.global.seeHelperOnTop = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		
		groupNameTag = ("vehicleInspectorSettings.global.otherValues.viewWorkingWidth(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.global.viewWorkingWidth.isOn = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.global.otherValues.viewWorkingWidthSizeC(%d)"):format(0);
		if getXMLInt(Xml, groupNameTag.. "#int") ~= nil then VehicleInspector.global.viewWorkingWidth.cSize = getXMLInt(Xml, groupNameTag.. "#int");end;		
		groupNameTag = ("vehicleInspectorSettings.global.otherValues.viewWorkingWidthState(%d)"):format(0);
		if getXMLInt(Xml, groupNameTag.. "#int") ~= nil then VehicleInspector.global.viewWorkingWidth.state = getXMLInt(Xml, groupNameTag.. "#int");end;
		
		groupNameTag = ("vehicleInspectorSettings.global.otherValues.viewAttachedDamage(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.global.viewAttachedDamage.isOn = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.global.otherValues.viewAttachedDamageSizeC(%d)"):format(0);
		if getXMLInt(Xml, groupNameTag.. "#int") ~= nil then VehicleInspector.global.viewAttachedDamage.cSize = getXMLInt(Xml, groupNameTag.. "#int");end;		
		groupNameTag = ("vehicleInspectorSettings.global.otherValues.viewAttachedDamageState(%d)"):format(0);
		if getXMLInt(Xml, groupNameTag.. "#int") ~= nil then VehicleInspector.global.viewAttachedDamage.state = getXMLInt(Xml, groupNameTag.. "#int");end;
		
		groupNameTag = ("vehicleInspectorSettings.global.otherValues.viewUnloadSide(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.global.viewUnloadSide.isOn = getXMLBool(Xml, groupNameTag.. "#boolean");end;		
		groupNameTag = ("vehicleInspectorSettings.global.otherValues.viewUnloadSideSizeC(%d)"):format(0);
		if getXMLInt(Xml, groupNameTag.. "#int") ~= nil then VehicleInspector.global.viewUnloadSide.cSize = getXMLInt(Xml, groupNameTag.. "#int");end;		
		groupNameTag = ("vehicleInspectorSettings.global.otherValues.viewUnloadSideState(%d)"):format(0);
		if getXMLInt(Xml, groupNameTag.. "#int") ~= nil then VehicleInspector.global.viewUnloadSide.state = getXMLInt(Xml, groupNameTag.. "#int");end;
		groupNameTag = ("vehicleInspectorSettings.global.otherValues.viewUnloadSidePos(%d)"):format(0);
		if getXMLInt(Xml, groupNameTag.. "#int") ~= nil then VehicleInspector.global.viewUnloadSide.pos = getXMLInt(Xml, groupNameTag.. "#int");end;
		groupNameTag = ("vehicleInspectorSettings.global.otherValues.sortBy(%d)"):format(0);
		if getXMLInt(Xml, groupNameTag.. "#int") ~= nil then VehicleInspector.global.sortBy = getXMLInt(Xml, groupNameTag.. "#int");end;
		groupNameTag = ("vehicleInspectorSettings.global.otherValues.settingLineState(%d)"):format(0);
		if getXMLInt(Xml, groupNameTag.. "#int") ~= nil then VehicleInspector.global.settingLineState = getXMLInt(Xml, groupNameTag.. "#int");end;
		groupNameTag = ("vehicleInspectorSettings.global.otherValues.viewIconDisplay(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.global.iconDisplay.isOn = getXMLBool(Xml, groupNameTag.. "#boolean");end;	
		groupNameTag = ("vehicleInspectorSettings.global.otherValues.isHidden(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.global.isHidden = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.global.otherValues.previewVehicleData(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.global.previewVehicleData.isOn = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.global.otherValues.previewCanLoadedFillTypes(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.global.previewVehicleData.canLoadedFillTypes = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.global.otherValues.iconWidescreenFix(%d)"):format(0);
		if getXMLFloat(Xml, groupNameTag.. "#float") then VehicleInspector.global.iconWidescreenFix = getXMLFloat(Xml, groupNameTag.. "#float");end;		
		groupNameTag = ("vehicleInspectorSettings.global.otherValues.helperJobEndTimeBlinkingSec(%d)"):format(0);
		if getXMLInt(Xml, groupNameTag.. "#int") ~= nil then VehicleInspector.global.helperJobEndTimeBlinking = getXMLInt(Xml, groupNameTag.. "#int");end;
		--showDraw--
		--iconDisplay--		
		groupNameTag = ("vehicleInspectorSettings.global.iconDisplayValues.vehicleIcon(%d)"):format(0);
		if getXMLInt(Xml, groupNameTag.. "#int") ~= nil then VehicleInspector.global.iconDisplay.vehicleIcon = getXMLInt(Xml, groupNameTag.. "#int");end;
		groupNameTag = ("vehicleInspectorSettings.global.iconDisplayValues.attachedIcon(%d)"):format(0);
		if getXMLInt(Xml, groupNameTag.. "#int") ~= nil then VehicleInspector.global.iconDisplay.attachedIcon = getXMLInt(Xml, groupNameTag.. "#int");end;
		groupNameTag = ("vehicleInspectorSettings.global.iconDisplayValues.fillIcon(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.global.iconDisplay.fillIcon = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		viSetGetSettingsXml:loadSetMasterOrderConfig(Xml);
		viSetGetSettingsXml:loadSetOrderVehicleConfig(Xml);
		viSetGetSettingsXml:loadSetOrderFillLevelInformationConfig(Xml);
		--iconDisplay--
		--groupNameTag = ("vehicleInspectorSettings.global.showVI.onlyOverMultiOverlayHud(%d)"):format(0);
		--if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.global.onlyMoh = getXMLBool(Xml, groupNameTag.. "#boolean");end;		
		groupNameTag = ("vehicleInspectorSettings.global.showVI.helpMenuOn_F1(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.showDraw.helpMenuOn = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.global.showVI.helpMenuOff_F1(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.showDraw.helpMenuOff = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.global.showVI.inGameMapOn(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.showDraw.inGameMapOn = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.global.showVI.inGameMapOff(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.showDraw.inGameMapOff = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		--showDraw--
		--seeWarning--
		groupNameTag = ("vehicleInspectorSettings.viewWarning.isBlocking(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.seeWarning.isBlocking = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.viewWarning.isWater(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.seeWarning.isWater = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.viewWarning.isDamage(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.seeWarning.isDamage = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.viewWarning.damageProzent(%d)"):format(0);
		if getXMLInt(Xml, groupNameTag.. "#int") ~= nil then VehicleInspector.seeWarning.damageProzent = getXMLInt(Xml, groupNameTag.. "#int");end;
		groupNameTag = ("vehicleInspectorSettings.viewWarning.isFuelEmpty(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.seeWarning.isFuelEmpty = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.viewWarning.fuelProzent(%d)"):format(0);
		if getXMLInt(Xml, groupNameTag.. "#int") ~= nil then VehicleInspector.seeWarning.fuelProzent = getXMLInt(Xml, groupNameTag.. "#int");end;
		--seeWarning--
		--seeVehicle--
		groupNameTag = ("vehicleInspectorSettings.viewVehicle.onlyControlled(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.seeVehicle.onlyControlled = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.viewVehicle.notFillLevel(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.seeVehicle.notFillLevel = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.viewVehicle.notAttached(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.seeVehicle.notAttached = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.viewVehicle.isTrain(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.seeVehicle.isTrain = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.viewVehicle.isHelper(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.seeVehicle.isHelper = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.viewVehicle.isPlayer(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.seeVehicle.isPlayer = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.viewVehicle.isHorsePlayer(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.seeVehicle.isHorsePlayer = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.viewVehicle.isLeasing(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.seeVehicle.isLeasing = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.viewVehicle.isGps(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.seeVehicle.isGps = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.viewVehicle.isParking(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.seeVehicle.isParking = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.viewVehicle.isOwnFarmVehicle(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.seeVehicle.isOwnFarmVehicle = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		
		groupNameTag = ("vehicleInspectorSettings.viewVehicle.train(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.seeVehicle.train = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.viewVehicle.tractor(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.seeVehicle.tractor = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.viewVehicle.harvester(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.seeVehicle.harvester = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.viewVehicle.truck(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.seeVehicle.truck = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.viewVehicle.car(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.seeVehicle.car = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.viewVehicle.other(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.seeVehicle.other = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.viewVehicle.teleloader(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.seeVehicle.teleloader = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.viewVehicle.tool(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.seeVehicle.tool = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.viewVehicle.trailer(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.seeVehicle.trailer = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		--seeVehicle--
		--seeTxt--
		groupNameTag = ("vehicleInspectorSettings.viewText.playerName(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.seeTxt.playerName = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.viewText.helperName(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.seeTxt.helperName = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.viewText.speed(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.seeTxt.speed = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.viewText.field(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.seeTxt.field = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.viewText.fieldNumber(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.seeTxt.fieldNumber = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.viewText.fieldNumberMP(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.global.seeFieldNumberMP = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.viewText.fillProzent(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.seeTxt.fillProzent = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.viewText.fillLevel(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.seeTxt.fillLevel = getXMLBool(Xml, groupNameTag.. "#boolean");end;		
		groupNameTag = ("vehicleInspectorSettings.viewText.jobTypeTxt(%d)"):format(0);
		if getXMLInt(Xml, groupNameTag.. "#int") ~= nil then VehicleInspector.seeTxt.jobTypeTxt = getXMLInt(Xml, groupNameTag.. "#int");end;		
		groupNameTag = ("vehicleInspectorSettings.viewText.leasing(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.seeTxt.leasing = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.viewText.gps(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.seeTxt.gps = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.viewText.parking(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.seeTxt.parking = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.viewText.totalAttached(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.seeTxt.totalAttached = getXMLBool(Xml, groupNameTag.. "#boolean");end;		
		groupNameTag = ("vehicleInspectorSettings.viewText.vehicleName(%d)"):format(0);
		if getXMLInt(Xml, groupNameTag.. "#int") then VehicleInspector.seeTxt.vehicleName = getXMLInt(Xml, groupNameTag.. "#int");end;
		if VehicleInspector.seeTxt.vehicleName > 3 or VehicleInspector.seeTxt.vehicleName < 0 then VehicleInspector.seeTxt.vehicleName = 2;end;
		groupNameTag = ("vehicleInspectorSettings.viewText.fillName(%d)"):format(0);
		if getXMLInt(Xml, groupNameTag.. "#int") then VehicleInspector.seeTxt.fillName = getXMLInt(Xml, groupNameTag.. "#int");end;
		if VehicleInspector.seeTxt.fillName > 2 or VehicleInspector.seeTxt.fillName < 0 then VehicleInspector.seeTxt.fillName = 1;end;		
		groupNameTag = ("vehicleInspectorSettings.viewText.horse(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.seeTxt.horse = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.viewText.fillObject(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.seeTxt.fillObject = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.viewText.overload(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.seeTxt.overload = getXMLBool(Xml, groupNameTag.. "#boolean");end;		
		
		groupNameTag = ("vehicleInspectorSettings.viewText.cpRemainingState(%d)"):format(0);
		if getXMLInt(Xml, groupNameTag.. "#int") then VehicleInspector.seeTxt.cpRemaining.state = getXMLInt(Xml, groupNameTag.. "#int");end;
		if VehicleInspector.seeTxt.cpRemaining.state > 3 or VehicleInspector.seeTxt.cpRemaining.state < 0 then VehicleInspector.seeTxt.cpRemaining.state = 0;end;
		groupNameTag = ("vehicleInspectorSettings.viewText.cpRemainingMohVisible(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.seeTxt.cpRemaining.mohVisible = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		groupNameTag = ("vehicleInspectorSettings.viewText.adRemainingState(%d)"):format(0);
		if getXMLInt(Xml, groupNameTag.. "#int") then VehicleInspector.seeTxt.adRemaining.state = getXMLInt(Xml, groupNameTag.. "#int");end;
		if VehicleInspector.seeTxt.adRemaining.state > 3 or VehicleInspector.seeTxt.adRemaining.state < 0 then VehicleInspector.seeTxt.adRemaining.state = 0;end;
		groupNameTag = ("vehicleInspectorSettings.viewText.adRemainingMohVisible(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.seeTxt.adRemaining.mohVisible = getXMLBool(Xml, groupNameTag.. "#boolean");end;		
		--seeTxt--
		--txt--
		viSetGetSettingsXml:loadTxtConfig(Xml);
		--txt--
		--showColor--
		viSetGetSettingsXml:loadShowColorConfig(Xml);
		--showColor--
	end;	
end;

function viSetGetSettingsXml:saveConfig()
	createFolder(getUserProfileAppPath().. "modSettings/");
	createFolder(VehicleInspector.settingsDir);
	local file = VehicleInspector.settingsDir.. "vehicleInspectorSettings.xml";
	local Xml = createXMLFile("VehicleInspector_XML", file, "vehicleInspectorSettings");
	local groupNameTag = ("vehicleInspectorSettings.global(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#isOn", VehicleInspector.global.isOn);
	setXMLBool(Xml, groupNameTag.. "#hlDebugMode", VehicleInspector.hlDebugMode);
	local searchInvertTemp = ""
	for a=1, #VehicleInspector.global.searchInvert do
		if a == 1 then searchInvertTemp = tostring(VehicleInspector.global.searchInvert[a]); else searchInvertTemp = searchInvertTemp.. ",".. tostring(VehicleInspector.global.searchInvert[a]);end;
	end;	
	groupNameTag = ("vehicleInspectorSettings.global.otherValues.searchInvertColorByVehicleTypeName(%d)"):format(0);
	setXMLString(Xml, groupNameTag.. "#stringWithCommaSeparator", tostring(searchInvertTemp));
	groupNameTag = ("vehicleInspectorSettings.global.otherValues.joinVehicles(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.. "#int", VehicleInspector.global.joinVehicles);	
	groupNameTag = ("vehicleInspectorSettings.global.otherValues.attachedLimit(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.. "#int", VehicleInspector.global.attachedLimit);	
	groupNameTag = ("vehicleInspectorSettings.global.otherValues.autoMouseOffJoinVehicle(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.global.autoMouseOffJoinVehicle);	
	groupNameTag = ("vehicleInspectorSettings.global.otherValues.viewBackground(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.global.seeBackground);
	groupNameTag = ("vehicleInspectorSettings.global.otherValues.backgroundTransparents(%d)"):format(0);
	setXMLFloat(Xml, groupNameTag.. "#float", VehicleInspector.global.backgroundT);	
	groupNameTag = ("vehicleInspectorSettings.global.otherValues.viewPlayerOnTop(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.global.seePlayerOnTop);
	groupNameTag = ("vehicleInspectorSettings.global.otherValues.viewHelperOnTop(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.global.seeHelperOnTop);
	
	groupNameTag = ("vehicleInspectorSettings.global.otherValues.viewWorkingWidth(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.global.viewWorkingWidth.isOn);
	groupNameTag = ("vehicleInspectorSettings.global.otherValues.viewWorkingWidthSizeC(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.. "#int", VehicleInspector.global.viewWorkingWidth.cSize);
	groupNameTag = ("vehicleInspectorSettings.global.otherValues.viewWorkingWidthState(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.. "#int", VehicleInspector.global.viewWorkingWidth.state);
	
	groupNameTag = ("vehicleInspectorSettings.global.otherValues.viewAttachedDamage(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.global.viewAttachedDamage.isOn);
	groupNameTag = ("vehicleInspectorSettings.global.otherValues.viewAttachedDamageSizeC(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.. "#int", VehicleInspector.global.viewAttachedDamage.cSize);
	groupNameTag = ("vehicleInspectorSettings.global.otherValues.viewAttachedDamageState(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.. "#int", VehicleInspector.global.viewAttachedDamage.state);
	
	groupNameTag = ("vehicleInspectorSettings.global.otherValues.viewUnloadSide(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.global.viewUnloadSide.isOn);
	groupNameTag = ("vehicleInspectorSettings.global.otherValues.viewUnloadSideSizeC(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.. "#int", VehicleInspector.global.viewUnloadSide.cSize);
	groupNameTag = ("vehicleInspectorSettings.global.otherValues.viewUnloadSideState(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.. "#int", VehicleInspector.global.viewUnloadSide.state);
	groupNameTag = ("vehicleInspectorSettings.global.otherValues.viewUnloadSidePos(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.. "#int", VehicleInspector.global.viewUnloadSide.pos);
	groupNameTag = ("vehicleInspectorSettings.global.otherValues.sortBy(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.. "#int", VehicleInspector.global.sortBy);
	groupNameTag = ("vehicleInspectorSettings.global.otherValues.settingLineState(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.. "#int", VehicleInspector.global.settingLineState);
	groupNameTag = ("vehicleInspectorSettings.global.otherValues.viewIconDisplay(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.global.iconDisplay.isOn);
	groupNameTag = ("vehicleInspectorSettings.global.otherValues.isHidden(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.global.isHidden);
	groupNameTag = ("vehicleInspectorSettings.global.otherValues.previewVehicleData(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.global.previewVehicleData.isOn);
	groupNameTag = ("vehicleInspectorSettings.global.otherValues.previewCanLoadedFillTypes(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.global.previewVehicleData.canLoadedFillTypes);
	groupNameTag = ("vehicleInspectorSettings.global.otherValues.iconWidescreenFix(%d)"):format(0);
	setXMLFloat(Xml, groupNameTag.. "#float", VehicleInspector.global.iconWidescreenFix);	
	groupNameTag = ("vehicleInspectorSettings.global.otherValues.helperJobEndTimeBlinkingSec(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.. "#int", VehicleInspector.global.helperJobEndTimeBlinking);
	--showDraw--
	--iconDisplay--
	groupNameTag = ("vehicleInspectorSettings.global.iconDisplayValues.vehicleIcon(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.. "#int", VehicleInspector.global.iconDisplay.vehicleIcon);
	groupNameTag = ("vehicleInspectorSettings.global.iconDisplayValues.attachedIcon(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.. "#int", VehicleInspector.global.iconDisplay.attachedIcon);
	groupNameTag = ("vehicleInspectorSettings.global.iconDisplayValues.fillIcon(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolen", VehicleInspector.global.iconDisplay.fillIcon);	
	local searchOrderTemp = "";	
	for a=1, #VehicleInspector.global.iconDisplay.setOrder do
		if a == 1 then searchOrderTemp = tostring(VehicleInspector.global.iconDisplay.setOrder[a]); else searchOrderTemp = searchOrderTemp.. ",".. tostring(VehicleInspector.global.iconDisplay.setOrder[a]);end;
	end;	
	groupNameTag = ("vehicleInspectorSettings.global.iconDisplayValues.setMasterOrder(%d)"):format(0);
	setXMLString(Xml, groupNameTag.. "#stringWithCommaSeparator", tostring(searchOrderTemp));
	searchOrderTemp = "";
	for a=1, #VehicleInspector.global.iconDisplay.setOrderVehicle do
		if a == 1 then searchOrderTemp = tostring(VehicleInspector.global.iconDisplay.setOrderVehicle[a]); else searchOrderTemp = searchOrderTemp.. ",".. tostring(VehicleInspector.global.iconDisplay.setOrderVehicle[a]);end;
	end;	
	groupNameTag = ("vehicleInspectorSettings.global.iconDisplayValues.setOrderVehicle(%d)"):format(0);
	setXMLString(Xml, groupNameTag.. "#stringWithCommaSeparator", tostring(searchOrderTemp));	
	searchOrderTemp = "";
	for a=1, #VehicleInspector.global.iconDisplay.setOrderFillLevelInformation do
		if a == 1 then searchOrderTemp = tostring(VehicleInspector.global.iconDisplay.setOrderFillLevelInformation[a]); else searchOrderTemp = searchOrderTemp.. ",".. tostring(VehicleInspector.global.iconDisplay.setOrderFillLevelInformation[a]);end;
	end;	
	groupNameTag = ("vehicleInspectorSettings.global.iconDisplayValues.setOrderFillLevelInformation(%d)"):format(0);
	setXMLString(Xml, groupNameTag.. "#stringWithCommaSeparator", tostring(searchOrderTemp));	
	--iconDisplay--
	--groupNameTag = ("vehicleInspectorSettings.global.showVI.onlyOverMultiOverlayHud(%d)"):format(0);
	--setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.global.onlyMoh);
	groupNameTag = ("vehicleInspectorSettings.global.showVI.helpMenuOn_F1(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.showDraw.helpMenuOn);
	groupNameTag = ("vehicleInspectorSettings.global.showVI.helpMenuOff_F1(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.showDraw.helpMenuOff);
	groupNameTag = ("vehicleInspectorSettings.global.showVI.inGameMapOn(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.showDraw.inGameMapOn);
	groupNameTag = ("vehicleInspectorSettings.global.showVI.inGameMapOff(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.showDraw.inGameMapOff);
	--showDraw--
	--seeWarning--
	groupNameTag = ("vehicleInspectorSettings.viewWarning.isBlocking(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.seeWarning.isBlocking);
	groupNameTag = ("vehicleInspectorSettings.viewWarning.isWater(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.seeWarning.isWater);
	groupNameTag = ("vehicleInspectorSettings.viewWarning.isDamage(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.seeWarning.isDamage);
	groupNameTag = ("vehicleInspectorSettings.viewWarning.damageProzent(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.. "#int", VehicleInspector.seeWarning.damageProzent);	
	groupNameTag = ("vehicleInspectorSettings.viewWarning.isFuelEmpty(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.seeWarning.isFuelEmpty);
	groupNameTag = ("vehicleInspectorSettings.viewWarning.fuelProzent(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.. "#int", VehicleInspector.seeWarning.fuelProzent);
	--seeWarning--
	--seeVehicle--
	groupNameTag = ("vehicleInspectorSettings.viewVehicle.onlyControlled(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.seeVehicle.onlyControlled);
	groupNameTag = ("vehicleInspectorSettings.viewVehicle.notFillLevel(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.seeVehicle.notFillLevel);
	groupNameTag = ("vehicleInspectorSettings.viewVehicle.notAttached(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.seeVehicle.notAttached);
	groupNameTag = ("vehicleInspectorSettings.viewVehicle.isTrain(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.seeVehicle.isTrain);
	groupNameTag = ("vehicleInspectorSettings.viewVehicle.isHelper(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.seeVehicle.isHelper);
	groupNameTag = ("vehicleInspectorSettings.viewVehicle.isPlayer(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.seeVehicle.isPlayer);
	groupNameTag = ("vehicleInspectorSettings.viewVehicle.isHorsePlayer(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.seeVehicle.isHorsePlayer);
	groupNameTag = ("vehicleInspectorSettings.viewVehicle.isLeasing(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.seeVehicle.isLeasing);
	groupNameTag = ("vehicleInspectorSettings.viewVehicle.isGps(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.seeVehicle.isGps);
	groupNameTag = ("vehicleInspectorSettings.viewVehicle.isParking(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.seeVehicle.isParking);
	groupNameTag = ("vehicleInspectorSettings.viewVehicle.isOwnFarmVehicle(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.seeVehicle.isOwnFarmVehicle);	
	groupNameTag = ("vehicleInspectorSettings.viewVehicle.categoryTrain(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.seeVehicle.train);
	groupNameTag = ("vehicleInspectorSettings.viewVehicle.categoryTractor(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.seeVehicle.tractor);
	groupNameTag = ("vehicleInspectorSettings.viewVehicle.categoryHarvester(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.seeVehicle.harvester);
	groupNameTag = ("vehicleInspectorSettings.viewVehicle.categoryTuck(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.seeVehicle.truck);
	groupNameTag = ("vehicleInspectorSettings.viewVehicle.categoryCar(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.seeVehicle.car);
	groupNameTag = ("vehicleInspectorSettings.viewVehicle.categoryOther(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.seeVehicle.other);
	groupNameTag = ("vehicleInspectorSettings.viewVehicle.categoryTeleloader(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.seeVehicle.teleloader);
	groupNameTag = ("vehicleInspectorSettings.viewVehicle.categoryTool(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.seeVehicle.tool);
	groupNameTag = ("vehicleInspectorSettings.viewVehicle.categoryTrailer(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.seeVehicle.trailer);
	--seeVehicle--
	--seeTxt--
	groupNameTag = ("vehicleInspectorSettings.viewText.playerName(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.seeTxt.playerName);
	groupNameTag = ("vehicleInspectorSettings.viewText.helperName(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.seeTxt.helperName);
	groupNameTag = ("vehicleInspectorSettings.viewText.speed(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.seeTxt.speed);
	groupNameTag = ("vehicleInspectorSettings.viewText.field(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.seeTxt.field);
	groupNameTag = ("vehicleInspectorSettings.viewText.fieldNumber(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.seeTxt.fieldNumber);
	groupNameTag = ("vehicleInspectorSettings.viewText.fieldNumberMP(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.global.seeFieldNumberMP);
	groupNameTag = ("vehicleInspectorSettings.viewText.fillProzent(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.seeTxt.fillProzent);
	groupNameTag = ("vehicleInspectorSettings.viewText.fillLevel(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.seeTxt.fillLevel);
	
	groupNameTag = ("vehicleInspectorSettings.viewText.jobTypeTxt(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.. "#int", VehicleInspector.seeTxt.jobTypeTxt);
	
	groupNameTag = ("vehicleInspectorSettings.viewText.leasing(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.seeTxt.leasing);
	groupNameTag = ("vehicleInspectorSettings.viewText.gps(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.seeTxt.gps);
	groupNameTag = ("vehicleInspectorSettings.viewText.parking(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.seeTxt.parking);
	groupNameTag = ("vehicleInspectorSettings.viewText.totalAttached(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.seeTxt.totalAttached);	
	groupNameTag = ("vehicleInspectorSettings.viewText.vehicleName(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.. "#int", VehicleInspector.seeTxt.vehicleName);
	groupNameTag = ("vehicleInspectorSettings.viewText.fillName(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.. "#int", VehicleInspector.seeTxt.fillName);	
	groupNameTag = ("vehicleInspectorSettings.viewText.horse(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.seeTxt.horse);	
	groupNameTag = ("vehicleInspectorSettings.viewText.fillObject(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.seeTxt.fillObject);
	groupNameTag = ("vehicleInspectorSettings.viewText.overload(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.seeTxt.overload);	
	
	groupNameTag = ("vehicleInspectorSettings.viewText.cpRemainingState(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.. "#int", VehicleInspector.seeTxt.cpRemaining.state);
	groupNameTag = ("vehicleInspectorSettings.viewText.cpRemainingMohVisible(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.seeTxt.cpRemaining.mohVisible)
	groupNameTag = ("vehicleInspectorSettings.viewText.adRemainingState(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.. "#int", VehicleInspector.seeTxt.adRemaining.state);
	groupNameTag = ("vehicleInspectorSettings.viewText.adRemainingMohVisible(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.seeTxt.adRemaining.mohVisible);	
	--seeTxt--
	--txt--
	groupNameTag = ("vehicleInspectorSettings.text(%d)"):format(0);
	setXMLString(Xml, groupNameTag.. "#info", "spaces count with (Leerzeichen zählen mit)");
	groupNameTag = ("vehicleInspectorSettings.text.size(%d)"):format(0);
	setXMLFloat(Xml, groupNameTag.. "#float", VehicleInspector.global.txtSize);
	groupNameTag = ("vehicleInspectorSettings.text.bold(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.txt.bold);
	groupNameTag = ("vehicleInspectorSettings.text.color(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#boolean", VehicleInspector.txt.color);
	groupNameTag = ("vehicleInspectorSettings.text.widthDistance(%d)"):format(0);
	setXMLFloat(Xml, groupNameTag.. "#float", VehicleInspector.global.txtWidthDistance);
	groupNameTag = ("vehicleInspectorSettings.text.lineDistance(%d)"):format(0);
	setXMLFloat(Xml, groupNameTag.. "#float", VehicleInspector.global.txtLineDistance);	
	groupNameTag = ("vehicleInspectorSettings.text.playerNameLength(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.. "#int", VehicleInspector.global.playerNameLength);
	groupNameTag = ("vehicleInspectorSettings.text.vehicleNameLength(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.. "#int", VehicleInspector.global.vehicleNameLength);	
	groupNameTag = ("vehicleInspectorSettings.text.fillNameLength(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.. "#int", VehicleInspector.global.fillNameLength);
	groupNameTag = ("vehicleInspectorSettings.text.separator(%d)"):format(0);
	setXMLString(Xml, groupNameTag.. "#string", VehicleInspector.txt.separator);
	groupNameTag = ("vehicleInspectorSettings.text.ownSeparator(%d)"):format(0);
	setXMLString(Xml, groupNameTag.. "#string", VehicleInspector.txt.ownSeparator);	
	groupNameTag = ("vehicleInspectorSettings.text.fieldNumberSeparator(%d)"):format(0);
	setXMLString(Xml, groupNameTag.. "#string", VehicleInspector.txt.fieldNumberSeparator);	
	groupNameTag = ("vehicleInspectorSettings.text.speed(%d)"):format(0);
	setXMLString(Xml, groupNameTag.. "#string", VehicleInspector.txt.speed);
	groupNameTag = ("vehicleInspectorSettings.text.fillNameToFillLevel(%d)"):format(0);
	setXMLString(Xml, groupNameTag.. "#string", VehicleInspector.txt.fillNameToFillLevel);	
	groupNameTag = ("vehicleInspectorSettings.text.isField(%d)"):format(0);
	setXMLString(Xml, groupNameTag.. "#string", VehicleInspector.txt.isField);
	groupNameTag = ("vehicleInspectorSettings.text.isParking(%d)"):format(0);
	setXMLString(Xml, groupNameTag.. "#string", VehicleInspector.txt.isParking);
	groupNameTag = ("vehicleInspectorSettings.text.isHelper(%d)"):format(0);
	setXMLString(Xml, groupNameTag.. "#string", VehicleInspector.txt.isHelper);
	groupNameTag = ("vehicleInspectorSettings.text.isPlayer(%d)"):format(0);
	setXMLString(Xml, groupNameTag.. "#string", VehicleInspector.txt.isPlayer);
	groupNameTag = ("vehicleInspectorSettings.text.isSeedsEmpty(%d)"):format(0);
	setXMLString(Xml, groupNameTag.. "#string", VehicleInspector.txt.isSaEmpty);
	groupNameTag = ("vehicleInspectorSettings.text.isObject(%d)"):format(0);
	setXMLString(Xml, groupNameTag.. "#string", VehicleInspector.txt.isObject);
	groupNameTag = ("vehicleInspectorSettings.text.isSeedsOr(%d)"):format(0);
	setXMLString(Xml, groupNameTag.. "#string", VehicleInspector.txt.isSa);
	groupNameTag = ("vehicleInspectorSettings.text.isSeedsOrFill(%d)"):format(0);
	setXMLString(Xml, groupNameTag.. "#string", VehicleInspector.txt.isSaOrFill);
	groupNameTag = ("vehicleInspectorSettings.text.isWater(%d)"):format(0);
	setXMLString(Xml, groupNameTag.. "#string", VehicleInspector.txt.isWater);
	groupNameTag = ("vehicleInspectorSettings.text.isDamage(%d)"):format(0);
	setXMLString(Xml, groupNameTag.. "#string", VehicleInspector.txt.isDamage);
	groupNameTag = ("vehicleInspectorSettings.text.isBlocking(%d)"):format(0);
	setXMLString(Xml, groupNameTag.. "#string", VehicleInspector.txt.isBlocking);
	groupNameTag = ("vehicleInspectorSettings.text.isFuelEmpty(%d)"):format(0);
	setXMLString(Xml, groupNameTag.. "#string", VehicleInspector.txt.isFuelEmpty);
	groupNameTag = ("vehicleInspectorSettings.text.isFillLevelFull(%d)"):format(0);
	setXMLString(Xml, groupNameTag.. "#string", VehicleInspector.txt.isFillLevelFull);
	groupNameTag = ("vehicleInspectorSettings.text.isLeasing(%d)"):format(0);
	setXMLString(Xml, groupNameTag.. "#string", VehicleInspector.txt.isLeasing);
	groupNameTag = ("vehicleInspectorSettings.text.isGps(%d)"):format(0);
	setXMLString(Xml, groupNameTag.. "#string", VehicleInspector.txt.isGps);
	groupNameTag = ("vehicleInspectorSettings.text.isOverload(%d)"):format(0);
	setXMLString(Xml, groupNameTag.. "#string", VehicleInspector.txt.isOverload);	
	groupNameTag = ("vehicleInspectorSettings.text.remainingTimeSeparator(%d)"):format(0);
	setXMLString(Xml, groupNameTag.. "#string", VehicleInspector.txt.remainingTimeSeparator);
	groupNameTag = ("vehicleInspectorSettings.text.remainingWaypoints(%d)"):format(0);
	setXMLString(Xml, groupNameTag.. "#string", VehicleInspector.txt.remainingWaypoints);
	groupNameTag = ("vehicleInspectorSettings.text.remainingTimeWaypointsSeparator(%d)"):format(0);
	setXMLString(Xml, groupNameTag.. "#string", VehicleInspector.txt.remainingTimeWaypointsSeparator);
	--txt--
	--showColor--
	local colorTable = VehicleInspector.showColor;
	if not VehicleInspector.txt.color then colorTable = VehicleInspector.showColorXml;end;
	groupNameTag = ("vehicleInspectorSettings.color.background(%d)"):format(0);
	setXMLString(Xml, groupNameTag.. "#string", colorTable.background);
	groupNameTag = ("vehicleInspectorSettings.color.txt(%d)"):format(0);
	setXMLString(Xml, groupNameTag.. "#string", colorTable.txt);
	groupNameTag = ("vehicleInspectorSettings.color.playerControlled(%d)"):format(0);
	setXMLString(Xml, groupNameTag.. "#string", colorTable.playerControlled);
	groupNameTag = ("vehicleInspectorSettings.color.otherPlayerControlled(%d)"):format(0);
	setXMLString(Xml, groupNameTag.. "#string", colorTable.otherPlayerControlled);
	groupNameTag = ("vehicleInspectorSettings.color.isField(%d)"):format(0);
	setXMLString(Xml, groupNameTag.. "#string", colorTable.field);
	groupNameTag = ("vehicleInspectorSettings.color.isWater(%d)"):format(0);
	setXMLString(Xml, groupNameTag.. "#string", colorTable.water);
	groupNameTag = ("vehicleInspectorSettings.color.isDamage(%d)"):format(0);
	setXMLString(Xml, groupNameTag.. "#string", colorTable.damage);
	groupNameTag = ("vehicleInspectorSettings.color.isBlocking(%d)"):format(0);
	setXMLString(Xml, groupNameTag.. "#string", colorTable.blocking);
	groupNameTag = ("vehicleInspectorSettings.color.isLeasing(%d)"):format(0);
	setXMLString(Xml, groupNameTag.. "#string", colorTable.leasing);
	groupNameTag = ("vehicleInspectorSettings.color.isGps(%d)"):format(0);
	setXMLString(Xml, groupNameTag.. "#string", colorTable.gps);
	groupNameTag = ("vehicleInspectorSettings.color.isParking(%d)"):format(0);
	setXMLString(Xml, groupNameTag.. "#string", colorTable.parking);
	groupNameTag = ("vehicleInspectorSettings.color.isFull(%d)"):format(0);
	setXMLString(Xml, groupNameTag.. "#string", colorTable.full);
	groupNameTag = ("vehicleInspectorSettings.color.isEmpty(%d)"):format(0);
	setXMLString(Xml, groupNameTag.. "#string", colorTable.empty);
	groupNameTag = ("vehicleInspectorSettings.color.isSelected(%d)"):format(0);
	setXMLString(Xml, groupNameTag.. "#string", colorTable.selected);
	groupNameTag = ("vehicleInspectorSettings.color.remainingString(%d)"):format(0);
	setXMLString(Xml, groupNameTag.. "#string", colorTable.remainingString);
	--showColor--
	saveXMLFile(Xml);
end;

function viSetGetSettingsXml:loadSearchInvertConfig(Xml)
	local searchInvertTemp = "";		
	local groupNameTag = ("vehicleInspectorSettings.global.otherValues.searchInvertColorByVehicleTypeName(%d)"):format(0);
	if getXMLString(Xml, groupNameTag.. "#stringWithCommaSeparator") ~= nil then searchInvertTemp = getXMLString(Xml, groupNameTag.. "#stringWithCommaSeparator");end;
	local stringSplit = g_currentMission.hl.stringSplit(searchInvertTemp, ",", true);
	if stringSplit ~= nil and #stringSplit > 0 then			
		for key,value in pairs(stringSplit) do				
			if string.len(stringSplit[key]) > 1 then
				local nameExists = viSetGet:isInvertFill(tostring(string.lower(stringSplit[key])))
				if not nameExists then table.insert(VehicleInspector.global.searchInvert, tostring(string.lower(stringSplit[key])));end;
			end;
		end;			
	end;
end;

function viSetGetSettingsXml:loadSetMasterOrderConfig(Xml)
	local searchOrderTemp = "";	
	local groupNameTag = ("vehicleInspectorSettings.global.iconDisplayValues.setMasterOrder(%d)"):format(0);
	if getXMLString(Xml, groupNameTag.. "#stringWithCommaSeparator") ~= nil then searchOrderTemp = getXMLString(Xml, groupNameTag.. "#stringWithCommaSeparator");end;
	local stringSplit = g_currentMission.hl.stringSplit(searchOrderTemp, ",", true);
	if stringSplit ~= nil and #stringSplit > 0 then			
		local tempSetOrder = VehicleInspector.global.iconDisplay.setOrder;
		VehicleInspector.global.iconDisplay.setOrder = {};
		for key,value in pairs(stringSplit) do				
			if string.len(stringSplit[key]) > 1 then				
				if string.find(VehicleInspector.global.iconDisplay.comparseOrder, tostring(stringSplit[key]).. ",") then
					table.insert(VehicleInspector.global.iconDisplay.setOrder, tostring(stringSplit[key]));
					VehicleInspector.global.iconDisplay.comparseOrder = string.gsub(VehicleInspector.global.iconDisplay.comparseOrder, tostring(stringSplit[key]).. ",", "");
				end;
			end;
		end;
		if #tempSetOrder ~= #VehicleInspector.global.iconDisplay.setOrder or VehicleInspector.global.iconDisplay.comparseOrder:len() > 1 then			
			for key,value in pairs(tempSetOrder) do					
				if string.find(VehicleInspector.global.iconDisplay.comparseOrder, tostring(value).. ",") then
					table.insert(VehicleInspector.global.iconDisplay.setOrder, key, tostring(value));
					VehicleInspector.global.iconDisplay.comparseOrder = string.gsub(VehicleInspector.global.iconDisplay.comparseOrder, tostring(value).. ",", "");
				end;
				if VehicleInspector.global.iconDisplay.comparseOrder:len() <= 1 then break;end;
			end;
			tempSetOrder = nil;			
		end;
	end;
end;

function viSetGetSettingsXml:loadSetOrderVehicleConfig(Xml)
	local searchOrderTemp = "";	
	local groupNameTag = ("vehicleInspectorSettings.global.iconDisplayValues.setOrderVehicle(%d)"):format(0);
	if getXMLString(Xml, groupNameTag.. "#stringWithCommaSeparator") ~= nil then searchOrderTemp = getXMLString(Xml, groupNameTag.. "#stringWithCommaSeparator");end;
	local stringSplit = g_currentMission.hl.stringSplit(searchOrderTemp, ",", true);
	if stringSplit ~= nil and #stringSplit > 0 then			
		local tempSetOrderVehicle = VehicleInspector.global.iconDisplay.setOrderVehicle;
		VehicleInspector.global.iconDisplay.setOrderVehicle = {};
		for key,value in pairs(stringSplit) do				
			if string.len(stringSplit[key]) > 1 then				
				if string.find(VehicleInspector.global.iconDisplay.comparseOrderVehicle, tostring(stringSplit[key]).. ",") then
					table.insert(VehicleInspector.global.iconDisplay.setOrderVehicle, tostring(stringSplit[key]));
					VehicleInspector.global.iconDisplay.comparseOrderVehicle = string.gsub(VehicleInspector.global.iconDisplay.comparseOrderVehicle, tostring(stringSplit[key]).. ",", "");
				end;				
			end;
		end;
		if #tempSetOrderVehicle ~= #VehicleInspector.global.iconDisplay.setOrderVehicle or VehicleInspector.global.iconDisplay.comparseOrderVehicle:len() > 1 then						
			for key,value in pairs(tempSetOrderVehicle) do	
				if string.find(VehicleInspector.global.iconDisplay.comparseOrderVehicle, tostring(value).. ",") then
					table.insert(VehicleInspector.global.iconDisplay.setOrderVehicle, key, tostring(value));
					VehicleInspector.global.iconDisplay.comparseOrderVehicle = string.gsub(VehicleInspector.global.iconDisplay.comparseOrderVehicle, tostring(value).. ",", "");
				end;
				if VehicleInspector.global.iconDisplay.comparseOrderVehicle:len() <= 1 then break;end;				
			end;
			tempSetOrderVehicle = nil;
		end;
	end;
end;

function viSetGetSettingsXml:loadSetOrderFillLevelInformationConfig(Xml)
	local searchOrderTemp = "";	
	local groupNameTag = ("vehicleInspectorSettings.global.iconDisplayValues.setOrderFillLevelInformation(%d)"):format(0);
	if getXMLString(Xml, groupNameTag.. "#stringWithCommaSeparator") ~= nil then searchOrderTemp = getXMLString(Xml, groupNameTag.. "#stringWithCommaSeparator");end;
	local stringSplit = g_currentMission.hl.stringSplit(searchOrderTemp, ",", true);
	if stringSplit ~= nil and #stringSplit > 0 then			
		local tempSetOrderFillLevelInformation = VehicleInspector.global.iconDisplay.setOrderFillLevelInformation;
		VehicleInspector.global.iconDisplay.setOrderFillLevelInformation = {};
		for key,value in pairs(stringSplit) do				
			if string.len(stringSplit[key]) > 1 then				
				if string.find(VehicleInspector.global.iconDisplay.comparseOrderFillLevelInformation, tostring(stringSplit[key]).. ",") then
					table.insert(VehicleInspector.global.iconDisplay.setOrderFillLevelInformation, tostring(stringSplit[key]));
					VehicleInspector.global.iconDisplay.comparseOrderFillLevelInformation = string.gsub(VehicleInspector.global.iconDisplay.comparseOrderFillLevelInformation, tostring(stringSplit[key]).. ",", "");
				end;				
			end;
		end;
		if #tempSetOrderFillLevelInformation ~= #VehicleInspector.global.iconDisplay.setOrderFillLevelInformation then			
			for key,value in pairs(tempSetOrderFillLevelInformation) do	
				if string.find(VehicleInspector.global.iconDisplay.comparseOrderFillLevelInformation, tostring(value).. ",") then					
					table.insert(VehicleInspector.global.iconDisplay.setOrderFillLevelInformation, key, tostring(value));
					VehicleInspector.global.iconDisplay.comparseOrderFillLevelInformation = string.gsub(VehicleInspector.global.iconDisplay.comparseOrderFillLevelInformation, tostring(value).. ",", "");
				end;
				if VehicleInspector.global.iconDisplay.comparseOrderFillLevelInformation:len() <= 1 then break;end;				
			end;
			tempSetOrderFillLevelInformation = nil;
		end;
	end;
end;

function viSetGetSettingsXml:loadTxtConfig(Xml)
	local groupNameTag = ("vehicleInspectorSettings.text.size(%d)"):format(0);
	if getXMLFloat(Xml, groupNameTag.. "#float") then VehicleInspector.global.txtSize = getXMLFloat(Xml, groupNameTag.. "#float");end;
	groupNameTag = ("vehicleInspectorSettings.text.bold(%d)"):format(0);
	if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.txt.bold = getXMLBool(Xml, groupNameTag.. "#boolean");end;
	groupNameTag = ("vehicleInspectorSettings.text.color(%d)"):format(0);
	if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then VehicleInspector.txt.color = getXMLBool(Xml, groupNameTag.. "#boolean");end;
	groupNameTag = ("vehicleInspectorSettings.text.widthDistance(%d)"):format(0);
	if getXMLFloat(Xml, groupNameTag.. "#float") then VehicleInspector.global.txtWidthDistance = getXMLFloat(Xml, groupNameTag.. "#float");end;
	groupNameTag = ("vehicleInspectorSettings.text.lineDistance(%d)"):format(0);
	if getXMLFloat(Xml, groupNameTag.. "#float") then VehicleInspector.global.txtLineDistance = getXMLFloat(Xml, groupNameTag.. "#float");end;	
	groupNameTag = ("vehicleInspectorSettings.text.playerNameLength(%d)"):format(0);
	if getXMLInt(Xml, groupNameTag.. "#int") then VehicleInspector.global.playerNameLength = getXMLInt(Xml, groupNameTag.. "#int");end;	
	groupNameTag = ("vehicleInspectorSettings.text.vehicleNameLength(%d)"):format(0);
	if getXMLInt(Xml, groupNameTag.. "#int") then VehicleInspector.global.vehicleNameLength = getXMLInt(Xml, groupNameTag.. "#int");end;
	groupNameTag = ("vehicleInspectorSettings.text.fillNameLength(%d)"):format(0);
	if getXMLInt(Xml, groupNameTag.. "#int") then VehicleInspector.global.fillNameLength = getXMLInt(Xml, groupNameTag.. "#int");end;		
	groupNameTag = ("vehicleInspectorSettings.text.separator(%d)"):format(0);
	if getXMLString(Xml, groupNameTag.. "#string") ~= nil then VehicleInspector.txt.separator = getXMLString(Xml, groupNameTag.. "#string");end;
	groupNameTag = ("vehicleInspectorSettings.text.ownSeparator(%d)"):format(0);
	if getXMLString(Xml, groupNameTag.. "#string") ~= nil then VehicleInspector.txt.ownSeparator = getXMLString(Xml, groupNameTag.. "#string");end;		
	groupNameTag = ("vehicleInspectorSettings.text.fieldNumberSeparator(%d)"):format(0);
	if getXMLString(Xml, groupNameTag.. "#string") ~= nil then VehicleInspector.txt.fieldNumberSeparator = getXMLString(Xml, groupNameTag.. "#string");end;		
	groupNameTag = ("vehicleInspectorSettings.text.fillNameToFillLevel(%d)"):format(0);
	if getXMLString(Xml, groupNameTag.. "#string") ~= nil then VehicleInspector.txt.fillNameToFillLevel = getXMLString(Xml, groupNameTag.. "#string");end;	
	groupNameTag = ("vehicleInspectorSettings.text.speed(%d)"):format(0);
	if getXMLString(Xml, groupNameTag.. "#string") ~= nil then VehicleInspector.txt.speed = getXMLString(Xml, groupNameTag.. "#string");end;	
	groupNameTag = ("vehicleInspectorSettings.text.isField(%d)"):format(0);
	if getXMLString(Xml, groupNameTag.. "#string") ~= nil then VehicleInspector.txt.isField = getXMLString(Xml, groupNameTag.. "#string");end;
	groupNameTag = ("vehicleInspectorSettings.text.isParking(%d)"):format(0);
	if getXMLString(Xml, groupNameTag.. "#string") ~= nil then VehicleInspector.txt.isParking = getXMLString(Xml, groupNameTag.. "#string");end;
	groupNameTag = ("vehicleInspectorSettings.text.isPlayer(%d)"):format(0);
	if getXMLString(Xml, groupNameTag.. "#string") ~= nil then VehicleInspector.txt.isPlayer = getXMLString(Xml, groupNameTag.. "#string");end;
	groupNameTag = ("vehicleInspectorSettings.text.isHelper(%d)"):format(0);
	if getXMLString(Xml, groupNameTag.. "#string") ~= nil then VehicleInspector.txt.isHelper = getXMLString(Xml, groupNameTag.. "#string");end;
	groupNameTag = ("vehicleInspectorSettings.text.isSeedsEmpty(%d)"):format(0);
	if getXMLString(Xml, groupNameTag.. "#string") ~= nil then VehicleInspector.txt.isSaEmpty = getXMLString(Xml, groupNameTag.. "#string");end;
	groupNameTag = ("vehicleInspectorSettings.text.isObject(%d)"):format(0);
	if getXMLString(Xml, groupNameTag.. "#string") ~= nil then VehicleInspector.txt.isObject = getXMLString(Xml, groupNameTag.. "#string");end;
	groupNameTag = ("vehicleInspectorSettings.text.isSeedsOr(%d)"):format(0);
	if getXMLString(Xml, groupNameTag.. "#string") ~= nil then VehicleInspector.txt.isSa = getXMLString(Xml, groupNameTag.. "#string");end;
	groupNameTag = ("vehicleInspectorSettings.text.isSeedsOrFill(%d)"):format(0);
	if getXMLString(Xml, groupNameTag.. "#string") ~= nil then VehicleInspector.txt.isSaOrFill = getXMLString(Xml, groupNameTag.. "#string");end;
	groupNameTag = ("vehicleInspectorSettings.text.isWater(%d)"):format(0);
	if getXMLString(Xml, groupNameTag.. "#string") ~= nil then VehicleInspector.txt.isWater = getXMLString(Xml, groupNameTag.. "#string");end;
	groupNameTag = ("vehicleInspectorSettings.text.isDamage(%d)"):format(0);
	if getXMLString(Xml, groupNameTag.. "#string") ~= nil then VehicleInspector.txt.isDamage = getXMLString(Xml, groupNameTag.. "#string");end;
	groupNameTag = ("vehicleInspectorSettings.text.isBlocking(%d)"):format(0);
	if getXMLString(Xml, groupNameTag.. "#string") ~= nil then VehicleInspector.txt.isBlocking = getXMLString(Xml, groupNameTag.. "#string");end;
	groupNameTag = ("vehicleInspectorSettings.text.isFuelEmpty(%d)"):format(0);
	if getXMLString(Xml, groupNameTag.. "#string") ~= nil then VehicleInspector.txt.isFuelEmpty = getXMLString(Xml, groupNameTag.. "#string");end;
	groupNameTag = ("vehicleInspectorSettings.text.isFillLevelFull(%d)"):format(0);
	if getXMLString(Xml, groupNameTag.. "#string") ~= nil then VehicleInspector.txt.isFillLevelFull = getXMLString(Xml, groupNameTag.. "#string");end;
	groupNameTag = ("vehicleInspectorSettings.text.isLeasing(%d)"):format(0);
	if getXMLString(Xml, groupNameTag.. "#string") ~= nil then VehicleInspector.txt.isLeasing = getXMLString(Xml, groupNameTag.. "#string");end;
	groupNameTag = ("vehicleInspectorSettings.text.isGps(%d)"):format(0);
	if getXMLString(Xml, groupNameTag.. "#string") ~= nil then VehicleInspector.txt.isGps = getXMLString(Xml, groupNameTag.. "#string");end;
	groupNameTag = ("vehicleInspectorSettings.text.isOverload(%d)"):format(0);
	if getXMLString(Xml, groupNameTag.. "#string") ~= nil then VehicleInspector.txt.isOverload = getXMLString(Xml, groupNameTag.. "#string");end;	
	groupNameTag = ("vehicleInspectorSettings.text.remainingTimeSeparator(%d)"):format(0);
	if getXMLString(Xml, groupNameTag.. "#string") ~= nil then VehicleInspector.txt.remainingTimeSeparator = getXMLString(Xml, groupNameTag.. "#string");end;
	groupNameTag = ("vehicleInspectorSettings.text.remainingWaypoints(%d)"):format(0);
	if getXMLString(Xml, groupNameTag.. "#string") ~= nil then VehicleInspector.txt.remainingWaypoints = getXMLString(Xml, groupNameTag.. "#string");end;
	groupNameTag = ("vehicleInspectorSettings.text.remainingTimeWaypointsSeparator(%d)"):format(0);
	if getXMLString(Xml, groupNameTag.. "#string") ~= nil then VehicleInspector.txt.remainingTimeWaypointsSeparator = getXMLString(Xml, groupNameTag.. "#string");end;
end;

function viSetGetSettingsXml:loadShowColorConfig(Xml)	
	local groupNameTag = ("vehicleInspectorSettings.color.background(%d)"):format(0);
	if getXMLString(Xml, groupNameTag.. "#string") ~= nil then VehicleInspector.showColor.background = getXMLString(Xml, groupNameTag.. "#string");end;
	groupNameTag = ("vehicleInspectorSettings.color.txt(%d)"):format(0);
	if getXMLString(Xml, groupNameTag.. "#string") ~= nil then VehicleInspector.showColor.txt = getXMLString(Xml, groupNameTag.. "#string");end;
	groupNameTag = ("vehicleInspectorSettings.color.playerControlled(%d)"):format(0);
	if getXMLString(Xml, groupNameTag.. "#string") ~= nil then VehicleInspector.showColor.playerControlled = getXMLString(Xml, groupNameTag.. "#string");end;
	groupNameTag = ("vehicleInspectorSettings.color.otherPlayerControlled(%d)"):format(0);
	if getXMLString(Xml, groupNameTag.. "#string") ~= nil then VehicleInspector.showColor.otherPlayerControlled = getXMLString(Xml, groupNameTag.. "#string");end;
	groupNameTag = ("vehicleInspectorSettings.color.isField(%d)"):format(0);
	if getXMLString(Xml, groupNameTag.. "#string") ~= nil then VehicleInspector.showColor.field = getXMLString(Xml, groupNameTag.. "#string");end;
	groupNameTag = ("vehicleInspectorSettings.color.isWater(%d)"):format(0);
	if getXMLString(Xml, groupNameTag.. "#string") ~= nil then VehicleInspector.showColor.water = getXMLString(Xml, groupNameTag.. "#string");end;
	groupNameTag = ("vehicleInspectorSettings.color.isDamage(%d)"):format(0);
	if getXMLString(Xml, groupNameTag.. "#string") ~= nil then VehicleInspector.showColor.damage = getXMLString(Xml, groupNameTag.. "#string");end;
	groupNameTag = ("vehicleInspectorSettings.color.isBlocking(%d)"):format(0);
	if getXMLString(Xml, groupNameTag.. "#string") ~= nil then VehicleInspector.showColor.blocking = getXMLString(Xml, groupNameTag.. "#string");end;
	groupNameTag = ("vehicleInspectorSettings.color.isLeasing(%d)"):format(0);
	if getXMLString(Xml, groupNameTag.. "#string") ~= nil then VehicleInspector.showColor.leasing = getXMLString(Xml, groupNameTag.. "#string");end;
	groupNameTag = ("vehicleInspectorSettings.color.isGps(%d)"):format(0);
	if getXMLString(Xml, groupNameTag.. "#string") ~= nil then VehicleInspector.showColor.gps = getXMLString(Xml, groupNameTag.. "#string");end;
	groupNameTag = ("vehicleInspectorSettings.color.isParking(%d)"):format(0);
	if getXMLString(Xml, groupNameTag.. "#string") ~= nil then VehicleInspector.showColor.parking = getXMLString(Xml, groupNameTag.. "#string");end;
	groupNameTag = ("vehicleInspectorSettings.color.isFull(%d)"):format(0);
	if getXMLString(Xml, groupNameTag.. "#string") ~= nil then VehicleInspector.showColor.full = getXMLString(Xml, groupNameTag.. "#string");end;
	groupNameTag = ("vehicleInspectorSettings.color.isEmpty(%d)"):format(0);
	if getXMLString(Xml, groupNameTag.. "#string") ~= nil then VehicleInspector.showColor.empty = getXMLString(Xml, groupNameTag.. "#string");end;
	groupNameTag = ("vehicleInspectorSettings.color.isSelected(%d)"):format(0);
	if getXMLString(Xml, groupNameTag.. "#string") ~= nil then VehicleInspector.showColor.selected = getXMLString(Xml, groupNameTag.. "#string");end;
	groupNameTag = ("vehicleInspectorSettings.color.remainingString(%d)"):format(0);
	if getXMLString(Xml, groupNameTag.. "#string") ~= nil then VehicleInspector.showColor.remainingString = getXMLString(Xml, groupNameTag.. "#string");end;
	viSetGetSettingsXml:cloneXmlColor();
end;

function viSetGetSettingsXml:onCloseCallbackGuiMenue()
	
end;

function viSetGetSettingsXml:onOpenCallbackGuiMenue()

end;

function viSetGetSettingsXml:onSaveCallbackGuiMenue()
	viSetGetSettingsXml:saveConfig();
end;

function viSetGetSettingsXml:cloneDefaultColor()
	VehicleInspector.showColorDefault = g_currentMission.hl.getTableCopy(VehicleInspector.showColor);
end;

function viSetGetSettingsXml:cloneXmlColor()
	VehicleInspector.showColorXml = g_currentMission.hl.getTableCopy(VehicleInspector.showColor);
end;