--load Hl Gui over mod desc,copy hlGui directory at your mod
--edit line 30,35,54 with your mod name
--Hl Gui Menue needs _hl.lua, check MultiOverlayV4 Mod _hl.lua
--Hl Gui Menue generate etc. check MultiOverlayV4 Mod ../scripte/hlGui/..

hlGui = {};

hlGui.metadata = {
	interface = " FS22 ...",
	title = "HL GUI Menue",
	notes = " Erstellt ein Konfigurations Menue Hud für Mods etc.",
	author = " (by HappyLooser)",
	version = " v0.5 Beta",
	hlGuiVersion = 0.5,
	datum = " 03.01.2019",
	update = " 28.01.2023",
	web = " no",
	info = " Link Freigabe,Änderungen,Kopien Benutzung ist ohne meine Zustimmung nicht erlaubt",
	info1 = " Benutzung als GUI Menue in einem Mod (ohne Code Änderung) ist ohne Zustimmung erlaubt",
	"##Orginal Link Freigabe:"
};

hlGui.modDir = g_currentModDirectory;
function hlGui:loadMap(name)
	Mission00.onStartMission = Utils.prependedFunction(Mission00.onStartMission, hlGui.onStartMission);	
	if hlGui:getServer() then return;end;	
	if g_currentMission.hlGui == nil then g_currentMission.hlGui = {};end;
	if g_currentMission.hlGui.version == nil then 
		g_currentMission.hlGui.version = hlGui.metadata.hlGuiVersion;
		g_currentMission.hlGui.masterMod = "VehicleInspector";
		g_currentMission.hlGui.master = self;
	else
		if g_currentMission.hlGui.version < hlGui.metadata.hlGuiVersion then 
			g_currentMission.hlGui.version = hlGui.metadata.hlGuiVersion;
			g_currentMission.hlGui.masterMod = "VehicleInspector";
			g_currentMission.hlGui.master = self;
		end;
	end;	
end;	

function hlGui:loadHlGui()
	if hlGui:getServer() then return;end;
	print("---loading ".. tostring(hlGui.metadata.title).. tostring(hlGui.metadata.version).. tostring(hlGui.metadata.author).. "---")
	hlGui:loadScripts();
	hlGuiSetGet:loadTable();
	hlGuiOverlays:loadTable();
	g_currentMission.hlGui.setGet = hlGuiSetGet;
	hlGuiSetGet:generateHlGuiModMenue();
	if g_currentMission.hlGui.callbacks == nil then g_currentMission.hlGui.callbacks = {};end;
	hlGuiSetGet:loadXml();
end;

function hlGui.onStartMission()	
	if g_currentMission.hlGui == nil or g_currentMission.hlGui.masterMod ~= "VehicleInspector" or g_currentMission.hl == nil then
		removeModEventListener(hlGui);
	else
		if hlGui:getServer() then return;end;
		hlGui:loadHlGui();
	end;
end;

function hlGui:deleteMap()
	if hlGui:getServer() then return;end;
	hlGuiOverlays:deleteMenueIcons();
	hlGuiSetGet:saveXml();
end;

function hlGui:mouseEvent(posX, posY, isDown, isUp, button)
	if hlGui:getServer() or hlGui:getIngameMap() or hlGui:getFullSize() then return;end;	
	hlGui.mouseCursor = {posX=posX, posY=posY, isDwon=isDown, isUp=isUp, button=button};
	hlGuiMouseKeyEvents:setKeyMouse(nil, nil, nil, nil, posX, posY, isDown, isUp, button);
end;

function hlGui:keyEvent(unicode, sym, modifier, isDown)	
	if hlGui:getServer() or hlGui:getIngameMap() or hlGui:getFullSize() then return;end;
	hlGuiMouseKeyEvents:setKeyMouse(unicode, sym, modifier, isDown, nil, nil, nil, nil, nil);
end;

function hlGui:update(dt)	
	if hlGui:getServer() or hlGui:getIngameMap() or hlGui:getFullSize() then return;end;
end;

function hlGui:draw()	
	if hlGui:getServer() or hlGui:getIngameMap() or hlGui:getFullSize() then return;end;
	--respect settings for other mods (not every mod) that's why
	setTextAlignment(0);
	setTextLineBounds(0, 0);
	setTextWrapWidth(0);
	setTextColor(1, 1, 1, 1);
	setTextBold(false);
	--respect settings for other mods	
	
	--if g_currentMission.hl.isMouseCursor then
		hlGuiDraw:setOpen();		
	--end;
	
	--respect settings for other mods
	setTextAlignment(0);
	setTextLineBounds(0, 0);
	setTextWrapWidth(0);
	setTextColor(1, 1, 1, 1);
	setTextBold(false);
	--respect settings for other mods	
end;
addModEventListener(hlGui);

function hlGui:loadScripts()		
	source(hlGui.modDir.."hlGui/hlGuiSetGet.lua");
	source(hlGui.modDir.."hlGui/hlGuiOverlays.lua");
	source(hlGui.modDir.."hlGui/hlGuiDraw.lua");
	source(hlGui.modDir.."hlGui/hlGuiMouseKeyEvents.lua");
end;

function hlGui:getServer()	
	return g_dedicatedServer ~= nil;
end;

function hlGui:getFullSize()
	if g_currentMission.paused or
	g_gui:getIsGuiVisible() or
	g_currentMission.inGameMenu.paused or	
	g_currentMission.inGameMenu.isOpen or 
	g_currentMission.physicsPaused or 
	not g_currentMission.hud.isVisible then
	if g_currentMission.missionDynamicInfo.isMultiplayer and g_currentMission.manualPaused then return false;end;
	return true;end;
	return false;
end;

function hlGui:getIngameMap()
	return g_gameSettings:getValue("ingameMapState") == 4;	
end;