hlGuiSetGet = {};

function hlGuiSetGet:loadTable()
	g_currentMission.hlGui.clickAreas = {master={},menue={}};
	g_currentMission.hlGui.mod = {};
	g_currentMission.hlGui.menue = {		
		iconWidescreenFix = 0;
		blinkDragDropHeight = false;
		blinkDragDropWidth = false;
		modTotal = 0;
		icon = {};
		distanceHeight = 0;
		distanceWidth = 0;
		distanceEdge = 0.001;
		acceptButtons = {
			buttonLeft="buttonLeft";
			buttonRight="buttonRight";
			buttonLeftRight="buttonLeftRight";
			buttonUp="buttonUp";
			buttonDown="buttonDown";
			buttonUpDown="buttonUpDown";
			buttonOnOff="buttonOnOff";
			buttonFlip="buttonFlip";
			buttonPrint="buttonPrint";
			buttonGenerate="buttonGenerate";
			buttonLoad="buttonLoad";
			buttonDelete="buttonDelete";
			buttonEdit="buttonEdit";
		};
		color = {txt="white",button="black",buttonGround="pulldownGray",txtPullDown="black",txtTitle="khaki",txtExtra="ls15",on="green",off="red",ready="yellow",default="darkGray",select="darkGreen"};
		isOpen = false;
		isSmallView = false;
		smallViewHidden = false;
		isSave = true;
		isHelp = false;
		helpBox = {bounds={0,0,0,0},txt=""};
		isInfo = false;
		infoBox = {bounds={0,0,0,0},txt=""};
		pullDownButton = {isOpen=false,whatOpen="",x=0,y=0,width=0,height=0,bounds={0,0,0,0},select=0,multiple=false,up=false,line={}};
		select = {modName="HlGuiMenue", page=1, side=1};
		overUnderOptiSize = 0;
		buttonOptiSize = 0;
		minZoomOutIn = 15;
		maxZoomOutIn = 25;
		defaultZoomOutIn = 20;
		zoomOutIn = 20;
		zoomOutInLV = 1;
		position = 1;
		posX = {[1]=0.1, [2]=0};
		posY = {[1]=0.4 ,[2]=0, beginLine=0, endLine=0};
		width = {zoomOutIn=11, [1]=0, [2]=0};
		height = {zoomOutIn=8, [1]=0, [2]=0,line=0};
	};
end;

function hlGuiSetGet:blinkingDragDropHeight(on)
	if on ~= nil and on then g_currentMission.hlGui.menue.blinkDragDropHeight = true;else g_currentMission.hlGui.menue.blinkDragDropHeight = false;end;
end;

function hlGuiSetGet:blinkingDragDropWidth(on)
	if on ~= nil and on then g_currentMission.hlGui.menue.blinkDragDropWidth = true;else g_currentMission.hlGui.menue.blinkDragDropWidth = false;end;
end;

function hlGuiSetGet:getMaxWidth(maxWidth, iconWidth)
	local maxWidth = math.floor(maxWidth/iconWidth, -0.5);	
	return maxWidth;
end;

function hlGuiSetGet:getMaxHeight(maxHeight, iconHeight)	
	local maxHeight = math.floor(maxHeight/iconHeight, -0.5);	
	return maxHeight;
end;

function hlGuiSetGet:resetPullDownButton()
	g_currentMission.hlGui.menue.pullDownButton = {isOpen=false,whatOpen="",x=0,y=0,width=0,height=0,bounds={0,0,0,0},select=0,multiple=false,up=false;line={}};
end;

function hlGuiSetGet:resetSelect()
	g_currentMission.hlGui.menue.select = {modName="HlGuiMenue", page=1, side=1};
end;

function hlGuiSetGet:resetInfoBox()
	g_currentMission.hlGui.menue.infoBox = {bounds={0,0,0,0},txt=""};
	if g_currentMission.hl.timers["hlGuiMenue_infoBox"] ~= nil then g_currentMission.hl.removeTimer("hlGuiMenue_infoBox");end;
end;

function hlGuiSetGet:resetHelpBox()
	g_currentMission.hlGui.menue.helpBox = {bounds={0,0,0,0},txt=""};
	if g_currentMission.hl.timers["hlGuiMenue_helpBox"] ~= nil then g_currentMission.hl.removeTimer("hlGuiMenue_helpBox");end;
end;

function hlGuiSetGet:setOpen(modName, page, side, ownTable)
	hlGuiSetGet:resetPullDownButton();
	local oldSelectModName = g_currentMission.hlGui.menue.select.modName;
	if modName ~= nil and g_currentMission.hlGui.mod[modName] ~= nil then		
		--if hlGuiSetGet:isOpen() and modName == oldSelectModName then return;end;
		g_currentMission.hlGui.menue.select.modName = modName;
		if page ~= nil and type(page) == "number" then g_currentMission.hlGui.menue.select.page = page;else hlGuiSetGet:setOpenPage(1);end;
		if side ~= nil and type(side) == "number" then g_currentMission.hlGui.menue.select.side = side;else hlGuiSetGet:setOpenSide(1);end;
	else
		hlGuiSetGet:resetSelect();		
	end;
	g_currentMission.hlGui.menue.isOpen = true;
	if g_currentMission.hlGui.menue.select.modName ~= "HlGuiMenue" then
		if g_currentMission.hlGui.menue.select.modName ~= oldSelectModName then
			for modNameKey, modTable in pairs (g_currentMission.hlGui.mod) do
				if modNameKey ~= oldSelectModName then
					if modTable.onOpenCallback ~= nil then modTable.onOpenCallback();end;
					hlGuiSetGet:resetHelpBox();
					hlGuiSetGet:resetInfoBox();
				end;
			end;
		end;
	end;
end;

function hlGuiSetGet:setOpenPage(page)
	hlGuiSetGet:resetPullDownButton();
	local modName = g_currentMission.hlGui.menue.select.modName;
	if g_currentMission.hlGui.mod[modName] ~= nil then
		if page ~= nil and type(page) == "number" then 
			if page ~= g_currentMission.hlGui.menue.select.page then
				g_currentMission.hlGui.menue.select.page = page;
				g_currentMission.hlGui.menue.select.side = 1;
				if g_currentMission.hlGui.mod[modName].page[page].onOpenCallback ~= nil then
					g_currentMission.hlGui.mod[modName].page[page].onOpenCallback(page);
				end;
				hlGuiSetGet:resetHelpBox();
				hlGuiSetGet:resetInfoBox();
			end;
		end;
	end;
end;

function hlGuiSetGet:setOpenSide(side)
	hlGuiSetGet:resetPullDownButton();
	local modName = g_currentMission.hlGui.menue.select.modName;
	if g_currentMission.hlGui.mod[modName] ~= nil then
		if side ~= nil and type(side) == "number" then 
			if side ~= g_currentMission.hlGui.menue.select.side then
				g_currentMission.hlGui.menue.select.side = side;
				if g_currentMission.hlGui.mod[modName].page[g_currentMission.hlGui.menue.select.page].side[side].onOpenCallback ~= nil then
					g_currentMission.hlGui.mod[modName].page[g_currentMission.hlGui.menue.select.page].side[side].onOpenCallback(side);
				end;
				hlGuiSetGet:resetHelpBox();
				hlGuiSetGet:resetInfoBox();
			end;
		end;
	end;
end;

function hlGuiSetGet:setClose()
	hlGuiSetGet:resetPullDownButton();	
	g_currentMission.hlGui.menue.isOpen = false;	
	hlGuiSetGet:resetHelpBox();
	hlGuiSetGet:resetInfoBox();
	for modNameKey, modTable in pairs (g_currentMission.hlGui.mod) do		
		if modTable.closeCallback ~= nil then modTable.closeCallback();end;		
	end;
	g_currentMission.hlGui.clickAreas.menue["hlGuiMenue"] = {};
	g_currentMission.hlGui.clickAreas.master = {};
end;

function hlGuiSetGet:setSave()
	hlGuiSetGet:resetPullDownButton();	
	g_currentMission.hlGui.menue.isSave = true;	
	for modNameKey, modTable in pairs (g_currentMission.hlGui.mod) do		
		if modTable.saveCallback ~= nil then modTable.saveCallback();end;		
	end;
	hlGuiSetGet:saveXml();
end;

function hlGuiSetGet:setHelp()	
	g_currentMission.hlGui.menue.isHelp = not g_currentMission.hlGui.menue.isHelp;
end;

function hlGuiSetGet:setInfo()	
	g_currentMission.hlGui.menue.isInfo = not g_currentMission.hlGui.menue.isInfo;
end;

function hlGuiSetGet:setZoomOutIn(zoomOut)	
	if zoomOut then
		if g_currentMission.hlGui.menue.zoomOutIn+g_currentMission.hlGui.menue.zoomOutInLV > g_currentMission.hlGui.menue.maxZoomOutIn then return;end;
		g_currentMission.hlGui.menue.zoomOutIn = g_currentMission.hlGui.menue.zoomOutIn+g_currentMission.hlGui.menue.zoomOutInLV;
		g_currentMission.hlGui.menue.isSave = false;
		hlGuiSetGet:resetPullDownButton();
		hlGuiOverlays:setNormalDraw();
		hlGuiSetGet:resetSideLineBounds();
		hlGuiSetGet:resetHelpBox();
		hlGuiSetGet:resetInfoBox();
	elseif not zoomOut then
		if g_currentMission.hlGui.menue.zoomOutIn-g_currentMission.hlGui.menue.zoomOutInLV < g_currentMission.hlGui.menue.minZoomOutIn then return;end;
		g_currentMission.hlGui.menue.zoomOutIn = g_currentMission.hlGui.menue.zoomOutIn-g_currentMission.hlGui.menue.zoomOutInLV;
		g_currentMission.hlGui.menue.isSave = false;
		hlGuiSetGet:resetPullDownButton();
		hlGuiOverlays:setNormalDraw();
		hlGuiSetGet:resetSideLineBounds();
		hlGuiSetGet:resetHelpBox();
		hlGuiSetGet:resetInfoBox();
	end;
end;

function hlGuiSetGet:getPosWidthHeight()
	return {x=g_currentMission.hlGui.menue.posX[1],y=g_currentMission.hlGui.menue.posY[1]-g_currentMission.hlGui.menue.height[1],width=g_currentMission.hlGui.menue.width[1],height=g_currentMission.hlGui.menue.height[1]};
end;

function hlGuiSetGet:getSmallViewPosWidthHeight()
	return {x=g_currentMission.hlGui.menue.posX[2],y=g_currentMission.hlGui.menue.posY[2],width=g_currentMission.hlGui.menue.width[2],height=g_currentMission.hlGui.menue.height[2]};
end;

function hlGuiSetGet:isOpen()
	return g_currentMission.hlGui.menue.isOpen;
end;

function hlGuiSetGet:getModTable(modName)
	if modName ~= nil and g_currentMission.hlGui.mod[modName] ~= nil then return g_currentMission.hlGui.mod[modName];end;
	return nil;
end;

function hlGuiSetGet:getOpenMod()
	if g_currentMission.hlGui.menue.isOpen then return g_currentMission.hlGui.menue.select.modName;end;	
	return "";
end;

function hlGuiSetGet:getOpenPage()
	if g_currentMission.hlGui.menue.isOpen then return g_currentMission.hlGui.menue.select.page;end;	
	return 0;
end;

function hlGuiSetGet:getOpenSide()
	if g_currentMission.hlGui.menue.isOpen then return g_currentMission.hlGui.menue.select.side;end;	
	return 0;
end;

function hlGuiSetGet:getOpenAndWhat()
	return hlGuiSetGet:isOpen(), hlGuiSetGet:getOpenMod(), hlGuiSetGet:getOpenPage(), hlGuiSetGet:getOpenSide();
end;

function hlGuiSetGet:setUnSave()
	g_currentMission.hlGui.menue.isSave = false;
end;

function hlGuiSetGet:isSave()
	return g_currentMission.hlGui.menue.isSave;
end;

function hlGuiSetGet:isHelp()
	return g_currentMission.hlGui.menue.isHelp;
end;

function hlGuiSetGet:isInfo()
	return g_currentMission.hlGui.menue.isInfo;
end;

function hlGuiSetGet:isPullDownOpenButton()
	return g_currentMission.hlGui.menue.pullDownButton.isOpen;
end;

function hlGuiSetGet:getPullDownButtonData()
	if g_currentMission.hlGui.menue.pullDownButton.isOpen then
		return {line=g_currentMission.hlGui.menue.pullDownButton.line,whatOpen=g_currentMission.hlGui.menue.pullDownButton.whatOpen,x=g_currentMission.hlGui.menue.pullDownButton.x,y=g_currentMission.hlGui.menue.pullDownButton.y,width=g_currentMission.hlGui.menue.pullDownButton.width,height=g_currentMission.hlGui.menue.pullDownButton.height,bounds=g_currentMission.hlGui.menue.pullDownButton.bounds}; 
	end;
	return nil;
end;

function hlGuiSetGet:setMenuePullDown(args)
	if args == nil or type(args) ~= "table" then return;end;
	if hlGuiSetGet:isPullDownOpenButton() then hlGuiSetGet:resetPullDownButton();return;end;
	local modMenueTable = g_currentMission.hlGui.mod[g_currentMission.hlGui.menue.select.modName];
	local modPage = g_currentMission.hlGui.mod[g_currentMission.hlGui.menue.select.modName].page[g_currentMission.hlGui.menue.select.page];
	local modSide = g_currentMission.hlGui.mod[g_currentMission.hlGui.menue.select.modName].page[g_currentMission.hlGui.menue.select.page].side[g_currentMission.hlGui.menue.select.side];
	local foundPage = modMenueTable ~= nil and modMenueTable.page ~= nil and #modMenueTable.page > 0;
	local foundSide = foundPage and modPage ~= nil and modPage.side ~= nil and #modPage.side > 0;
	function setMenuePullDownData()
		if #g_currentMission.hlGui.menue.pullDownButton.line > 1 then
			hlGuiSetGet:setMenuePullDownData(args);
			g_currentMission.hlGui.menue.pullDownButton.isOpen = true;
			g_currentMission.hlGui.menue.pullDownButton.whatOpen = args.whereClick;			
		end;
	end;
	if args.whereClick == "modPullDownHlGuiMenue_" then
		for modName,modTable in pairs (g_currentMission.hlGui.mod) do
			if modTable ~= nil then
				g_currentMission.hlGui.menue.pullDownButton.line[#g_currentMission.hlGui.menue.pullDownButton.line+1] = {modName=modName,txt=modTable.displayName,view=false,isSelect=modName==g_currentMission.hlGui.menue.select.modName};
			end;
		end;
		setMenuePullDownData();
	elseif args.whereClick == "pagePullDownHlGuiMenue_" then		
		if foundPage then
			for page=1, #modMenueTable.page do
				if modMenueTable.page[page] ~= nil then
					g_currentMission.hlGui.menue.pullDownButton.line[#g_currentMission.hlGui.menue.pullDownButton.line+1] = {page=page,txt=modMenueTable.page[page].displayName,view=false,isSelect=page==g_currentMission.hlGui.menue.select.page};
				end;
			end;				
		end;		
		setMenuePullDownData();
	elseif args.whereClick == "sidePullDownHlGuiMenue_" then		
		if foundSide then
			for side=1, #modPage.side do
				if modPage.side[side] ~= nil then
					g_currentMission.hlGui.menue.pullDownButton.line[#g_currentMission.hlGui.menue.pullDownButton.line+1] = {side=side,txt=tostring(side),view=false,isSelect=side==g_currentMission.hlGui.menue.select.side};
				end;
			end;
		end;		
		setMenuePullDownData();
	elseif args.whereClick == "sideLineButtonPullDown_" then
		if args.callback ~= nil then
			local pullDownTable = args.callback( {lineButton=args.lineButton, line=args.line, button=args.button, ownTable=args.ownTable} );
			if pullDownTable ~= nil and type(pullDownTable) == "table" and #pullDownTable > 0 then
				for line=1, #pullDownTable do
					if pullDownTable[line] ~= nil and pullDownTable[line].txt ~= nil then
						g_currentMission.hlGui.menue.pullDownButton.line[#g_currentMission.hlGui.menue.pullDownButton.line+1] = {line=line,txt=tostring(pullDownTable[line].txt),view=false,isSelect=pullDownTable[line].isSelect or false,callback=pullDownTable[line].callback,ownTable=pullDownTable[line].ownTable};
					end;
				end;				
				setMenuePullDownData();
			end;
		end;
	end;	
end;

function hlGuiSetGet:setMenuePullDownData(args)
	if args == nil or type(args) ~= "table" then return;end;
	local iconHeight = hlGuiOverlays.buttonGfxHeight1*g_currentMission.hlGui.menue.zoomOutIn;
	local distanceHeight = g_currentMission.hlGui.menue.distanceHeight;
	local distanceEdge = g_currentMission.hlGui.menue.distanceEdge;
	local lineHeight = iconHeight+distanceEdge;
	local maxHeight = args[3]-(g_currentMission.hlGui.menue.posY[1]-g_currentMission.hlGui.menue.height[1]+iconHeight+(distanceHeight/2));
	local maxLines = hlGuiSetGet:getMaxHeight(maxHeight, lineHeight);
	g_currentMission.hlGui.menue.pullDownButton.bounds[1] = 1;
	if maxLines > 1 then 
		g_currentMission.hlGui.menue.pullDownButton.bounds[2] = maxLines;		
	else 
		g_currentMission.hlGui.menue.pullDownButton.bounds[2] = 1;
	end;
	g_currentMission.hlGui.menue.pullDownButton.bounds[3] = #g_currentMission.hlGui.menue.pullDownButton.line;
	g_currentMission.hlGui.menue.pullDownButton.bounds[4] = lineHeight;
	g_currentMission.hlGui.menue.pullDownButton.height = lineHeight*(g_currentMission.hlGui.menue.pullDownButton.bounds[2]-g_currentMission.hlGui.menue.pullDownButton.bounds[1]+1);
	if g_currentMission.hlGui.menue.pullDownButton.height > lineHeight*#g_currentMission.hlGui.menue.pullDownButton.line then g_currentMission.hlGui.menue.pullDownButton.height = lineHeight*#g_currentMission.hlGui.menue.pullDownButton.line;end;
	g_currentMission.hlGui.menue.pullDownButton.width = args.pullDown.width;
	g_currentMission.hlGui.menue.pullDownButton.x = args.pullDown.x;
	g_currentMission.hlGui.menue.pullDownButton.y = args.pullDown.y-g_currentMission.hlGui.menue.pullDownButton.height;
	g_currentMission.hlGui.menue.pullDownButton.multiple = args.pullDown.multiple;
	hlGuiSetGet:setMenuePullDownBounds(args);	
end;

function hlGuiSetGet:setMenuePullDownBounds(args)
	if args == nil or type(args) ~= "table" then return;end;
	if args.up then
		if g_currentMission.hlGui.menue.pullDownButton.bounds[1]-1 < 1 then return;end;
		g_currentMission.hlGui.menue.pullDownButton.bounds[1] = g_currentMission.hlGui.menue.pullDownButton.bounds[1]-1;
		g_currentMission.hlGui.menue.pullDownButton.bounds[2] = g_currentMission.hlGui.menue.pullDownButton.bounds[2]-1;
	elseif args.down then
		if g_currentMission.hlGui.menue.pullDownButton.bounds[2]+1 > g_currentMission.hlGui.menue.pullDownButton.bounds[3] then return;end;
		g_currentMission.hlGui.menue.pullDownButton.bounds[1] = g_currentMission.hlGui.menue.pullDownButton.bounds[1]+1;
		g_currentMission.hlGui.menue.pullDownButton.bounds[2] = g_currentMission.hlGui.menue.pullDownButton.bounds[2]+1;
	end;
	for line=1, #g_currentMission.hlGui.menue.pullDownButton.line do
		if g_currentMission.hlGui.menue.pullDownButton.line[line] ~= nil then
			if line >= g_currentMission.hlGui.menue.pullDownButton.bounds[1] and line <= g_currentMission.hlGui.menue.pullDownButton.bounds[2] then
				g_currentMission.hlGui.menue.pullDownButton.line[line].view = true;
			else
				g_currentMission.hlGui.menue.pullDownButton.line[line].view = false;
			end;
		end;
	end;
end;

function hlGuiSetGet:setMenuePullDownClick(args)
	if args == nil or type(args) ~= "table" or args.pullDown == nil then return;end;
	if g_currentMission.hlGui.menue.pullDownButton.whatOpen == "modPullDownHlGuiMenue_" then		
		hlGuiSetGet:setOpen(g_currentMission.hlGui.menue.pullDownButton.line[args.pullDown.line].modName);		
	elseif g_currentMission.hlGui.menue.pullDownButton.whatOpen == "pagePullDownHlGuiMenue_" then
		hlGuiSetGet:setOpenPage(g_currentMission.hlGui.menue.pullDownButton.line[args.pullDown.line].page);
	elseif g_currentMission.hlGui.menue.pullDownButton.whatOpen == "sidePullDownHlGuiMenue_" then
		hlGuiSetGet:setOpenSide(g_currentMission.hlGui.menue.pullDownButton.line[args.pullDown.line].side);
	elseif g_currentMission.hlGui.menue.pullDownButton.whatOpen == "sideLineButtonPullDown_" then
		local pullDownLine = g_currentMission.hlGui.menue.pullDownButton.line[args.pullDown.line];
		if g_currentMission.hlGui.menue.pullDownButton.multiple then g_currentMission.hlGui.menue.pullDownButton.line[args.pullDown.line].isSelect = not g_currentMission.hlGui.menue.pullDownButton.line[args.pullDown.line].isSelect;end;
		if pullDownLine.callback ~= nil and type(pullDownLine.callback) == "function" then
			pullDownLine.callback( {ownTable=pullDownLine.ownTable,selectLine=g_currentMission.hlGui.menue.pullDownButton.select} );			
		end;
		if not g_currentMission.hlGui.menue.pullDownButton.multiple then hlGuiSetGet:resetPullDownButton();end;
	end;
end;

function hlGuiSetGet:pullDownOverlap(overlay, txt, optiSize)
	if not hlGuiSetGet:isPullDownOpenButton() then return false;end;
	local tempOverlay = {
		x=g_currentMission.hlGui.menue.pullDownButton.x;
		y=g_currentMission.hlGui.menue.pullDownButton.y;
		width=g_currentMission.hlGui.menue.pullDownButton.width;
		height=g_currentMission.hlGui.menue.pullDownButton.height;
	};
		
	if old then
		local box1x = g_currentMission.hlGui.menue.pullDownButton.x;	
		local box1y = g_currentMission.hlGui.menue.pullDownButton.y;
		local box1w = g_currentMission.hlGui.menue.pullDownButton.width-hlGuiOverlays.buttonGfxWidth1;
		local box1h = g_currentMission.hlGui.menue.pullDownButton.height-hlGuiOverlays.buttonGfxHeight1;
		local box2x = overlay.x;	
		local box2y = overlay.y;
		local box2w = overlay.width;
		local box2h = overlay.height;
		if txt then
			box2w = getTextWidth(optiSize, utf8Substr(txt, 0))-hlGuiOverlays.buttonGfxWidth1;
			box2h = getTextHeight(optiSize, utf8Substr(txt, 0))-hlGuiOverlays.buttonGfxHeight1
		else
			box2w = box2w-hlGuiOverlays.buttonGfxWidth1;
			box2h = box2h-hlGuiOverlays.buttonGfxHeight1;
		end;	
		if box1x >= box2x + box2w or -- Is box1 on the right side of box2?
		   box1y >= box2y + box2h or -- Is box1 under box2?
		   box2x >= box1x + box1w or -- Is box2 on the right side of box1?
		   box2y >= box1y + box1h    -- Is b2 under b1?
		then
			return false; 
		else
			return true;
		end;
	end;
	return g_currentMission.hl.overlayOverlap(tempOverlay, overlay, txt, optiSize);
end;

function hlGuiSetGet:resetSideLineBounds()
	for _, modTable in pairs (g_currentMission.hlGui.mod) do
		for page=1, #modTable.page do
			for side=1, #modTable.page[page].side do
				modTable.page[page].side[side].bounds = {0,0,0,0};
			end;
		end;				
	end;
end;

function hlGuiSetGet:setSideFirstLineBounds()
	local beginPosY = g_currentMission.hlGui.menue.posY.beginLine;
	local endPosY = g_currentMission.hlGui.menue.posY.endLine;
	local lineHeight = g_currentMission.hlGui.menue.height.line;
	local modTable = g_currentMission.hlGui.mod[g_currentMission.hlGui.menue.select.modName].page[g_currentMission.hlGui.menue.select.page].side[g_currentMission.hlGui.menue.select.side];
	if modTable ~= nil then
		local maxLines = hlGuiSetGet:getMaxHeight(beginPosY-endPosY, lineHeight);
		modTable.bounds[1] = 1;
		if maxLines > 1 then
			modTable.bounds[2] = maxLines;
		else
			modTable.bounds[2] = 1;
		end;
		modTable.bounds[3] = #modTable.line;
		modTable.bounds[4] = lineHeight;
		hlGuiSetGet:setSideLineBounds();
	end;
end;

function hlGuiSetGet:setSideLineBounds(args)	
	local modTable = g_currentMission.hlGui.mod[g_currentMission.hlGui.menue.select.modName].page[g_currentMission.hlGui.menue.select.page].side[g_currentMission.hlGui.menue.select.side];
	if modTable ~= nil then
		if args ~= nil and args.up then			
			if modTable.bounds[1]-1 < 1 then return;end;			
			modTable.bounds[1] = modTable.bounds[1]-1;
			modTable.bounds[2] = modTable.bounds[2]-1;
		elseif args ~= nil and args.down then			
			if modTable.bounds[2]+1 > modTable.bounds[3] then return;end;			
			modTable.bounds[1] = modTable.bounds[1]+1;
			modTable.bounds[2] = modTable.bounds[2]+1;
		end;
		for line=1, #modTable.line do
			if modTable.line[line] ~= nil then
				if line >= modTable.bounds[1] and line <= modTable.bounds[2] then
					modTable.line[line].view = true;
				else
					modTable.line[line].view = false;
				end;
			end;
		end;
	end;
end;

function hlGuiSetGet.setInfoHelpBoxBounds(args) --timer callback or hlGuiDraw
	if args == nil or type(args) ~= "table" then return;end;
	local maxTxtWidth = g_currentMission.hlGui.menue.width[1]-(g_currentMission.hlGui.menue.distanceEdge*3)-((hlGuiOverlays.buttonGfxWidth1*g_currentMission.hlGui.menue.zoomOutIn)*2);
	local optiSize = g_currentMission.hlGui.menue.buttonOptiSize;
	local txt = "";
	local isInfoTxt = string.len(g_currentMission.hlGui.menue.infoBox.txt) > 0;
	local isHelpTxt = string.len(g_currentMission.hlGui.menue.helpBox.txt) > 0;
	local isTimerCallback = false;
	if args.current_time ~= nil then
		if g_currentMission.hl.timers["hlGuiMenue_infoBox"] ~= nil then
			if not g_currentMission.hlGui.menue.isInfo or not isInfoTxt then hlGuiSetGet:resetInfoBox();end;
			isTimerCallback = true;
		end;
		if g_currentMission.hl.timers["hlGuiMenue_helpBox"] ~= nil then
			if not g_currentMission.hlGui.menue.isHelp or not isHelpTxt then hlGuiSetGet:resetHelpBox();end;
			isTimerCallback = true;
		end;
	else
		if g_currentMission.hlGui.menue.isInfo and g_currentMission.hl.timers["hlGuiMenue_infoBox"] == nil and isInfoTxt then
			g_currentMission.hl.addTimer( {delay=3, name="hlGuiMenue_infoBox", repeatable=2, ownTable={infoBox=true}, ms=false, action=hlGuiSetGet.setInfoHelpBoxBounds} );
		end;
		if g_currentMission.hlGui.menue.isHelp and g_currentMission.hl.timers["hlGuiMenue_helpBox"] == nil and isHelpTxt then
			g_currentMission.hl.addTimer( {delay=3, name="hlGuiMenue_helpBox", repeatable=2, ownTable={helpBox=true}, ms=false, action=hlGuiSetGet.setInfoHelpBoxBounds} );
		end;
	end;
	if not isHelpTxt then 
		txt = utf8Substr(g_currentMission.hlGui.menue.infoBox.txt, 0);
	else
		txt = utf8Substr(g_currentMission.hlGui.menue.helpBox.txt, 0);
	end;
	if isInfoTxt or isHelpTxt then
		local foundLines = math.ceil(getTextWidth(optiSize, utf8Substr(txt, 0))/maxTxtWidth);
		if foundLines > 3 then
			if isTimerCallback then
				if isHelpTxt then
					if g_currentMission.hlGui.menue.helpBox.bounds[1]+3 > foundLines then
						g_currentMission.hlGui.menue.helpBox.bounds[1] = g_currentMission.hlGui.menue.helpBox.bounds[1]+3;
						g_currentMission.hlGui.menue.helpBox.bounds[2] = g_currentMission.hlGui.menue.helpBox.bounds[2]+3;
						if g_currentMission.hl.timers["hlGuiMenue_helpBox"] ~= nil then g_currentMission.hl.timers["hlGuiMenue_helpBox"].repeatable = 2;end;
					else
						hlGuiSetGet:resetHelpBox();
					end;
				else
					if g_currentMission.hlGui.menue.infoBox.bounds[1]+3 > foundLines then
						g_currentMission.hlGui.menue.infoBox.bounds[1] = g_currentMission.hlGui.menue.infoBox.bounds[1]+3;
						g_currentMission.hlGui.menue.infoBox.bounds[2] = g_currentMission.hlGui.menue.infoBox.bounds[2]+3;
						if g_currentMission.hl.timers["hlGuiMenue_infoBox"] ~= nil then g_currentMission.hl.timers["hlGuiMenue_infoBox"].repeatable = 2;end;
					else
						hlGuiSetGet:resetInfoBox();
					end;				
				end;
			else
				if isHelpTxt then
					g_currentMission.hlGui.menue.helpBox.bounds[1] = 0;
					g_currentMission.hlGui.menue.helpBox.bounds[2] = 3;
				else
					g_currentMission.hlGui.menue.infoBox.bounds[1] = 0;
					g_currentMission.hlGui.menue.infoBox.bounds[2] = 3;
				end;
			end;
		else
			if isTimerCallback then
				if isHelpTxt then
					hlGuiSetGet:resetHelpBox();
				else
					hlGuiSetGet:resetInfoBox();
				end;
			else
				if isHelpTxt then
					g_currentMission.hlGui.menue.helpBox.bounds[1] = 0;
					g_currentMission.hlGui.menue.helpBox.bounds[2] = 3;
				else
					g_currentMission.hlGui.menue.infoBox.bounds[1] = 0;
					g_currentMission.hlGui.menue.infoBox.bounds[2] = 3;
				end;
			end;
		end;
	end;	
end;

function hlGuiSetGet:loadXml()
	local file = getUserProfileAppPath().. "modSettings/hlGuiMenue.xml";
	if fileExists(file) then 
		local Xml = loadXMLFile("_hlGuiMenue_XML", file, "hlGui");
		local xmlNameTag = "hlGui";	
		if Xml ~= nil then
			local refreshWidescreenFix = false;
			if getXMLFloat(Xml, xmlNameTag.. "#iconWidescreenFix") ~= nil then
				g_currentMission.hlGui.menue.iconWidescreenFix = getXMLFloat(Xml, xmlNameTag.. "#iconWidescreenFix");
				if g_currentMission.hlGui.menue.iconWidescreenFix ~= nil and (g_currentMission.hlGui.menue.iconWidescreenFix > 0 or g_currentMission.hlGui.menue.iconWidescreenFix < 0) then refreshWidescreenFix = true;end;
			end;
			if getXMLFloat(Xml, xmlNameTag.. "#posX") ~= nil then
				g_currentMission.hlGui.menue.posX[1] = getXMLFloat(Xml, xmlNameTag.. "#posX");
			end;
			if getXMLFloat(Xml, xmlNameTag.. "#posY") ~= nil then
				g_currentMission.hlGui.menue.posY[1] = getXMLFloat(Xml, xmlNameTag.. "#posY");
			end;
			if getXMLFloat(Xml, xmlNameTag.. "#width") ~= nil then
				g_currentMission.hlGui.menue.width[1] = getXMLFloat(Xml, xmlNameTag.. "#width");
			end;
			if getXMLFloat(Xml, xmlNameTag.. "#height") ~= nil then
				g_currentMission.hlGui.menue.height[1] = getXMLFloat(Xml, xmlNameTag.. "#height");
			end;
			if getXMLInt(Xml, xmlNameTag.. "#zoomOutIn") ~= nil then
				g_currentMission.hlGui.menue.zoomOutIn = getXMLInt(Xml, xmlNameTag.. "#zoomOutIn");
			end;
			if getXMLInt(Xml, xmlNameTag.. "#position") ~= nil then
				g_currentMission.hlGui.menue.position = getXMLInt(Xml, xmlNameTag.. "#position");
			end;
			if getXMLBool(Xml, xmlNameTag.. "#smallViewHidden") then
				g_currentMission.hlGui.menue.smallViewHidden = getXMLBool(Xml, xmlNameTag.. "#smallViewHidden");
			end;
			hlGuiOverlays:setNormalDraw(true, refreshWidescreenFix);
		end;
	else
		hlGuiSetGet:saveXml();
	end;
end;

function hlGuiSetGet:saveXml()
	createFolder(getUserProfileAppPath().. "modSettings/");
	local file = getUserProfileAppPath().. "modSettings/hlGuiMenue.xml";	
	local Xml = createXMLFile("_hlGuiMenue_XML", file, "hlGui");
	local xmlNameTag = "hlGui";
	if Xml ~= nil then		
		setXMLFloat(Xml, xmlNameTag.. "#iconWidescreenFix", g_currentMission.hlGui.menue.iconWidescreenFix);
		setXMLFloat(Xml, xmlNameTag.. "#posX", g_currentMission.hlGui.menue.posX[1]);
		setXMLFloat(Xml, xmlNameTag.. "#posY", g_currentMission.hlGui.menue.posY[1]);
		setXMLFloat(Xml, xmlNameTag.. "#width", g_currentMission.hlGui.menue.width[1]);
		setXMLFloat(Xml, xmlNameTag.. "#height", g_currentMission.hlGui.menue.height[1]);
		setXMLInt(Xml, xmlNameTag.. "#zoomOutIn", g_currentMission.hlGui.menue.zoomOutIn);
		setXMLInt(Xml, xmlNameTag.. "#position", g_currentMission.hlGui.menue.position);
		setXMLBool(Xml, xmlNameTag.. "#smallViewHidden", g_currentMission.hlGui.menue.smallViewHidden);
		saveXMLFile(Xml);
	end;	
end;

--------------------------------------------------------------------------------------------------------------

function hlGuiSetGet:generateHlGuiModMenue()
	hlGuiSetGet:generateModMenue( {modName="HlGuiMenue",displayName="HL GuiMenue Settings"} );
	hlGuiSetGet:generateModPage( {modName="HlGuiMenue", displayName="Setting"} );
	hlGuiSetGet:generateModPageSide( {modName="HlGuiMenue", page=1} );
		
	local buttons = {
		[1] = {
			txtOverButton = "SmallView Icon Hidden";				
			txtButton = "Off";
			txtBoldButton = true;
			txtButtonCallback = hlGuiSetGet.txtButtonCallback;
			clickButton = "buttonOnOff";
			clickButtonColor = "red";
			clickButtonCallback = hlGuiSetGet.clickButtonCallback;
			ownTable = {whatClick="guiSmallViewHidden_"};
			txtInfo = "SmallView Icon Hidden(MouseCursor Off)";
			width = 30;
		};
		[2] = {
			visible = false;								
			width = 70;
		};
	};	
	hlGuiSetGet:generateModSideLine({modName="HlGuiMenue", page=1, side=1, lineButtons=buttons});	
end;

function hlGuiSetGet.clickButtonCallback(args)	
	if args == nil or type(args) ~= "table" or args.lineButton == nil then return;end;	
	if args.lineButton.ownTable.whatClick == "guiSmallViewHidden_" then
		g_currentMission.hlGui.menue.smallViewHidden = not g_currentMission.hlGui.menue.smallViewHidden;
		g_currentMission.hlGui.setGet:setUnSave();
	end;	
	return;
end;

function hlGuiSetGet.txtButtonCallback(args)
	if args == nil or type(args) ~= "table" or args.lineButton == nil or args.lineButton.ownTable == nil then return "";end;
	local txtButton = "";
	if args.lineButton.ownTable.whatClick == "guiSmallViewHidden_" then
		if g_currentMission.hlGui.menue.smallViewHidden then txtButton = "On";args.lineButton.clickButtonColor = "green";else txtButton = "Off";args.lineButton.clickButtonColor = "red";end;
	end;
	return txtButton;
end;	

--------------------------------------------------------------------------------------------------------------

function hlGuiSetGet:isGenerateModMenue(modName, page, side)
	if g_currentMission.hlGui.mod[modName] and page == nil and side == nil then return true;end;
	if g_currentMission.hlGui.mod[modName] and page ~= nil and g_currentMission.hlGui.mod[modName].page ~= nil and g_currentMission.hlGui.mod[modName].page[page] ~= nil and side == nil then return true;end;
	if g_currentMission.hlGui.mod[modName] and page ~= nil and g_currentMission.hlGui.mod[modName].page ~= nil and g_currentMission.hlGui.mod[modName].page[page] ~= nil 
	and side ~= nil and g_currentMission.hlGui.mod[modName].page[page].side ~= nil and g_currentMission.hlGui.mod[modName].page[page].side[side] ~= nil then return true;end;
	return false;
end;

function hlGuiSetGet:generateModMenue(args)
	if args == nil or type(args) ~= "table" or args.modName == nil then return nil;end;
	if g_currentMission.hlGui.mod[args.modName] ~= nil then return false, "modName already exists";end;
	g_currentMission.hlGui.mod[args.modName] = {isSave=false,page={}};
	if args.displayName ~= nil then g_currentMission.hlGui.mod[args.modName].displayName = tostring(args.displayName);else g_currentMission.hlGui.mod[args.modName].displayName = tostring(args.modName);end;
	if args.saveCallback ~= nil and type(args.saveCallback) == "function" then g_currentMission.hlGui.mod[args.modName].saveCallback = args.saveCallback;end;
	if args.onOpenCallback ~= nil and type(args.onOpenCallback) == "function" then g_currentMission.hlGui.mod[args.modName].onOpenCallback = args.onOpenCallback;end;
	if args.closeCallback ~= nil and type(args.closeCallback) == "function" then g_currentMission.hlGui.mod[args.modName].closeCallback = args.closeCallback;end;
	g_currentMission.hlGui.menue.modTotal = g_currentMission.hlGui.menue.modTotal+1;
	function comp(w1,w2)		
		if w1.displayName > w2.displayName then
			return true;
		end;				
	end;
	table.sort(g_currentMission.hlGui.mod, comp);
	return true;
end;

function hlGuiSetGet:generateModPage(args)
	if args == nil or type(args) ~= "table" or args.modName == nil or not hlGuiSetGet:isGenerateModMenue(args.modName) then return nil;end;
	g_currentMission.hlGui.mod[args.modName].page[#g_currentMission.hlGui.mod[args.modName].page+1] = {side={}};
	if args.displayName ~= nil then g_currentMission.hlGui.mod[args.modName].page[#g_currentMission.hlGui.mod[args.modName].page].displayName = tostring(args.displayName);else g_currentMission.hlGui.mod[args.modName].page[#g_currentMission.hlGui.mod[args.modName].page].displayName = "Page ".. tostring(#g_currentMission.hlGui.mod[args.modName].page);end;
	if args.onOpenCallback ~= nil and type(args.onOpenCallback) == "function" then g_currentMission.hlGui.mod[args.modName].page[#g_currentMission.hlGui.mod[args.modName].page].onOpenCallback = args.onOpenCallback;end;
	return true;
end;

function hlGuiSetGet:insertModPage(args)
	if args == nil or type(args) ~= "table" or args.modName == nil or args.page == nil or not hlGuiSetGet:isGenerateModMenue(args.modName) then return nil;end;
	table.insert(g_currentMission.hlGui.mod[args.modName].page, args.page, {side={}});
	if args.displayName ~= nil then g_currentMission.hlGui.mod[args.modName].page[args.page].displayName = tostring(args.displayName);else g_currentMission.hlGui.mod[args.modName].page[args.page].displayName = "Page ".. tostring(arge.page);end;
	if args.onOpenCallback ~= nil and type(args.onOpenCallback) == "function" then g_currentMission.hlGui.mod[args.modName].page[args.page].onOpenCallback = args.onOpenCallback;end;
	return true;
end;

function hlGuiSetGet:generateModPageSide(args)
	if args == nil or type(args) ~= "table" or args.modName == nil or args.page == nil or not hlGuiSetGet:isGenerateModMenue(args.modName, args.page) then return nil;end;
	g_currentMission.hlGui.mod[args.modName].page[args.page].side[#g_currentMission.hlGui.mod[args.modName].page[args.page].side+1] = {line={}, bounds={0,0,0,0}};
	if args.displayName ~= nil then g_currentMission.hlGui.mod[args.modName].page[args.page].side[#g_currentMission.hlGui.mod[args.modName].page[args.page].side].displayName = tostring(args.displayName);else	g_currentMission.hlGui.mod[args.modName].page[args.page].side[#g_currentMission.hlGui.mod[args.modName].page[args.page].side].displayName = "Side ".. tostring(#g_currentMission.hlGui.mod[args.modName].page[args.page].side);end;
	if args.otherDraw ~= nil and type(args.otherDraw) == "function" then g_currentMission.hlGui.mod[args.modName].page[args.page].side[#g_currentMission.hlGui.mod[args.modName].page[args.page].side].otherDraw = args.otherDraw;end;
	if args.onOpenCallback ~= nil and type(args.onOpenCallback) == "function" then g_currentMission.hlGui.mod[args.modName].page[args.page].side[#g_currentMission.hlGui.mod[args.modName].page[args.page].side].onOpenCallback = args.onOpenCallback;end;
	g_currentMission.hlGui.mod[args.modName].page[args.page].side[#g_currentMission.hlGui.mod[args.modName].page[args.page].side].ownTable = args.ownTable;
	return true;
end;

function hlGuiSetGet:insertModPageSide(args)
	if args == nil or type(args) ~= "table" or args.modName == nil or args.page == nil or args.side == nil or not hlGuiSetGet:isGenerateModMenue(args.modName, args.page) then return nil;end;
	table.insert(g_currentMission.hlGui.mod[args.modName].page[args.page].side, args.side, {line={}, bounds={0,0,0,0}});
	if args.displayName ~= nil then g_currentMission.hlGui.mod[args.modName].page[args.page].side[args.side].displayName = tostring(args.displayName);else g_currentMission.hlGui.mod[args.modName].page[args.page].side[args.side].displayName = "Side ".. tostring(args.side);end;
	if args.otherDraw ~= nil and type(args.otherDraw) == "function" then g_currentMission.hlGui.mod[args.modName].page[args.page].side[args.side].otherDraw = args.otherDraw;end;
	if args.onOpenCallback ~= nil and type(args.onOpenCallback) == "function" then g_currentMission.hlGui.mod[args.modName].page[args.page].side[args.side].onOpenCallback = args.onOpenCallback;end;
	g_currentMission.hlGui.mod[args.modName].page[args.page].side[args.side].ownTable = args.ownTable;
	return true;
end;

function hlGuiSetGet:generateModSideLine(args)
	if args == nil or type(args) ~= "table" or args.modName == nil or args.page == nil or args.side == nil or not hlGuiSetGet:isGenerateModMenue(args.modName, args.page, args.side) then return nil;end;
	local modTable = g_currentMission.hlGui.mod[args.modName].page[args.page].side[args.side].line;
	args.line = #modTable+1
	return hlGuiSetGet:insertModSideLine(args, true);
end;

function hlGuiSetGet:insertModSideLine(args, intern)
	if intern == nil and (args == nil or type(args) ~= "table" or args.modName == nil or args.page == nil or args.side == nil or args.line == nil or not hlGuiSetGet:isGenerateModMenue(args.modName, args.page, args.side)) then return nil;end;
	table.insert(g_currentMission.hlGui.mod[args.modName].page[args.page].side[args.side].line, args.line, {button={},view=false,empty=false});
	if g_currentMission.hlGui.mod[args.modName].page[args.page].side[args.side].bounds[1] > 0 then g_currentMission.hlGui.mod[args.modName].page[args.page].side[args.side].bounds = {0,0,0,0};end;
	local lineTable = g_currentMission.hlGui.mod[args.modName].page[args.page].side[args.side].line[args.line];
	if args.otherDraw ~= nil and type(args.otherDraw) == "function" then lineTable.otherDraw = args.otherDraw;lineTable.empty = true;lineTable.ownTable = args.ownTable;return true;end;
	if args.lineButtons == nil or type(args.lineButtons) ~= "table" then lineTable.empty = true;return true;end;	
	local buttonTable = g_currentMission.hlGui.mod[args.modName].page[args.page].side[args.side].line[args.line].button;
	for button=1, #args.lineButtons do
		if args.lineButtons[button] ~= nil then
			buttonTable[#buttonTable+1] = {};
			local isButtonTable = buttonTable[#buttonTable];
			local isArgsButton = args.lineButtons[button];						
			if isArgsButton.txtOverButton ~= nil then 
				isButtonTable.txtOverButton = tostring(isArgsButton.txtOverButton);
				if isArgsButton.txtOverButtonColor ~= nil then isButtonTable.txtOverButtonColor = tostring(isArgsButton.txtOverButtonColor);end;
			end;
			if isArgsButton.groundButton ~= nil then isButtonTable.groundButton = isArgsButton.groundButton;else isButtonTable.groundButton = true;end;
			if isArgsButton.groundButtonColor ~= nil then isButtonTable.groundButtonColor = tostring(isArgsButton.groundButtonColor);end;
			if isArgsButton.clickButton ~= nil and g_currentMission.hlGui.menue.acceptButtons[isArgsButton.clickButton] ~= nil then 
				isButtonTable.clickButton = g_currentMission.hlGui.menue.acceptButtons[isArgsButton.clickButton];
				if isArgsButton.clickButtonCallback ~= nil and type(isArgsButton.clickButtonCallback) == "function" then isButtonTable.clickButtonCallback = isArgsButton.clickButtonCallback;end;
				if isArgsButton.clickButtonColor ~= nil then isButtonTable.clickButtonColor = tostring(isArgsButton.clickButtonColor);end;
			end;
			if isArgsButton.txtButton ~= nil then 
				isButtonTable.txtButton = tostring(isArgsButton.txtButton);
				isButtonTable.txtBoldButton = isArgsButton.txtBoldButton or false;
				if isArgsButton.txtButtonCallback ~= nil and type(isArgsButton.txtButtonCallback) == "function" then isButtonTable.txtButtonCallback = isArgsButton.txtButtonCallback;end;
				if isArgsButton.txtButtonColor ~= nil then isButtonTable.txtButtonColor = tostring(isArgsButton.txtButtonColor);end;
			end;			
			if isArgsButton.txtHelp ~= nil then isButtonTable.txtHelp = tostring(isArgsButton.txtHelp);end;
			if isArgsButton.txtInfo ~= nil then isButtonTable.txtInfo = tostring(isArgsButton.txtInfo);end;
			if isArgsButton.visible ~= nil then isButtonTable.visible = isArgsButton.visible;else isButtonTable.visible = true;end;
			if not isButtonTable.visible and isArgsButton.headLine and isArgsButton.txtHeadLine then
				isButtonTable.headLine = true;
				isButtonTable.txtHeadLine = tostring(isArgsButton.txtHeadLine);
				if isArgsButton.txtHeadLineColor ~= nil then isButtonTable.txtHeadLineColor = tostring(isArgsButton.txtHeadLineColor);end;
			end;
			if isArgsButton.ownTable ~= nil then isButtonTable.ownTable = isArgsButton.ownTable;end;
			if isArgsButton.width ~= nil and type(isArgsButton.width) == "number" then isButtonTable.width = isArgsButton.width;end;
			if isArgsButton.pullDownButton ~= nil and isArgsButton.pullDownButton and isArgsButton.pullDownCallback ~= nil and type(isArgsButton.pullDownCallback) == "function" then 
				if isArgsButton.pullDownMultipleSelect ~= nil then isButtonTable.pullDownMultipleSelect = isArgsButton.pullDownMultipleSelect;else isButtonTable.pullDownMultipleSelect = false;end;
				isButtonTable.pullDownButton = true;
				isButtonTable.pullDownCallback = isArgsButton.pullDownCallback;
				isButtonTable.clickButton = "buttonDown";
				isButtonTable.clickButtonCallback = nil;
				isButtonTable.clickButtonColor = nil;				
			else
				isButtonTable.pullDownButton = false;
			end;
		end;
	end;
	return true;
end;


































