viDraw = {};
source(VehicleInspector.modDir.."scripte/draw/viDrawSettingLine.lua");
source(VehicleInspector.modDir.."scripte/draw/viDrawIcons.lua");
source(VehicleInspector.modDir.."scripte/draw/viDrawPreviewVehicleData.lua");

function viDraw:setOpen()
	VehicleInspector.clickAreas.slave["default"] = {};
	VehicleInspector.clickAreas.master["default"] = {};
	--if VehicleInspector.global.foundMoh and VehicleInspector.global.onlyMoh then VehicleInspector.isVisible=false;return;end;
	function setSettingLine()
		if viSetGet:canSettingLine() then
			viDrawSettingLine:setOpen(0);	
		end;
	end;
	if not viSetGet:helpMenue() or not viSetGet:inGameMapMenu() then VehicleInspector.isVisible=false;setSettingLine();return;end;
	setSettingLine();
	if VehicleInspector.global.isHidden then VehicleInspector.isVisible=false;return;end;
	viOutput:loadVehicle(true,false);
	if VehicleInspector.output == nil or #VehicleInspector.output <= 0 then VehicleInspector.isVisible=false;return;end;
	VehicleInspector.isVisible = true;
	local posX = VehicleInspector.global.posX[VehicleInspector.global.viewModus];
	local posY = VehicleInspector.global.posY[VehicleInspector.global.viewModus];
	local width = 0; --VehicleInspector.global.width[VehicleInspector.global.viewModus];
	local height = 0; --VehicleInspector.global.height[VehicleInspector.global.viewModus];
	--local lastWidth = VehicleInspector.global.width.last;
	--local lastHeight = VehicleInspector.global.height.last;
	local endPosY = viSetGet:getEndPosY(); --g_currentMission.hlGui.menue.posY[2]+g_currentMission.hlGui.menue.height[2]; --VehicleInspector.inGameMapMenu
	local txtSize = VehicleInspector.global.txtSize;
	local txtHeight = getTextHeight(txtSize, utf8Substr("Äg", 0));	
	local txtWidthDistance = VehicleInspector.global.txtWidthDistance;
	local txtLineDistance = VehicleInspector.global.txtLineDistance;	
	local separatorColor = g_currentMission.hl.getColor(VehicleInspector.showColor.separator, true);
	local blinkTimeColor = g_currentMission.hl.getColor(VehicleInspector.showColor.remainTime, true);
	local txt = "";
	local isToLarge = false;
	local disableClickArea = g_currentMission.hl.dragDrop.on or not g_currentMission.hl.isMouseCursor;
	if VehicleInspector.global.seeBackground then VehicleInspector.overlays["ground"]:render();end;
		
	local nextPosY = posY-txtHeight-(txtLineDistance);
	local nextPosX = posX+0.001;	
	for line=1, #VehicleInspector.output do
		local isLine = VehicleInspector.output[line];
		if isLine ~= nil and isLine.txt ~= nil and #isLine.txt > 0 then
			local txtWidth = 0;
			nextPosX = posX+0.001;
			for outputTxt=1, #isLine.txt do
				local isTxt = isLine.txt[outputTxt];				
				if isTxt ~= nil then
					setTextAlignment(0);
					if isTxt.separator then
						setTextColor(unpack(separatorColor));							
						setTextBold(false);
						renderText(nextPosX, nextPosY, txtSize, tostring(VehicleInspector.txt.separator));
						txtWidth = txtWidth+getTextWidth(txtSize, utf8Substr(VehicleInspector.txt.separator, 0))+txtWidthDistance;
					else
						txt = utf8Substr(isTxt.txt, 0);
						setTextColor(unpack(isTxt.txtColor));							
						setTextBold(isTxt.txtBold);
						renderText(nextPosX, nextPosY, txtSize, tostring(txt));					
						txtWidth = txtWidth+getTextWidth(txtSize, txt)+txtWidthDistance;
					end;					
					setTextAlignment(0);
					setTextColor(1, 1, 1, 1);
					setTextBold(false);
					nextPosX = posX+0.001+txtWidth;
				end;				
			end;			
			if width < txtWidth then width = txtWidth;end; --for background
			txt = "";
			if isLine.rootNode ~= nil and isLine.rootNode > 0 and not disableClickArea then viDraw:clickAreas(false, {posX, nextPosX, nextPosY, nextPosY+txtHeight+txtLineDistance, whereClick="vehicleJoin_", rootNode=isLine.rootNode, line=line, tableType="output"} );end; 
					
			if isLine.rootNode ~= nil and isLine.rootNode > 0 and g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers["viJobBlinkingTime_".. tostring(isLine.rootNode)] ~= nil and not g_currentMission.hl.timers["viJobBlinkingTime_".. tostring(isLine.rootNode)].repeatable then
				if g_currentMission.hl.runsTimer("1sec", true) then
					local blinkTxtWidth = getTextWidth(txtSize, ">>")+txtWidthDistance;
					setTextColor(unpack(blinkTimeColor));
					setTextBold(true);
					renderText(posX-0.001-blinkTxtWidth, nextPosY, txtSize, ">>");
					setTextBold(false);
					setTextColor(1, 1, 1, 1);
				end;			
			end;
			if line ~= #VehicleInspector.output then nextPosY = nextPosY-txtHeight-txtLineDistance;end;
			if nextPosY-txtHeight-txtLineDistance < endPosY then isToLarge=true;break;end;
		end;
	end;	
	height = posY-nextPosY+txtLineDistance;			 
	VehicleInspector.global.width[VehicleInspector.global.viewModus] = width+0.002; 
	VehicleInspector.global.height[VehicleInspector.global.viewModus] = height;		
	if not disableClickArea then viDraw:clickAreas(true, {posX, posX+(width+0.002), nextPosY-txtLineDistance, nextPosY-txtLineDistance+height} );end;
	if VehicleInspector.global.seeBackground then
		if VehicleInspector.overlays["ground"].a ~= VehicleInspector.global.backgroundT then 
			local backgroundColor = g_currentMission.hl.getColor(VehicleInspector.showColor.background, true);
			backgroundColor[4] = VehicleInspector.global.backgroundT;
			VehicleInspector:get_hl("setBackgroundColor", {VehicleInspector.overlays["ground"], backgroundColor}, "viDraw:setOpen()");
		end;
		g_currentMission.hl.setOverlay(VehicleInspector.overlays["ground"], posX, nextPosY-txtLineDistance, width+0.002, height);
	end;
	if isToLarge then VehicleInspector.global.toLarge = true;else VehicleInspector.global.toLarge = false;end;
	if isToLarge and g_currentMission.hl.runsTimer("1sec", true) then
		setTextBold(true);
		setTextColor(unpack(g_currentMission.hl.getColor("ls22", true)));
		renderText(posX+0.001, nextPosY, txtSize, tostring("! to large !"));
		setTextColor(1, 1, 1, 1);
		setTextBold(false);
	end;	
end;

function viDraw:setOpenWidth()
	if g_currentMission.controlledVehicle ~= nil and g_currentMission.controlledVehicle.getSelectedObject ~= nil and g_currentMission.controlledVehicle.spec_rideable == nil then
		local aw, wTxt, txt = viSetGet:getWidth(g_currentMission.controlledVehicle);
		if aw <= 0 then return;end;
		local isOkay, x, y, w, h, size = viSetGet:getSpeedMeterData();
		if isOkay then
			local txtWidth = getTextWidth(size, tostring(txt).. " ".. tostring(wTxt).. "m");
			--setTextAlignment(RenderText.ALIGN_CENTER);
			setTextBold(true);
			setTextColor(unpack(g_currentMission.hl.getColor("ls22", true)));
			renderText(x-(txtWidth/2), y, size, tostring(txt).. " ".. tostring(wTxt).. "m");
			setTextColor(1, 1, 1, 1);
			setTextBold(false);
			--setTextAlignment(0);
		end;
	end;
end;

function viDraw:setOpenTipSide()
	if g_currentMission.controlledVehicle ~= nil and g_currentMission.controlledVehicle.getSelectedObject ~= nil and g_currentMission.controlledVehicle.spec_rideable == nil then
		local ts, txt = viSetGet:getTipSide(g_currentMission.controlledVehicle);
		if ts == nil or ts <= 0 then return;end;
		local isOkay, x, y, w, h, w1, isDocked = viSetGet:getVehicleSchemaData();
		if isOkay then
			if isDocked and VehicleInspector.global.viewUnloadSide.state == 2 then return;end;
			local size = g_currentMission.hl.optiHeightSize(h, tostring(txt), VehicleInspector.global.viewUnloadSide.size)+(VehicleInspector.global.viewUnloadSide.cSize/1000);
			if VehicleInspector.global.viewUnloadSide.pos == 1 then
				local txtHeight = getTextHeight(size, tostring(txt));
				setTextBold(true);
				setTextColor(unpack(g_currentMission.hl.getColor("ls22", true)));
				if isDocked then									
					renderText(g_safeFrameOffsetX, y+h, size, tostring(txt));
				else
					renderText(x+w, y+(h/2)-(txtHeight/2), size, " ".. tostring(txt));
				end;
				--setTextAlignment(0);
				setTextColor(1, 1, 1, 1);
				setTextBold(false);
			end;			
		end;
	end;
end;

function viDraw:setAttachedDamage()
	if VehicleInspector.attachedDamageBar == nil or VehicleInspector.attachedDamageBar.overlay == nil then return;end;
	if g_currentMission.controlledVehicle ~= nil and g_currentMission.controlledVehicle.getSelectedObject ~= nil and g_currentMission.controlledVehicle.spec_rideable == nil then
		local isOkay, damage = viSetGet:getAttachedDamage(g_currentMission.controlledVehicle);
		if isOkay and g_currentMission.inGameMenu.hud.speedMeter ~= nil then
			local speedMeter = g_currentMission.inGameMenu.hud.speedMeter;
			if VehicleInspector.attachedDamageBar ~= nil and VehicleInspector.attachedDamageBar.overlay ~= nil then
				VehicleInspector.attachedDamageBar:setAlpha(1);
				local color = speedMeter.COLOR.DAMAGE_GAUGE;
				if damage < 0.2 then
					color = speedMeter.COLOR.DAMAGE_GAUGE_LOW;
				end;
				VehicleInspector.attachedDamageBar:setValue(damage, "DAMAGE");
				VehicleInspector.attachedDamageBar:setBarColor(color[1], color[2], color[3]);								
			end;
		else
			VehicleInspector.attachedDamageBar:setAlpha(0);
		end;
	end;	
end;

function viDraw:clickAreas(masterArea, args)		
	if masterArea then
		VehicleInspector.clickAreas.master["default"] = {
			args[1]; --posX
			args[2]; --posX1
			args[3]; --posY
			args[4]; --posY1
			whichArea="default";
		};
	else	
		VehicleInspector.clickAreas.slave["default"][#VehicleInspector.clickAreas.slave["default"]+1] = {
			args[1]; --posX
			args[2]; --posX1
			args[3]; --posY
			args[4]; --posY1
			whatClick = "default";
			whereClick = args.whereClick;
			rootNode = args.rootNode;
			line = args.line;
			tableType = args.tableType;
		};
	end;
end;