viDrawPreviewVehicleData = {};

function viDrawPreviewVehicleData:setOpen(clickTable)
	if clickTable == nil or clickTable.line == nil or clickTable.line == 0 or clickTable.tableType == nil then return;end;
	local vehicleData = VehicleInspector[clickTable.tableType][clickTable.line];
	if not vehicleData.isTrain and vehicleData ~= nil and vehicleData.rootNode ~= nil and vehicleData.rootNode > 0 then
		local iconTxtHeight = getTextHeight(0.11, utf8Substr("Äg", 0));
		local iconHeight = iconTxtHeight; 
		local iconWidescreenFix = 1.6+(VehicleInspector.global.iconWidescreenFix); --breitbild fix
		local iconWidth = iconTxtHeight/iconWidescreenFix;
		local posX = 0.5-(iconWidth/2);
		local posY = 0.5-iconHeight;
		local nextPosY = posY;
		local nextPosX = posX;		
		local attachedIconHeight = iconHeight/2;
		local attachedIconWidth = iconWidth/2;
		local groundOverlay = VehicleInspector.overlays["previewGround"];		
		local overlay;
		local attachedOverlay;
		if VehicleInspector.storeOverlays[vehicleData.storeName] ~= nil then
			g_currentMission.hl.setOverlay(groundOverlay, posX-0.002, posY, iconWidth+0.004, iconHeight);
			groundOverlay:render();
			overlay = VehicleInspector.storeOverlays[vehicleData.storeName];
			g_currentMission.hl.setOverlay(overlay, posX, posY, iconWidth, iconHeight);												
			overlay:render();			
			if vehicleData.totalAttached > 0 and #vehicleData.attached > 0 then
				nextPosY = nextPosY-attachedIconHeight-0.002;				
				local setAttachedOverlays = {};
				for o=1, #vehicleData.attached do
					if vehicleData.attached[o] ~= nil then							
						local object = g_currentMission:getNodeObject(vehicleData.attached[o].rootNode);
						if object ~= nil then
							local vehicleName = tostring(object.getName(object));
							if vehicleName ~= nil and VehicleInspector.storeOverlays[vehicleName] ~= nil then
								table.insert(setAttachedOverlays, vehicleName);								
							end;
						end;
					end;
				end;
				if #setAttachedOverlays > 0 then
					local startPosX = posX+(iconWidth/2)-(attachedIconWidth/2*#setAttachedOverlays);
					nextPosX = startPosX;
					g_currentMission.hl.setOverlay(groundOverlay, startPosX-0.002, nextPosY, attachedIconWidth*#setAttachedOverlays+0.004, attachedIconHeight);
					groundOverlay:render();
					for o=1, #setAttachedOverlays do
						attachedOverlay = VehicleInspector.storeOverlays[setAttachedOverlays[o]];
						g_currentMission.hl.setOverlay(attachedOverlay, nextPosX, nextPosY, attachedIconWidth, attachedIconHeight);												
						attachedOverlay:render();
						nextPosX = nextPosX+attachedIconWidth;
					end;
				end;
			end;
		end;		
	end;
end;

function viDrawPreviewVehicleData:setFillTypesShowInfo()
	if g_currentMission.controlledVehicle ~= nil then VehicleInspector.previewVehicleFillTypes = {};return;end;
	local viewMax = 90;
	local isToLarge = false;
	local height = {{1,15},{16,30},{31,45},{46,60},{61,75},{76,95}};
	local maxHeight = 1;
	local length = #VehicleInspector.previewVehicleFillTypes;
	if length > 15 and length <= 30 then maxHeight = 2;elseif length > 30 and length <=45 then maxHeight = 3;elseif length > 45 and length <= 60 then maxHeight = 4;elseif length > 60 and length <= 75 then maxHeight = 5;elseif length > 75 and length <= viewMax then maxHeight = 5;
	elseif length > viewMax then isToLarge = true;end;
	local iconTxtHeight = getTextHeight(0.020, utf8Substr("Äg", 0));
	local iconHeight = iconTxtHeight; 
	local iconWidescreenFix = 1.6+(VehicleInspector.global.iconWidescreenFix); --breitbild fix
	local iconWidth = iconTxtHeight/iconWidescreenFix;
	local widthDif = 0.001;
	local heightDif = 0.001;	
	local posX = 0.5;
	local posY = 0.55;
	if length > 0 then
		local groundOverlay = VehicleInspector.overlays["roundGround"];		
		local isLength = 15;
		if length < 15 then isLength = length;end;
		for h=1, maxHeight do
			posX = 0.5-(((iconWidth+widthDif)*isLength)/2);
			for f=height[h][1], height[h][2] do				
				if VehicleInspector.previewVehicleFillTypes[f] ~= nil then
					if VehicleInspector.fillTypeOverlays[VehicleInspector.previewVehicleFillTypes[f]] ~= nil then
						local overlay = VehicleInspector.fillTypeOverlays[VehicleInspector.previewVehicleFillTypes[f]];
						if overlay ~= nil then
							g_currentMission.hl.setOverlay(groundOverlay, posX, posY, iconWidth, iconHeight);
							groundOverlay:render();
							g_currentMission.hl.setOverlay(overlay, posX, posY, iconWidth, iconHeight);
							overlay:render();
							posX = posX+iconWidth+widthDif;
						end;			
					end;
				else
					break;
				end;
			end;			
			posY = posY+iconHeight+heightDif;
		end;		
		if isToLarge and g_currentMission.hl.runsTimer("1sec", true) then
			posX = 0.5-(((iconWidth+widthDif)*15)/2);
			setTextBold(true);
			setTextColor(unpack(g_currentMission.hl.getColor("ls22", true)));
			renderText(posX, posY+heightDif, 0.015, tostring("! to large !"));
			setTextColor(1, 1, 1, 1);
			setTextBold(false);
		end;		
	end;
end;