viDrawSettingLine = {};

function viDrawSettingLine:setOpen(lineHeight)
	VehicleInspector.clickAreas.slave["setting"] = {};
	VehicleInspector.clickAreas.master["setting"] = {};
	if VehicleInspector.helpMenu == nil then return;end;
	local posX = VehicleInspector.global.posX[VehicleInspector.global.viewModus];
	local posY = VehicleInspector.global.posY[VehicleInspector.global.viewModus];
			
	local height = viSetGet:getSettingLineHeight();
	local width = VehicleInspector.helpMenu.overlay.width;
	local txtSize = VehicleInspector.global.txtSize;
	local txtHeight = getTextHeight(txtSize, utf8Substr("Äg", 0));
	local txtLineDistance = VehicleInspector.global.txtLineDistance;
	local txtWidthDistance = 0.0015;
	local iconHeight = txtHeight; 
	local iconWidescreenFix = 1.6+(VehicleInspector.global.iconWidescreenFix); --breitbild fix
	local iconWidth = txtHeight/iconWidescreenFix;	
	local colorOn = g_currentMission.hl.getColor("green", true);
	local colorOff = g_currentMission.hl.getColor("darkGray", true);	
	local ls22Color = g_currentMission.hl.getColor("ls22", true);
	local disableClickArea = g_currentMission.hl.dragDrop.on or not g_currentMission.hl.isMouseCursor;
	local color = colorOff;
	
	posY = posY;
	local overlay = VehicleInspector.overlays["settingGround"];	
	local tempOverlay = VehicleInspector.overlays["settingGround"];
	g_currentMission.hl.setOverlay(overlay, posX, posY, width, height);
	overlay:render();
	if not disableClickArea then viDrawSettingLine:clickAreas(true, {posX, posX+width, posY, posY+height} );end;
	
	local maxCategory = VehicleInspector.vehicleTypeCategoryNumber.maxVisible; --VehicleInspector.vehicleTypeCategoryNumber.max;
	local iconPosY = posY+(txtLineDistance/2);
	local iconLeftPosX = posX+0.001;
	local iconRightPosX = posX+width-iconWidth-0.001;
	local maxIconWidth = g_currentMission.hl.getMaxIconWidth(iconRightPosX-iconLeftPosX, iconWidth+(txtWidthDistance*2));
	
	if maxCategory > maxIconWidth then color = ls22Color;else color = colorOff;end;
	overlay = VehicleInspector.overlays["buttonLeft"];
	g_currentMission.hl.setOverlay(overlay, iconLeftPosX, iconPosY, iconWidth, iconHeight);
	g_currentMission.hl.setBackgroundColor(overlay, color);
	overlay:render();
	overlay = VehicleInspector.overlays["buttonRight"];
	g_currentMission.hl.setOverlay(overlay, iconRightPosX, iconPosY, iconWidth, iconHeight);
	g_currentMission.hl.setBackgroundColor(overlay, color);
	overlay:render();	
	iconLeftPosX = iconLeftPosX+iconWidth+txtWidthDistance;
	--default 3
	if maxIconWidth > 0 then
		overlay = VehicleInspector.overlays["view"];
		if overlay ~= nil then
			g_currentMission.hl.setOverlay(overlay, iconLeftPosX, iconPosY, iconWidth, iconHeight);
			color = colorOn;
			if VehicleInspector.global.isHidden then color = colorOff;end;
			g_currentMission.hl.setBackgroundColor(overlay, color);
			overlay:render();
			if not disableClickArea then viDrawSettingLine:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+height, whereClick="viewHidden_"} );end;
			maxIconWidth = maxIconWidth-1;
			iconLeftPosX = iconLeftPosX+iconWidth+txtWidthDistance;
			if maxIconWidth <= 0 then return;end;
		end;		
		
		overlay = VehicleInspector.overlays["forceView"];		
		if overlay ~= nil then
			color = ls22Color;
			if VehicleInspector.global.forceView > 0 and g_currentMission.hl.runsTimer("7sec", true) and not g_currentMission.hl.isMouseCursor then
				local txt = tostring(VehicleInspector.global.forceView);
				local optiSize = g_currentMission.hl.optiHeightSize(iconHeight, txt, 0.012)-0.0005;				
				local txtWidth = getTextWidth(optiSize, utf8Substr(txt, 0));				
				setTextBold(true);	
				setTextColor(unpack(color));		
				renderText(iconLeftPosX+(iconWidth/2)-(txtWidth/2), iconPosY+(iconHeight/2)-(txtHeight/3), optiSize, txt);
				setTextBold(false);		
				setTextColor(1, 1, 1, 1);
			else
				g_currentMission.hl.setOverlay(overlay, iconLeftPosX, iconPosY, iconWidth, iconHeight);		
				if VehicleInspector.global.forceView == 0 then color = colorOff;end;
				g_currentMission.hl.setBackgroundColor(overlay, color);
				overlay:render();
			end;	
			if not disableClickArea then viDrawSettingLine:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+height, whereClick="viewForce_"} );end;
			maxIconWidth = maxIconWidth-1;			
			iconLeftPosX = iconLeftPosX+iconWidth+txtWidthDistance;
			if maxIconWidth <= 0 then return;end;
		end;		
		overlay = VehicleInspector.overlays["sort1"];		
		if VehicleInspector.global.sortBy > 0 then
			tempOverlay = VehicleInspector.categoryOverlays[VehicleInspector.global.sortBy];			
		end;
		if overlay ~= nil then
			color = ls22Color;
			if VehicleInspector.global.sortBy > 0 and tempOverlay ~= nil and g_currentMission.hl.runsTimer("7sec", true) and not g_currentMission.hl.isMouseCursor then
				g_currentMission.hl.setOverlay(tempOverlay, iconLeftPosX, iconPosY, iconWidth, iconHeight);
				g_currentMission.hl.setBackgroundColor(tempOverlay, color);
				tempOverlay:render();
			else
				g_currentMission.hl.setOverlay(overlay, iconLeftPosX, iconPosY, iconWidth, iconHeight);				
				if VehicleInspector.global.sortBy == 0 then color = colorOff;end;
				g_currentMission.hl.setBackgroundColor(overlay, color);
				overlay:render();
			end;
			if not disableClickArea then viDrawSettingLine:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+height, whereClick="viewSortByCategory_"} );end;
			maxIconWidth = maxIconWidth-1;
			iconLeftPosX = iconLeftPosX+iconWidth+txtWidthDistance;
			if maxIconWidth <= 0 then return;end;
		end;
	end;
	if maxIconWidth > 0 then		
		for o=1, #VehicleInspector.categoryOverlays do
			overlay = VehicleInspector.categoryOverlays[o];
			if overlay ~= nil and overlay.view ~= nil and overlay.view and VehicleInspector.vehicleTypeCategoryViewSettingLine[tostring(overlay.category)] ~= nil and VehicleInspector.vehicleTypeCategoryViewSettingLine[tostring(overlay.category)][1] then
				g_currentMission.hl.setOverlay(overlay, iconLeftPosX, iconPosY, iconWidth, iconHeight);
				color = colorOn;				
				if not VehicleInspector.seeVehicle[overlay.category] then color = colorOff;end;
				g_currentMission.hl.setBackgroundColor(overlay, color);
				overlay:render();
				if not disableClickArea then viDrawSettingLine:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+height, whereClick=tostring(overlay.category).."_"} );end;
				maxIconWidth = maxIconWidth-1;
				iconLeftPosX = iconLeftPosX+iconWidth+txtWidthDistance;
				if maxIconWidth <= 0 then break;end;
			end;
		end;		
	end;
end;

function viDrawSettingLine:clickAreas(masterArea, args)		
	if masterArea then
		VehicleInspector.clickAreas.master["setting"] = {
			args[1]; --posX
			args[2]; --posX1
			args[3]; --posY
			args[4]; --posY1
			whichArea="setting";
		};
	else	
		VehicleInspector.clickAreas.slave["setting"][#VehicleInspector.clickAreas.slave["setting"]+1] = {
			args[1]; --posX
			args[2]; --posX1
			args[3]; --posY
			args[4]; --posY1
			whatClick = "setting";
			whereClick = args.whereClick;			
		};
	end;
end;