viOutput = {};

function viOutput:loadVehicle()
	VehicleInspector.output = {}; --new	
	local output = {};
	local outputNotOwnVehicle = {};
	local playerFarmId = g_currentMission.player.farmId;
	if g_currentMission ~= nil and g_currentMission.vehicles ~= nil then
		local txtColorDefault = g_currentMission.hl.getColor(VehicleInspector.showColor.txt, true);		
		local color = nil;		
		local farmTables = viSetGet:getFarmIdTables({}, playerFarmId);
		for v=1, #g_currentMission.vehicles do
			local vehicle = g_currentMission.vehicles[v];			
			if vehicle ~= nil and vehicle.finishedLoading == true and vehicle.getIsControlled ~= nil and Utils.getNoNil(vehicle.viCategoryName, "free") ~= "nosupport" then --by Achimobil (vehicle.finishedLoading == true)
				if vehicle.viJobActive == nil then vehicle.viJobActive = false;vehicle.viBlinking = false;end;
				local fillNameToFillLevelSeparator = VehicleInspector.txt.fillNameToFillLevel;
				local helperTxt = VehicleInspector.txt.isHelper;
				local trainTxt = VehicleInspector.txt.isTrain;			
				local playerTxt = VehicleInspector.txt.isPlayer;				
				local saEmptyTxt = VehicleInspector.txt.isSaEmpty;
				local saOrFillTxt = VehicleInspector.txt.isSaOrFill;
				local saTxt = VehicleInspector.txt.isSa;
				local waterTxt = VehicleInspector.txt.isWater;
				local damageTxt = VehicleInspector.txt.isDamage;
				local objectTxt = VehicleInspector.txt.isObject;
				local blockingTxt = VehicleInspector.txt.isBlocking;
				local overloadTxt = VehicleInspector.txt.isOverload;
				local waitTxt = "*Wait* ";
				local fuelEmptyTxt = VehicleInspector.txt.isFuelEmpty;
				local fullTxt = VehicleInspector.txt.isFillLevelFull;
				local leasingTxt = VehicleInspector.txt.isLeasing;				
				local fieldTxt = VehicleInspector.txt.isField;
				local speedTxt = VehicleInspector.txt.speed;
				local parkingTxt = VehicleInspector.txt.isParking;
				local horseTxt = VehicleInspector.txt.isHorse;
				local gpsTxt = VehicleInspector.txt.isGps;
				
				local adRemainingString = "";
				local cpRemainingString = "";
				local blinkingTime = VehicleInspector.global.helperJobEndTimeBlinking;
				local adErrorHelper = vehicle.getIsAIActive ~= nil and vehicle:getIsAIActive(); --for AD helper Bug Version >2.0.0.5
				local isHelper = (vehicle.getCurrentHelper ~= nil and vehicle.getCurrentHelper(vehicle)) or adErrorHelper;				
				local isPlayer = vehicle.getIsControlled(vehicle);
				local isOwnFarmVehicle = playerFarmId == vehicle.ownerFarmId;
				local isTrain = vehicle.trainSystem ~= nil;
				local isHorse = vehicle.spec_rideable ~= nil;
				local isLeasing = vehicle.propertyState == 2;
				local isGps = vehicle.spec_globalPositioningSystem ~= nil and vehicle.spec_globalPositioningSystem.hasGuidanceSystem;				
				local isGpsActive = isGps and vehicle.spec_globalPositioningSystem.lastInputValues.guidanceIsActive;
				local canJob = vehicle.getJob ~= nil;
				local isJob = false;
				local isAdJob = vehicle.spec_autodrive ~= nil and vehicle.ad ~= nil and vehicle.ad.stateModule:isActive();
				local canParking = vehicle.spec_parkvehicle ~= nil;
				local setSeparator = false;
				local playerName = "";
				local otherPlayer = false;
				
				---new 1.77--
				local stopThisOutput = false;	
				if VehicleInspector.seeVehicle.onlyControlled and not isPlayer and not isHelper and not vehicle.viBlinking then stopThisOutput = true;end;
				---new 1.77--
				if not stopThisOutput then --better for performenc;
					local attach, attachedSprayerAnd = viSetGet:getAttachedAndSprayerAnd(vehicle, 0);
					output[#output+1] = {txt={}, rootNode=Utils.getNoNil(vehicle.rootNode, 0), categorySort=VehicleInspector.global.sortBy,viCategoryName=tostring(vehicle.viCategoryName), vehicleName=tostring(vehicle.getName(vehicle))};
					if output[#output].viCategoryName == "unknown" then output[#output].viCategoryName = "other";end;
					output[#output].sortCategory = VehicleInspector.vehicleTypeCategoryNumber[output[#output].viCategoryName] == VehicleInspector.global.sortBy;
					local lineTxt = output[#output].txt;
					
					---for previewVehicleData---
					local attached = viSetGet:getAttached(vehicle, {});
					output[#output].storeName = tostring(output[#output].vehicleName);
					output[#output].isTrain = isTrain;
					if attached ~= nil and #attached > 0 then
						output[#output].totalAttached = #attached;
						output[#output].attached = attached;
					else
						output[#output].totalAttached = 0;
					end;
					---for previewVehicleData---
					
					if VehicleInspector.seeTxt.horse and isHorse and isPlayer then
						if setSeparator then lineTxt[#lineTxt+1] = {};lineTxt[#lineTxt].separator = true;end;
						lineTxt[#lineTxt+1] = {};
						lineTxt[#lineTxt].txt = tostring(horseTxt);
						lineTxt[#lineTxt].txtColor = txtColorDefault;
						lineTxt[#lineTxt].txtBold = true;					
						lineTxt[#lineTxt].typ = "horse";
						setSeparator = true;
					end;				
				
					if canJob then					
						local job = vehicle:getJob();
						if job ~= nil then						
							isJob = true;
							if VehicleInspector.seeTxt.jobTypeTxt > 0 then
								if setSeparator then lineTxt[#lineTxt+1] = {};lineTxt[#lineTxt].separator = true;end;						
								local jobType = g_currentMission.aiJobTypeManager:getJobTypeByIndex(job.jobTypeIndex);						
								lineTxt[#lineTxt+1] = {};
								if VehicleInspector.seeTxt.jobTypeTxt == 2 then
									lineTxt[#lineTxt].txt = tostring(viSetGet:getJobTypeIconTxt(job.jobTypeIndex, false));
								else
									lineTxt[#lineTxt].txt = tostring(jobType.title);
								end;
								lineTxt[#lineTxt].txtColor = txtColorDefault;
								lineTxt[#lineTxt].txtBold = VehicleInspector.txt.bold;					
								lineTxt[#lineTxt].typ = "jobName";
								setSeparator = true;
							end;
						end;
					end;
					if not isJob and isAdJob then
						local jobType, index = viSetGet:getAdJobType(vehicle);
						if jobType ~= nil and VehicleInspector.seeTxt.jobTypeTxt > 0 then
							if setSeparator then lineTxt[#lineTxt+1] = {};lineTxt[#lineTxt].separator = true;end;													
							lineTxt[#lineTxt+1] = {};
							if VehicleInspector.seeTxt.jobTypeTxt == 2 then
								lineTxt[#lineTxt].txt = tostring(viSetGet:getJobTypeIconTxt(index, true));
							else
								lineTxt[#lineTxt].txt = tostring(jobType);
							end;
							lineTxt[#lineTxt].txtColor = txtColorDefault;
							lineTxt[#lineTxt].txtBold = VehicleInspector.txt.bold;					
							lineTxt[#lineTxt].typ = "jobName";
							setSeparator = true;
						end;
						if jobType == nil then isAdJob = false;end;
					end;
					if VehicleInspector.seeTxt.adRemaining.state > 0 and ((VehicleInspector.global.foundMoh and VehicleInspector.seeTxt.adRemaining.mohVisible) or (not VehicleInspector.global.foundMoh)) and isAdJob then
						local isAdRemainingString, tempAdRemainingString = viSetGet:getAdRemainingString(vehicle, isPlayer);
						if isAdRemainingString ~= nil and isAdRemainingString then
							adRemainingString = tempAdRemainingString;											
						end;
					end;
					if VehicleInspector.seeTxt.cpRemaining.state > 0 and ((VehicleInspector.global.foundMoh and VehicleInspector.seeTxt.cpRemaining.mohVisible) or (not VehicleInspector.global.foundMoh)) and not isAdJob then
						local isCpRemainingString, tempCpRemainingString = viSetGet:getCpRemainingString(vehicle);
						if isCpRemainingString ~= nil and isCpRemainingString then
							cpRemainingString = tempCpRemainingString;						
						end;
					end;
					if cpRemainingString:len() > 0 or adRemainingString:len() > 0 then
						if adRemainingString:len() > 0 then
							if setSeparator then lineTxt[#lineTxt+1] = {};lineTxt[#lineTxt].separator = true;end;													
							lineTxt[#lineTxt+1] = {};
							lineTxt[#lineTxt].txt = adRemainingString;
							lineTxt[#lineTxt].txtColor = g_currentMission.hl.getColor(VehicleInspector.showColor.remainingString, true);
							lineTxt[#lineTxt].txtBold = true;					
							lineTxt[#lineTxt].typ = "remainingString";
							setSeparator = true;
						elseif cpRemainingString:len() > 0 then
							if setSeparator then lineTxt[#lineTxt+1] = {};lineTxt[#lineTxt].separator = true;end;													
							lineTxt[#lineTxt+1] = {};
							lineTxt[#lineTxt].txt = cpRemainingString;
							lineTxt[#lineTxt].txtColor = g_currentMission.hl.getColor(VehicleInspector.showColor.remainingString, true);
							lineTxt[#lineTxt].txtBold = true;					
							lineTxt[#lineTxt].typ = "remainingString";
							setSeparator = true;
						end;
					end;
					
					if (isJob or isAdJob) and blinkingTime > 0 and not vehicle.viJobActive then
						vehicle.viJobActive = true;						
						if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers["viJobBlinkingTime_".. tostring(Utils.getNoNil(vehicle.rootNode, 0))] ~= nil then 
							g_currentMission.hl.removeTimer("viJobBlinkingTime_".. tostring(Utils.getNoNil(vehicle.rootNode, 0)));
						end;
						vehicle.viJobTimerAdd = true;
						g_currentMission.hl.addTimer({name="viJobBlinkingTime_".. tostring(Utils.getNoNil(vehicle.rootNode, 0)), delay=blinkingTime, repeatable=true});
					elseif vehicle.viJobActive then
						if not isJob and not isAdJob then
							if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers["viJobBlinkingTime_".. tostring(Utils.getNoNil(vehicle.rootNode, 0))] ~= nil and g_currentMission.hl.timers["viJobBlinkingTime_".. tostring(Utils.getNoNil(vehicle.rootNode, 0))].repeatable then
								g_currentMission.hl.timers["viJobBlinkingTime_".. tostring(Utils.getNoNil(vehicle.rootNode, 0))].repeatable = false;
								g_currentMission.hl.timers["viJobBlinkingTime_".. tostring(Utils.getNoNil(vehicle.rootNode, 0))].current_time = 0;
								g_currentMission.hl.timers["viJobBlinkingTime_".. tostring(Utils.getNoNil(vehicle.rootNode, 0))].delay = blinkingTime*1000;
							end;
							vehicle.viJobTimerAdd = true;							
							vehicle.viBlinking = true;
						end;											
					end;
						
					
					if VehicleInspector.seeTxt.field then					
						local isField, fieldNr = viSetGet:getIsOnField(vehicle);
						local typ = "field";
						if isField then
							if setSeparator then lineTxt[#lineTxt+1] = {};lineTxt[#lineTxt].separator = true;end;
							if fieldNr == 0 or not VehicleInspector.seeTxt.fieldNumber then fieldNr = "";else typ = "fieldAndNr";fieldNr= tostring(VehicleInspector.txt.fieldNumberSeparator).. tostring(fieldNr);end;						
							lineTxt[#lineTxt+1] = {};
							lineTxt[#lineTxt].txt = tostring(fieldTxt).. tostring(fieldNr);						
							lineTxt[#lineTxt].txtColor = g_currentMission.hl.getColor(VehicleInspector.showColor.field, true);
							lineTxt[#lineTxt].txtBold = VehicleInspector.txt.bold;						
							lineTxt[#lineTxt].typ = typ;
							setSeparator = true;					
						end;						
					end;
					
					if VehicleInspector.seeTxt.speed then
						if setSeparator then lineTxt[#lineTxt+1] = {};lineTxt[#lineTxt].separator = true;end;
						local speed = viSetGet:getSpeed(vehicle);						
						lineTxt[#lineTxt+1] = {};
						lineTxt[#lineTxt].txt = speed.. " ".. tostring(speedTxt);
						lineTxt[#lineTxt].txtColor = txtColorDefault;
						lineTxt[#lineTxt].txtBold = VehicleInspector.txt.bold;					
						lineTxt[#lineTxt].typ = "speed";						
						setSeparator = true;
					end;
				
					if isPlayer or isHelper then					
						local typ = "";
						if setSeparator then lineTxt[#lineTxt+1] = {};lineTxt[#lineTxt].separator = true;end;
						local name = "";
						local helperType = helperTxt.. viSetGet:getHelperType(vehicle);
						if VehicleInspector.seeTxt.helperName and isHelper then 
							local currentHelper = vehicle.getCurrentHelper(vehicle);
							local helperName = "";
							if currentHelper ~= nil then helperName = Utils.getNoNil(currentHelper.name, "");end;
							if string.len(helperName) > 0 then helperName = "(".. tostring(helperName).. ")";end;						
							name = tostring(helperType).. helperName;						
							color = txtColorDefault;
							typ = "helperName";
						elseif isHelper then
							name = tostring(helperType);
							color = txtColorDefault;
							typ = "helper";
						end;
						playerName, otherPlayer = viSetGet:getPlayerName(vehicle);						
						if VehicleInspector.seeTxt.playerName and isPlayer then 					
							if playerName:len() > 0 then
								local playerNameSub = "..";				
								if string.len(playerName) <= VehicleInspector.global.playerNameLength then playerNameSub = "";end;
								playerName = string.sub(playerName, 0, VehicleInspector.global.playerNameLength).. playerNameSub;								
							end;							
							if string.len(name) > 0 then 
								name = name.. "+".. tostring(playerName);
								typ = typ.. "playerName";
							else
								name = tostring(playerName);
								typ = "playerName";
							end;
							if otherPlayer then
								color = g_currentMission.hl.getColor(VehicleInspector.showColor.otherPlayerControlled, true);
							else
								color = g_currentMission.hl.getColor(VehicleInspector.showColor.playerControlled, true);
							end;
						elseif isPlayer then 
							if string.len(name) > 0 then 
								name = name.. "+".. tostring(playerTxt);
								typ = "playerName";
							else
								name = tostring(playerTxt);
								typ = "player";
							end;						
							if otherPlayer then
								color = g_currentMission.hl.getColor(VehicleInspector.showColor.otherPlayerControlled, true);
							else
								color = g_currentMission.hl.getColor(VehicleInspector.showColor.playerControlled, true);
							end;
						end;
						lineTxt[#lineTxt+1] = {};
						lineTxt[#lineTxt].txt = tostring(name);
						lineTxt[#lineTxt].txtColor = color;
						lineTxt[#lineTxt].txtBold = VehicleInspector.txt.bold;						
						lineTxt[#lineTxt].typ = typ;						
						setSeparator = true;						
					end;

					if (vehicle.viJobActive and g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers["viJobBlinkingTime_".. tostring(Utils.getNoNil(vehicle.rootNode, 0))] == nil) or (vehicle.viJobActive and (isPlayer or otherPlayer)) then
						if isPlayer or otherPlayer then g_currentMission.hl.removeTimer("viJobBlinkingTime_".. tostring(Utils.getNoNil(vehicle.rootNode, 0)));end;
						vehicle.viJobTimerAdd = nil;
						vehicle.viJobActive = false;							
						vehicle.viBlinking = false;
					end;
				
					if VehicleInspector.seeTxt.vehicleName > 0 then
						if setSeparator then lineTxt[#lineTxt+1] = {};lineTxt[#lineTxt].separator = true;end;
						local typ = "vehicleName";
						viSetGet:setVehicleName(vehicle, false);					
						local vehicleName = tostring(vehicle.viVehicleName);
						if VehicleInspector.seeTxt.vehicleName == 2 then typ = "vehicleRealName";vehicleName = tostring(vehicle.getName(vehicle));end;
						if VehicleInspector.seeTxt.vehicleName == 3 then typ = "vehicleTyp";vehicleName = tostring(vehicle.typeDesc);end;
						local vehicleNameSub = ".."
						if string.len(vehicleName) <= VehicleInspector.global.vehicleNameLength then vehicleNameSub = "";end;
						vehicleName = string.sub(vehicleName, 0, VehicleInspector.global.vehicleNameLength);					
						lineTxt[#lineTxt+1] = {};
						lineTxt[#lineTxt].txt = tostring(vehicleName).. vehicleNameSub;
						lineTxt[#lineTxt].txtColor = txtColorDefault;
						lineTxt[#lineTxt].txtBold = VehicleInspector.txt.bold;					
						lineTxt[#lineTxt].typ = typ;
						setSeparator = true;
					end;				
				
					function setGetFillLevel()
						local fillLevelTable = {};
						local foundFillLevelFull = false;
						local foundFillLevel = false;
						local foundFillLevelEmpty = false; --seeds etc.
						if vehicle.getFillLevelInformation ~= nil then
							fillLevelTable = viSetGet:getFillLevelInformation(vehicle, fillLevelTable, false, 0);
							for _,fillLevelVehicle in pairs(fillLevelTable) do
								local invertProzent = fillLevelVehicle.isSeedsOrAnd or (attachedSprayerAnd > 0 and attach == 1) or (attachedSprayerAnd == 1 and attach == 1);
								if fillLevelVehicle.fillLevel > 0 or invertProzent then
									if setSeparator then lineTxt[#lineTxt+1] = {};lineTxt[#lineTxt].separator = true;end;
									foundFillLevel = fillLevelVehicle.fillLevel > 0;								
									local isCapacity = fillLevelVehicle.capacity > 0;								
									local prozent = 0;
									if isCapacity then prozent = g_currentMission.hl.getProzentFillLevel(fillLevelVehicle.fillLevel, fillLevelVehicle.capacity, false);end;
									
									if VehicleInspector.txt.color then
										color = g_currentMission.hl.getProzentColor(prozent, invertProzent);
									else
										color = 1;
									end;
									
									if fillLevelVehicle.numObject == nil then 
										if (prozent >= 99 and not invertProzent) then foundFillLevelFull = true;end;
										if (prozent <= 1 and invertProzent) then foundFillLevelEmpty = true;end;
									else
										color = 1;
									end;									
									local firstTable = 0;
									if VehicleInspector.seeTxt.fillName > 0 then																			
										local fillTypeName = FillTypeManager.getFillTypeNameByIndex(g_fillTypeManager, fillLevelVehicle.fillType);
										if VehicleInspector.seeTxt.fillName == 1 then fillTypeName = g_fillTypeManager.nameToFillType[fillTypeName].title;end;									
										local fillNameSub = ".."
										if string.len(fillTypeName) <= VehicleInspector.global.fillNameLength then fillNameSub = "";end;
										fillTypeName = utf8Substr(fillTypeName, 0, VehicleInspector.global.fillNameLength); --string.sub(fillTypeName, 0, VehicleInspector.global.fillNameLength);
										lineTxt[#lineTxt+1] = {};									
										lineTxt[#lineTxt].txt = tostring(fillTypeName).. fillNameSub.. fillNameToFillLevelSeparator;
										lineTxt[#lineTxt].txtBold = VehicleInspector.txt.bold;										
										lineTxt[#lineTxt].txtColor = g_currentMission.hl.getColorProzent(color, true);
										lineTxt[#lineTxt].typ = "fillName";
										firstTable = firstTable+1;
										setSeparator = true;
									end;								
									if VehicleInspector.seeTxt.fillLevel then
										if firstTable > 0 then
											lineTxt[#lineTxt].txt = lineTxt[#lineTxt].txt.. " ".. tostring(string.format("%1.0f", Utils.getNoNil(fillLevelVehicle.fillLevel, 0)));
											lineTxt[#lineTxt].typ = lineTxt[#lineTxt].typ.. "-fillLevel";
										else
											lineTxt[#lineTxt+1] = {};
											lineTxt[#lineTxt].txt = tostring(string.format("%1.0f", Utils.getNoNil(fillLevelVehicle.fillLevel, 0)));
											lineTxt[#lineTxt].txtBold = VehicleInspector.txt.bold;										
											lineTxt[#lineTxt].txtColor = g_currentMission.hl.getColorProzent(color, true);
											lineTxt[#lineTxt].typ = "fillLevel";
											setSeparator = true;
											firstTable = firstTable+1;
										end;										
									end;
									if VehicleInspector.seeTxt.fillProzent then
										local tempTxt = "0";
										if isCapacity then tempTxt = g_currentMission.hl.getProzentFillLevel(fillLevelVehicle.fillLevel, fillLevelVehicle.capacity, true);end;
										if firstTable > 0 then
											if VehicleInspector.seeTxt.fillLevel then tempTxt = " (".. tempTxt.. "%)";else tempTxt = " ".. tempTxt.. "%";end;
											lineTxt[#lineTxt].txt = lineTxt[#lineTxt].txt.. tostring(tempTxt);											
											lineTxt[#lineTxt].typ = lineTxt[#lineTxt].typ.. "-fillProzent";
										else
											lineTxt[#lineTxt+1] = {};		
											lineTxt[#lineTxt].txt = tostring(tempTxt).. "%";
											lineTxt[#lineTxt].txtBold = VehicleInspector.txt.bold;
											lineTxt[#lineTxt].txtColor = g_currentMission.hl.getColorProzent(color, true);
											lineTxt[#lineTxt].typ = "fillProzent";
											setSeparator = true;
											firstTable = firstTable+1;
										end;										
									end;									
									if invertProzent and firstTable > 0 then
										if fillLevelVehicle.isSeedsOrAnd then
											lineTxt[#lineTxt].txt = tostring(saTxt).. lineTxt[#lineTxt].txt;
										else
											lineTxt[#lineTxt].txt = tostring(saOrFillTxt).. lineTxt[#lineTxt].txt;
										end;
									end;									
									if VehicleInspector.seeTxt.fillObject and fillLevelVehicle.numObject ~= nil then									
										if firstTable > 0 then									 
											lineTxt[#lineTxt].txt = lineTxt[#lineTxt].txt.. tostring(objectTxt).. tostring(fillLevelVehicle.numObject);
											lineTxt[#lineTxt].typ = lineTxt[#lineTxt].typ.. "-numObject";
										else
											lineTxt[#lineTxt+1] = {};		
											lineTxt[#lineTxt].txt = tostring(objectTxt).. tostring(fillLevelVehicle.numObject);
											lineTxt[#lineTxt].txtBold = VehicleInspector.txt.bold;
											lineTxt[#lineTxt].txtColor = g_currentMission.hl.getColorProzent(color, true);
											lineTxt[#lineTxt].typ = "numObject";
											setSeparator = true;
											firstTable = firstTable+1;
										end;										
									end;																	
								end;	
							end;
						end;
						return foundFillLevel, foundFillLevelFull, foundFillLevelEmpty;
					end;
				
					if setSeparator then lineTxt[#lineTxt+1] = {};lineTxt[#lineTxt].separator = true;end;
					setSeparator = false;
					
					local foundFillLevel, foundFillLevelFull, foundFillLevelEmpty = setGetFillLevel();				
					if foundFillLevelFull and isJob then
						table.insert(lineTxt, 1, {})
						lineTxt[1].txt = tostring(fullTxt);
						lineTxt[1].txtBold = true;
						lineTxt[1].txtColor = g_currentMission.hl.getColor(VehicleInspector.showColor.full, true);
						lineTxt[1].typ = "jobFillLevelFull";
					elseif foundFillLevelEmpty and isJob then
						table.insert(lineTxt, 1, {})
						lineTxt[1].txt = tostring(saEmptyTxt);
						lineTxt[1].txtBold = true;
						lineTxt[1].txtColor = g_currentMission.hl.getColor(VehicleInspector.showColor.empty, true);
						lineTxt[1].typ = "jobFillLevelEmpty";
					end;
					
					if VehicleInspector.seeTxt.parking and canParking then
						local spec = vehicle.spec_parkvehicle;
						if spec.state[spec.uniqueUserId] then					
							if setSeparator then lineTxt[#lineTxt+1] = {};lineTxt[#lineTxt].separator = true;end;
							lineTxt[#lineTxt+1] = {};
							lineTxt[#lineTxt].txt = tostring(parkingTxt);
							lineTxt[#lineTxt].txtColor = g_currentMission.hl.getColor(VehicleInspector.showColor.parking, true);
							lineTxt[#lineTxt].txtBold = true;						
							lineTxt[#lineTxt].typ = "parking";
							setSeparator = true;					
						end;
					end;
				
					if VehicleInspector.seeTxt.leasing and isLeasing then	
						if setSeparator then lineTxt[#lineTxt+1] = {};lineTxt[#lineTxt].separator = true;end;	
						lineTxt[#lineTxt+1] = {};
						lineTxt[#lineTxt].txt = tostring(leasingTxt);
						lineTxt[#lineTxt].txtColor = g_currentMission.hl.getColor(VehicleInspector.showColor.leasing, true);
						lineTxt[#lineTxt].txtBold = true;					
						lineTxt[#lineTxt].typ = "leasing";
						setSeparator = true;
					end;
					
					if VehicleInspector.seeTxt.gps and isGps then	
						if setSeparator then lineTxt[#lineTxt+1] = {};lineTxt[#lineTxt].separator = true;end;	
						lineTxt[#lineTxt+1] = {};
						lineTxt[#lineTxt].txt = tostring(gpsTxt);
						if isGpsActive then
							lineTxt[#lineTxt].txtColor = g_currentMission.hl.getColor(VehicleInspector.showColor.gps, true);
						else
							lineTxt[#lineTxt].txtColor = g_currentMission.hl.getColor("darkGray", true);
						end;
						lineTxt[#lineTxt].txtBold = true;					
						lineTxt[#lineTxt].typ = "gps";
						setSeparator = true;
					end;
					
					if VehicleInspector.seeTxt.totalAttached and attach > 0 then
						if setSeparator then lineTxt[#lineTxt+1] = {};lineTxt[#lineTxt].separator = true;end;
						lineTxt[#lineTxt+1] = {};
						lineTxt[#lineTxt].txt = tostring(attach);
						lineTxt[#lineTxt].txtColor = txtColorDefault;
						lineTxt[#lineTxt].txtBold = VehicleInspector.txt.bold;						
						lineTxt[#lineTxt].typ = "totalAttached";
						setSeparator = true;
					end;
					local isPipeState = false;
					if VehicleInspector.seeTxt.overload then isPipeState = viSetGet:getPipeState(vehicle, isJob or isAdJob);end;				
					local isBlocking, didMoveStop, stillBlocking = viSetGet:getCollision(vehicle, isJob or isAdJob);
					local isFuelEmpty = viSetGet:getFuel(vehicle);
					local isDamage = viSetGet:getDamage(vehicle);
					local isWater = viSetGet:getWater(vehicle);
					local isWarning = false;
					if isPipeState and VehicleInspector.seeTxt.overload then
						table.insert(lineTxt, 1, {})
						lineTxt[1].txtBold = true;
						lineTxt[1].txt = tostring(overloadTxt);
						lineTxt[1].txtColor = g_currentMission.hl.getColor("yellow", true);
					elseif isBlocking and (isJob or isAdJob) and VehicleInspector.seeWarning.isBlocking and not foundFillLevelFull then						
						table.insert(lineTxt, 1, {})
						lineTxt[1].txtBold = true;
						local adDrivePath = nil;
						if isAdJob then adDrivePath = vehicle.ad.drivePathModule;end;
						if isAdJob and stillBlocking == nil and ( (adDrivePath ~= nil and adDrivePath.wayPoints ~= nil) or (didMoveStop ~= nil and didMoveStop) ) then
							lineTxt[1].txt = tostring(waitTxt);
							lineTxt[1].txtColor = g_currentMission.hl.getColor("yellow", true);
						else
							lineTxt[1].txt = tostring(blockingTxt);
							lineTxt[1].txtColor = g_currentMission.hl.getColor(VehicleInspector.showColor.blocking, true);
						end;						
						lineTxt[1].typ = "warningBlocking";
						isWarning = true;
					elseif isDamage and VehicleInspector.seeWarning.isDamage then
						table.insert(lineTxt, 1, {})
						lineTxt[1].txt = tostring(damageTxt);
						lineTxt[1].txtBold = true;
						lineTxt[1].txtColor = g_currentMission.hl.getColor(VehicleInspector.showColor.damage, true);
						lineTxt[1].typ = "warningDamage";
						isWarning = true;
					elseif isWater and VehicleInspector.seeWarning.isWater then
						table.insert(lineTxt, 1, {})
						lineTxt[1].txt = tostring(waterTxt);
						lineTxt[1].txtBold = true;
						lineTxt[1].txtColor = g_currentMission.hl.getColor(VehicleInspector.showColor.water, true);
						lineTxt[1].typ = "warningWater";
						isWarning = true;
					elseif isFuelEmpty and VehicleInspector.seeWarning.isFuelEmpty then
						table.insert(lineTxt, 1, {})
						lineTxt[1].txt = tostring(fuelEmptyTxt);
						lineTxt[1].txtBold = true;
						lineTxt[1].txtColor = g_currentMission.hl.getColor(VehicleInspector.showColor.empty, true);
						lineTxt[1].typ = "warningFullEmpty";
						isWarning = true;
					end;
				
					local delLastOutput = false;
															
					local isPlayerContractor = false;
					if isHorse then
						if not isPlayer or not VehicleInspector.seeVehicle.isHorsePlayer then table.remove(output, #output);delLastOutput=true;end;
					elseif isTrain then
						if not VehicleInspector.seeVehicle.isTrain then table.remove(output, #output);delLastOutput=true;end;
					end;
					
					if vehicle.viJobTimerAdd and vehicle.viBlinking then delLastOutput = true;end; ---<----
					
					if not delLastOutput and not isWarning and attach == 0 and not foundFillLevel then
						if not isPlayer and not isHelper and not VehicleInspector.seeVehicle.notAttached then table.remove(output, #output);delLastOutput=true;end;
					end;
					if not delLastOutput and not isWarning and not foundFillLevel then
						if not isPlayer and not isHelper and not VehicleInspector.seeVehicle.notFillLevel then table.remove(output, #output);delLastOutput=true;end;
					end;				
					if not delLastOutput then
						isPlayerContractor = viSetGet:getFarmContractor(playerFarmId, vehicle.ownerFarmId);
						local del1 = not isOwnFarmVehicle and VehicleInspector.seeVehicle.isOwnFarmVehicle;
						local del2 = not isOwnFarmVehicle and not VehicleInspector.seeVehicle.isOwnFarmVehicle and not isPlayerContractor;
						if del1 or del2 then table.remove(output, #output);delLastOutput=true;end;
					end;
					if not delLastOutput and isPlayer and not isHelper then
						if not VehicleInspector.seeVehicle.isPlayer then table.remove(output, #output);delLastOutput=true;end;
					end;
					if not delLastOutput and isHelper and not isPlayer then
						if not VehicleInspector.seeVehicle.isHelper then table.remove(output, #output);delLastOutput=true;end;
					end;
					
					if not delLastOutput and not isHelper and not isPlayer then
						if VehicleInspector.seeVehicle.onlyControlled then table.remove(output, #output);delLastOutput=true;end;
					end;
					
					if not delLastOutput and not isHelper and not isPlayer then
						local ghostCategory = viOutput:getViewGhostCategory(output[#output].viCategoryName, {isGps=isGps, isLeasing=isLeasing, isParking=canParking});
						if ghostCategory ~= output[#output].viCategoryName then								
							--output.sortCategory = VehicleInspector.vehicleTypeCategoryNumber[ghostCategory] == VehicleInspector.global.sortBy;								
						end;
						if not viOutput:setViewCategory(output[#output].viCategoryName, {isGps=isGps, isLeasing=isLeasing, isParking=canParking}) then table.remove(output, #output);delLastOutput=true;end;
					end;
					
					if vehicle.viJobTimerAdd and vehicle.viBlinking then delLastOutput = false;end; ---<----
					
					--notOwnVehicles--
					if not delLastOutput and isPlayerContractor and not isOwnFarmVehicle and not VehicleInspector.seeVehicle.isOwnFarmVehicle and not isTrain then
						if outputNotOwnVehicle[vehicle.ownerFarmId] == nil then outputNotOwnVehicle[vehicle.ownerFarmId] = {};end;
						if isPlayer and VehicleInspector.global.seePlayerOnTop then
							table.insert(outputNotOwnVehicle[vehicle.ownerFarmId], farmTables[vehicle.ownerFarmId].playerPos+1, output[#output]);
							farmTables[vehicle.ownerFarmId].playerPos = farmTables[vehicle.ownerFarmId].playerPos+1;						
							table.remove(output, #output);
						end;
						if not isPlayer and isHelper and VehicleInspector.global.seeHelperOnTop then
							table.insert(outputNotOwnVehicle[vehicle.ownerFarmId], farmTables[vehicle.ownerFarmId].playerPos+farmTables[vehicle.ownerFarmId].helperPos+1, output[#output]);
							farmTables[vehicle.ownerFarmId].helperPos = farmTables[vehicle.ownerFarmId].helperPos+1;						
							table.remove(output, #output);
						end;
						if not isPlayer and not isHelper then
							table.insert(outputNotOwnVehicle[vehicle.ownerFarmId], #outputNotOwnVehicle[vehicle.ownerFarmId], output[#output]);												
							table.remove(output, #output);
						end;
						delLastOutput = true;
					end;
					--notOwnVehicles--					
					
					--sort--
					if not delLastOutput then					
						if isPlayer and VehicleInspector.global.seePlayerOnTop then						
							table.insert(output, farmTables[playerFarmId].playerPos+1, output[#output]);
							farmTables[playerFarmId].playerPos = farmTables[playerFarmId].playerPos+1;						
							table.remove(output, #output);
						end;
						if not isPlayer and isHelper and VehicleInspector.global.seeHelperOnTop then
							table.insert(output, farmTables[playerFarmId].playerPos+farmTables[playerFarmId].helperPos+1, output[#output]);
							farmTables[playerFarmId].helperPos = farmTables[playerFarmId].helperPos+1;						
							table.remove(output, #output);
						end;
					end;					
					--sort--
				end;
			end;
		end;
		
		--sort contracting--
		if not VehicleInspector.seeVehicle.isOwnFarmVehicle and #outputNotOwnVehicle > 0 then
			local addTables = {};		
			table.foreach(output, function(k, v) table.insert(addTables, v) end);			
			function setFarmSeparator(name)
				addTables[#addTables+1] = {txt={}};
				local lineTxt = addTables[#addTables].txt;
				lineTxt[#lineTxt+1] = {};
				lineTxt[#lineTxt].txt = tostring(VehicleInspector.txt.ownSeparator).. " ".. tostring(name);
				lineTxt[#lineTxt].txtColor = g_currentMission.hl.getColor(VehicleInspector.showColor.separator, true);
				lineTxt[#lineTxt].txtBold = true;
				lineTxt[#lineTxt].typ = "farmSeperator";
			end;
			for farmId, farm in pairs(outputNotOwnVehicle) do
				setFarmSeparator(farmTables[farmId].name);
				table.foreach(farm, function(k, v) table.insert(addTables, v) end);
			end;			
			output = addTables;
		end;
		--sort contracting--
	end;
	VehicleInspector.output = output;	
end;

function viOutput:loadVehicleByIcons()
	VehicleInspector.otherOutput = {}; --new
	VehicleInspector.ownOutput = {}; --new
	VehicleInspector.contractorOutput = {}; --new
	local viPlayerHelper = {};
	local viVehicle = {};
	local viVehicleC = {};
	local viPlayerHelperC = {};
	local playerFarmId = g_currentMission.player.farmId;
	if g_currentMission ~= nil and g_currentMission.vehicles ~= nil then
		local txtColorDefault = g_currentMission.hl.getColor(VehicleInspector.showColor.txt, true);		
		local color = nil;		
		local farmTables = viSetGet:getFarmIdTables({}, playerFarmId);
		for v=1, #g_currentMission.vehicles do
			local vehicle = g_currentMission.vehicles[v];			
			if vehicle ~= nil and vehicle.finishedLoading == true and vehicle.getIsControlled ~= nil and Utils.getNoNil(vehicle.viCategoryName, "free") ~= "nosupport" then --by Achimobil (vehicle.finishedLoading == true)
				if vehicle.viJobActive == nil then vehicle.viJobActive = false;end;
				local isJob = false;
				local isAdJob = vehicle.spec_autodrive ~= nil and vehicle.ad ~= nil and vehicle.ad.stateModule:isActive();
								
				local output = {sortType="number",sortBy=0,attached={}};
				
				local adRemainingString = "";
				local cpRemainingString = "";				
				output.view = true;
				output.blinking = false;
				output.blinkingTime = VehicleInspector.global.helperJobEndTimeBlinking;
				output.isPlayer = vehicle.getIsControlled(vehicle);
				output.playerTxt = "P";
				output.controlledName = "";
				output.isOtherPlayer = false;
				local adErrorHelper = vehicle.getIsAIActive ~= nil and vehicle:getIsAIActive(); --for AD helper Bug Version >2.0.0.5				
				output.isHelper = (vehicle.getCurrentHelper ~= nil and vehicle.getCurrentHelper(vehicle)) or adErrorHelper;
				output.helperTxt = "H";
				output.ownerFarmId = playerFarmId == vehicle.ownerFarmId;
				output.farmId = vehicle.ownerFarmId or 0;
				if farmTables[vehicle.ownerFarmId] == nil then
					output.farmName = "Unknown";
				else				
					output.farmName = Utils.getNoNil(farmTables[vehicle.ownerFarmId].name, "Unknown");
				end;
				if output.farmName:len() <= 0 then output.farmName = "Free";end;
				output.isTrain = vehicle.trainSystem ~= nil;
				output.isHorse = vehicle.spec_rideable ~= nil;
				output.isLeasing = vehicle.propertyState == 2;
				output.isGps = vehicle.spec_globalPositioningSystem ~= nil and vehicle.spec_globalPositioningSystem.hasGuidanceSystem;
				output.isGpsActive = output.isGps and vehicle.spec_globalPositioningSystem.lastInputValues.guidanceIsActive;
				output.isParking = false;
				output.viCategoryName = tostring(vehicle.viCategoryName);
				if output.viCategoryName == "unknown" then output.viCategoryName = "other";end;
				output.sortCategory = VehicleInspector.vehicleTypeCategoryNumber[output.viCategoryName] == VehicleInspector.global.sortBy;
				--output.vehicleStoreName = tostring(vehicle.getName(vehicle));
				--output.hashVehicleIcon = VehicleInspector.storeOverlays[output.vehicleStoreName] ~= nil;
				output.rootNode = Utils.getNoNil(vehicle.rootNode, 0);
				
				if output.isPlayer then
					output.controlledName, output.isOtherPlayer = viSetGet:getPlayerName(vehicle);
					if not VehicleInspector.seeTxt.playerName and VehicleInspector.global.forceView == 0 then output.controlledName = "";end;
					if output.controlledName:len() > 0 then
						local playerNameSub = "..";				
						if string.len(output.controlledName) <= VehicleInspector.global.playerNameLength then playerNameSub = "";end;
						output.controlledName = string.sub(output.controlledName, 0, VehicleInspector.global.playerNameLength).. playerNameSub;						
					end;
				end;
				if output.isHelper then
					local _, iType = viSetGet:getHelperType(vehicle);
					output.helperTxt = tostring(iType);
					if VehicleInspector.seeTxt.helperName or VehicleInspector.global.forceView > 0 then
						local currentHelper = Utils.getNoNil(vehicle.getCurrentHelper(vehicle), {});					
						local helperName = Utils.getNoNil(currentHelper.name, "");
						if helperName:len() <= 1 then helperName = tostring(iType);else helperName = iType.."(".. helperName..")";end;
						if helperName:len() > 1 then
							if output.controlledName:len() > 0 then
								output.controlledName = helperName.. "+".. output.controlledName;
							else
								output.controlledName = helperName;
							end;
						end;
					end;
				end;								
				if vehicle.getJob ~= nil then					
					local job = vehicle:getJob();
					if job ~= nil then						
						isJob = true;
						if VehicleInspector.seeTxt.jobTypeTxt > 0 or VehicleInspector.global.forceView > 0 then
							local jobType = g_currentMission.aiJobTypeManager:getJobTypeByIndex(job.jobTypeIndex)
							output.isJob = true;
							output.jobType = job.jobTypeIndex;
							output.jobTypeIconTxt = tostring(viSetGet:getJobTypeIconTxt(job.jobTypeIndex, false));
							output.jobTypeTxt = tostring(jobType.title);
						end;
					end;
				end;
				if not isJob and isAdJob then
					local jobType, index = viSetGet:getAdJobType(vehicle);
					if jobType ~= nil and (VehicleInspector.seeTxt.jobTypeTxt > 0 or VehicleInspector.global.forceView > 0) then						
						output.isJob = true;
						output.isAdJob = true;
						output.jobType = index;
						output.jobTypeIconTxt = tostring(viSetGet:getJobTypeIconTxt(index, true));
						output.jobTypeTxt = tostring(jobType);
					end;
					if jobType == nil then isAdJob = false;end;					
				end;
				if VehicleInspector.seeTxt.adRemaining.state > 0 and ((VehicleInspector.global.foundMoh and VehicleInspector.seeTxt.adRemaining.mohVisible) or (not VehicleInspector.global.foundMoh)) and isAdJob then
					local isAdRemainingString, tempAdRemainingString = viSetGet:getAdRemainingString(vehicle, output.isPlayer);
					if isAdRemainingString ~= nil and isAdRemainingString then
						adRemainingString = tempAdRemainingString;											
					end;
				end;
				if VehicleInspector.seeTxt.cpRemaining.state > 0 and ((VehicleInspector.global.foundMoh and VehicleInspector.seeTxt.cpRemaining.mohVisible) or (not VehicleInspector.global.foundMoh)) and not isAdJob then
					local isCpRemainingString, tempCpRemainingString = viSetGet:getCpRemainingString(vehicle);
					if isCpRemainingString ~= nil and isCpRemainingString then
						cpRemainingString = tempCpRemainingString;						
					end;
				end;
				if cpRemainingString:len() > 0 or adRemainingString:len() > 0 then
					if adRemainingString:len() > 0 then
						output.remainingString = adRemainingString;
					elseif cpRemainingString:len() > 0 then
						output.remainingString = cpRemainingString;
					end;
				end;
				local disabled = true;
				--if not disabled then
					if (output.isJob) and output.blinkingTime > 0 and not vehicle.viJobActive then
						vehicle.viJobActive = true;						
						if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers["viJobBlinkingTime_".. tostring(output.rootNode)] ~= nil then 
							g_currentMission.hl.removeTimer("viJobBlinkingTime_".. tostring(output.rootNode));
						end;
						vehicle.viJobTimerAdd = true;
						g_currentMission.hl.addTimer({name="viJobBlinkingTime_".. tostring(output.rootNode), delay=output.blinkingTime, repeatable=true});
					elseif vehicle.viJobActive then
						if not output.isJob then
							if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers["viJobBlinkingTime_".. tostring(output.rootNode)] ~= nil and g_currentMission.hl.timers["viJobBlinkingTime_".. tostring(output.rootNode)].repeatable then
								g_currentMission.hl.timers["viJobBlinkingTime_".. tostring(output.rootNode)].repeatable = false;
								g_currentMission.hl.timers["viJobBlinkingTime_".. tostring(output.rootNode)].current_time = 0;
								g_currentMission.hl.timers["viJobBlinkingTime_".. tostring(output.rootNode)].delay = output.blinkingTime*1000;
							end;
							vehicle.viJobTimerAdd = true;							
							output.blinking = true;
						end;											
					end;
					if (vehicle.viJobActive and g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers["viJobBlinkingTime_".. tostring(output.rootNode)] == nil) or (vehicle.viJobActive and (output.isPlayer or output.isOtherPlayer)) then
						if output.isPlayer or output.isOtherPlayer then g_currentMission.hl.removeTimer("viJobBlinkingTime_".. tostring(output.rootNode));end;
						vehicle.viJobTimerAdd = nil;
						vehicle.viJobActive = false;							
						output.blinking = false;
					end;
				--end;
				
				if VehicleInspector.seeTxt.field or VehicleInspector.global.forceView > 0 then					
					local isField, fieldNr = viSetGet:getIsOnField(vehicle);
					if isField then
						output.isField = isField;
						output.fieldNr = fieldNr;
					end;
				end;
				
				local _, isTempomat = viSetGet:getSpeedControll(vehicle);
				output.isEngineOn = viSetGet:getEngine(vehicle);
				output.isTempomatOn = isTempomat;
				output.speed = tonumber(viSetGet:getSpeed(vehicle));				
				
				viSetGet:setVehicleName(vehicle, false);					
				output.storeName = tostring(vehicle.getName(vehicle));
				local vehicleName = tostring(vehicle.viVehicleName);
				if VehicleInspector.seeTxt.vehicleName == 2 or VehicleInspector.global.forceView > 0 then 
					vehicleName = tostring(output.storeName);
				elseif VehicleInspector.seeTxt.vehicleName == 3 then 
					vehicleName = tostring(vehicle.typeDesc);
				end;
				
				local vehicleNameSub = "..";				
				if string.len(vehicleName) <= VehicleInspector.global.vehicleNameLength then vehicleNameSub = "";end;
				local vehicleName = string.sub(vehicleName, 0, VehicleInspector.global.vehicleNameLength);
				
				output.vehicleName = tostring(vehicleName).. vehicleNameSub;
				
				if vehicle.spec_parkvehicle ~= nil then
					local spec = vehicle.spec_parkvehicle;
					if spec.state[spec.uniqueUserId] then
						output.isParking = true;
					end;
				end;
				
				local isPipeState = viSetGet:getPipeState(vehicle, isJob or isAdJob);
				local isBlocking, didMoveStop, stillBlocking = viSetGet:getCollision(vehicle, isJob or isAdJob);
				local isFuelEmpty, fPercent = viSetGet:getFuel(vehicle);
				local isDamage, dPercent = viSetGet:getDamage(vehicle);
				local isWater = viSetGet:getWater(vehicle);
				
				output.warnings = {};
				output.warnings.fuelProzent = fPercent;
				output.warnings.damageProzent = dPercent;
				if isPipeState then output.warnings.isPipeState = true;end;
				if isWater then output.warnings.isWater = true;end;
				if isDamage then output.warnings.isDamage = true;end;
				if isFuelEmpty then output.warnings.isFuelEmpty = true;end;
				if isBlocking then
					output.warnings.isBlocking = true;
					if isJob or isAdJob and stillBlocking == nil then
						if isAdJob then adDrivePath = vehicle.ad.drivePathModule;end;
						if isAdJob and ( (adDrivePath ~= nil and adDrivePath.wayPoints ~= nil) or (didMoveStop ~= nil and didMoveStop) ) then
							output.warnings.blockingType = 2;
						else
							output.warnings.blockingType = 1;
						end;
					else
						if didMoveStop == nil then output.warnings.blockingType = 1;end;
					end;
				end;
				output.isWarning = isBlocking or isWater or isDamage or isFuelEmpty or isPipeState;
				
				local frontAttached = 0;
				local backAttached = 0;
				local attached = viSetGet:getAttached(vehicle, {});
				output.totalAttached = 0;
				output.fillLevelInformation = {};
				
				viSetGet:setFillLevelInformation(vehicle, output.fillLevelInformation);
				if attached ~= nil and #attached > 0 then
					output.totalAttached = #attached;
					output.attached = attached;
					for o=1, #attached do
						if attached[o] ~= nil then							
							viSetGet:setFillLevelInformation(g_currentMission:getNodeObject(attached[o].rootNode), output.fillLevelInformation);
						end;
					end;					
				end;
				
				if VehicleInspector.global.forceView ~= 2 and output.isTrain and output.farmId == 0 and g_currentMission.missionDynamicInfo.isMultiplayer and not VehicleInspector.seeVehicle.train then
					output = nil;
				end;
				if output ~= nil then
					local stopViewOff = output.isPlayer or output.isOtherPlayer or output.isHelper or isJob or isAdJob or output.blinking;
					if VehicleInspector.global.forceView ~= 2 then
						if not stopViewOff then
							--local ghostCategory = viOutput:getViewGhostCategory(output.viCategoryName, {isGps=output.isGps, isLeasing=output.isLeasing, isParking=output.isParking});
							--if ghostCategory ~= output.viCategoryName then								
							--	output.sortCategory = VehicleInspector.vehicleTypeCategoryNumber[ghostCategory] == VehicleInspector.global.sortBy;								
							--end;
							output.view = viOutput:setViewCategory(output.viCategoryName, {isGps=output.isGps, isLeasing=output.isLeasing, isParking=output.isParking});
						end;
						viOutput:setView(output);				
					end;	
					if output.isPlayer or output.isOtherPlayer or output.isHelper then
						if output.ownerFarmId then 
							viPlayerHelper[#viPlayerHelper+1] = output;
						elseif not VehicleInspector.seeVehicle.isOwnFarmVehicle then
							if (output.farmId == 0 and output.isTrain) or viSetGet:getFarmContractor(playerFarmId, output.farmId) then
								if viPlayerHelperC[vehicle.ownerFarmId] == nil then viPlayerHelperC[vehicle.ownerFarmId] = {};end;
								viPlayerHelperC[vehicle.ownerFarmId][#viPlayerHelperC[vehicle.ownerFarmId]+1] = output;
							end;							
						end;
					else
						if output.ownerFarmId then 
							viVehicle[#viVehicle+1] = output;
						elseif not VehicleInspector.seeVehicle.isOwnFarmVehicle then
							if (output.farmId == 0 and output.isTrain) or viSetGet:getFarmContractor(playerFarmId, output.farmId) then
								if viVehicleC[vehicle.ownerFarmId] == nil then viVehicleC[vehicle.ownerFarmId] = {};end;
								viVehicleC[vehicle.ownerFarmId][#viVehicleC[vehicle.ownerFarmId]+1] = output;
							end;
						end;
					end;
				end;
			end;
		end;
		viSetGet:sortByCategory(viPlayerHelper);
		viSetGet:sortByCategory(viVehicle);
		local addTables = {};		
		table.foreach(viPlayerHelper, function(k, v) table.insert(addTables, v) end);
		table.foreach(viVehicle, function(k, v) table.insert(addTables, v) end);
		VehicleInspector.ownOutput = addTables;
		local addTablesC = {};
		for k,v in pairs (viPlayerHelperC) do
			if v == nil then break;end;			
			viSetGet:sortByCategory(v);
		end;
		for k,v in pairs (viVehicleC) do
			if v == nil then break;end;
			viSetGet:sortByCategory(v);
		end;		
		for farmId, farm in pairs(viPlayerHelperC) do			
			if addTablesC[farmId] == nil then addTablesC[farmId] = {};end;
			table.foreach(farm, function(k, v) table.insert(addTablesC[farmId], v) end);
		end;
		for farmId, farm in pairs(viVehicleC) do			
			if addTablesC[farmId] == nil then addTablesC[farmId] = {};end;
			table.foreach(farm, function(k, v) table.insert(addTablesC[farmId], v) end);
		end;
		for farmId, farm in pairs(addTablesC) do			
			table.foreach(farm, function(k, v) table.insert(VehicleInspector.contractorOutput, v) end);
		end;
	end;	
end;

function viOutput:setViewCategory(category, args)
	if args ~= nil and (args.isGps or args.isLeasing or args.isParking) then
		if VehicleInspector.vehicleTypeCategory[category] ~= nil and VehicleInspector.seeVehicle[category] then
			if args.isGps and not VehicleInspector.seeVehicle.isGps then return false;
			elseif args.isLeasing and not VehicleInspector.seeVehicle.isLeasing then return false;
			elseif args.isParking and not VehicleInspector.seeVehicle.isParking then return false;end;			
		end;
	end;
	return VehicleInspector.vehicleTypeCategory[category] ~= nil and VehicleInspector.seeVehicle[category];
end;

function viOutput:getViewGhostCategory(category, args)
	if args ~= nil and (args.isGps or args.isLeasing or args.isParking) then		
		if args.isGps and VehicleInspector.seeVehicle.isGps then return "isGps";
		elseif args.isLeasing and VehicleInspector.seeVehicle.isLeasing then return "isLeasing";
		elseif args.isParking and VehicleInspector.seeVehicle.isParking then return "isParking";end;		
	end;
	return category;
end;

function viOutput:setView(aTable)
	if aTable == nil then return;end;
	if aTable.blinking then aTable.view = true;return;end;
	if VehicleInspector.seeVehicle.isPlayer and (aTable.isPlayer or aTable.isOtherPlayer) then aTable.view = true;return;end;
	if VehicleInspector.seeVehicle.isHelper and aTable.isHelper then aTable.view = true;return;end;
	if VehicleInspector.seeVehicle.onlyControlled then
		if not aTable.isPlayer and not aTable.isOtherPlayer and not aTable.isHelper then aTable.view = false;return;end;aTable.view = true;return;	
	end;	
	if aTable.view and aTable.isTrain and not (aTable.isPlayer or aTable.isOtherPlayer) then aTable.view = VehicleInspector.seeVehicle.train;end;
	if aTable.view and aTable.totalAttached <= 0 and not VehicleInspector.seeVehicle.notAttached and not aTable.viCategoryName == "car" then aTable.view = false;end;
	if aTable.view and aTable.isHorse then aTable.view = VehicleInspector.seeVehicle.isHorsePlayer and (aTable.isPlayer or aTable.isOtherPlayer);end;
	
	if aTable.view and aTable.isLeasing then aTable.view = VehicleInspector.seeVehicle.isLeasing;end;
	if aTable.view and aTable.isParking then aTable.view = VehicleInspector.seeVehicle.isParking;end;
	if aTable.view and aTable.isGps then aTable.view = VehicleInspector.seeVehicle.isGps;end;
	
	local hashFillLevel = false;
	if aTable.view and #aTable.fillLevelInformation > 0 then
		for a=1, #aTable.fillLevelInformation do
			if aTable.fillLevelInformation[a] ~= nil and aTable.fillLevelInformation[a].tool == nil then
				local tempHashFillLevel = viOutput:hashFillLevel(aTable.fillLevelInformation[a]);
				if tempHashFillLevel then hashFillLevel = true;end; 				
			end;
		end;
	end;
	if aTable.view and not VehicleInspector.seeVehicle.notFillLevel and not hashFillLevel then aTable.view = false;end; 
	if aTable.isHelper and (not aTable.isPlayer and not aTable.isOtherPlayer) then aTable.view = VehicleInspector.seeVehicle.isHelper;end;
	if not aTable.isHelper and (aTable.isPlayer or aTable.isOtherPlayer) then aTable.view = VehicleInspector.seeVehicle.isPlayer;end;	
end;

function viOutput:hashFillLevel(aTable)
	if aTable == nil then return false;end;
	return (aTable.fillLevel ~= nil and aTable.fillLevel > 0) or (aTable.numObject ~= nil and aTable.numObject > 0);
end;

function viSetGet:sortByCategory(aTable)
	if VehicleInspector.global.sortBy == 0 then return;end;
	if aTable ~= nil then
		function comp(w1,w2)			
			return w1.sortCategory and not w2.sortCategory;
		end;	
		table.sort(aTable, comp);
	end;
end;





















